// Compiled by ClojureScript 1.10.238 {}
goog.provide('cljs.core.async');
goog.require('cljs.core');
goog.require('cljs.core.async.impl.protocols');
goog.require('cljs.core.async.impl.channels');
goog.require('cljs.core.async.impl.buffers');
goog.require('cljs.core.async.impl.timers');
goog.require('cljs.core.async.impl.dispatch');
goog.require('cljs.core.async.impl.ioc_helpers');
cljs.core.async.fn_handler = (function cljs$core$async$fn_handler(var_args){
var G__3874 = arguments.length;
switch (G__3874) {
case 1:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$1 = (function (f){
return cljs.core.async.fn_handler.call(null,f,true);
});

cljs.core.async.fn_handler.cljs$core$IFn$_invoke$arity$2 = (function (f,blockable){
if(typeof cljs.core.async.t_cljs$core$async3875 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3875 = (function (f,blockable,meta3876){
this.f = f;
this.blockable = blockable;
this.meta3876 = meta3876;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3875.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_3877,meta3876__$1){
var self__ = this;
var _3877__$1 = this;
return (new cljs.core.async.t_cljs$core$async3875(self__.f,self__.blockable,meta3876__$1));
});

cljs.core.async.t_cljs$core$async3875.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_3877){
var self__ = this;
var _3877__$1 = this;
return self__.meta3876;
});

cljs.core.async.t_cljs$core$async3875.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3875.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async3875.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.blockable;
});

cljs.core.async.t_cljs$core$async3875.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return self__.f;
});

cljs.core.async.t_cljs$core$async3875.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"blockable","blockable",-28395259,null),new cljs.core.Symbol(null,"meta3876","meta3876",1987988075,null)], null);
});

cljs.core.async.t_cljs$core$async3875.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3875.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3875";

cljs.core.async.t_cljs$core$async3875.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async3875");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3875.
 */
cljs.core.async.__GT_t_cljs$core$async3875 = (function cljs$core$async$__GT_t_cljs$core$async3875(f__$1,blockable__$1,meta3876){
return (new cljs.core.async.t_cljs$core$async3875(f__$1,blockable__$1,meta3876));
});

}

return (new cljs.core.async.t_cljs$core$async3875(f,blockable,cljs.core.PersistentArrayMap.EMPTY));
});

cljs.core.async.fn_handler.cljs$lang$maxFixedArity = 2;

/**
 * Returns a fixed buffer of size n. When full, puts will block/park.
 */
cljs.core.async.buffer = (function cljs$core$async$buffer(n){
return cljs.core.async.impl.buffers.fixed_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete but
 *   val will be dropped (no transfer).
 */
cljs.core.async.dropping_buffer = (function cljs$core$async$dropping_buffer(n){
return cljs.core.async.impl.buffers.dropping_buffer.call(null,n);
});
/**
 * Returns a buffer of size n. When full, puts will complete, and be
 *   buffered, but oldest elements in buffer will be dropped (not
 *   transferred).
 */
cljs.core.async.sliding_buffer = (function cljs$core$async$sliding_buffer(n){
return cljs.core.async.impl.buffers.sliding_buffer.call(null,n);
});
/**
 * Returns true if a channel created with buff will never block. That is to say,
 * puts into this buffer will never cause the buffer to be full. 
 */
cljs.core.async.unblocking_buffer_QMARK_ = (function cljs$core$async$unblocking_buffer_QMARK_(buff){
if(!((buff == null))){
if(((false) || ((cljs.core.PROTOCOL_SENTINEL === buff.cljs$core$async$impl$protocols$UnblockingBuffer$)))){
return true;
} else {
if((!buff.cljs$lang$protocol_mask$partition$)){
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
} else {
return false;
}
}
} else {
return cljs.core.native_satisfies_QMARK_.call(null,cljs.core.async.impl.protocols.UnblockingBuffer,buff);
}
});
/**
 * Creates a channel with an optional buffer, an optional transducer (like (map f),
 *   (filter p) etc or a composition thereof), and an optional exception handler.
 *   If buf-or-n is a number, will create and use a fixed buffer of that size. If a
 *   transducer is supplied a buffer must be specified. ex-handler must be a
 *   fn of one argument - if an exception occurs during transformation it will be called
 *   with the thrown value as an argument, and any non-nil return value will be placed
 *   in the channel.
 */
cljs.core.async.chan = (function cljs$core$async$chan(var_args){
var G__3881 = arguments.length;
switch (G__3881) {
case 0:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.chan.call(null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$1 = (function (buf_or_n){
return cljs.core.async.chan.call(null,buf_or_n,null,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$2 = (function (buf_or_n,xform){
return cljs.core.async.chan.call(null,buf_or_n,xform,null);
});

cljs.core.async.chan.cljs$core$IFn$_invoke$arity$3 = (function (buf_or_n,xform,ex_handler){
var buf_or_n__$1 = ((cljs.core._EQ_.call(null,buf_or_n,(0)))?null:buf_or_n);
if(cljs.core.truth_(xform)){
if(cljs.core.truth_(buf_or_n__$1)){
} else {
throw (new Error(["Assert failed: ","buffer must be supplied when transducer is","\n","buf-or-n"].join('')));
}
} else {
}

return cljs.core.async.impl.channels.chan.call(null,((typeof buf_or_n__$1 === 'number')?cljs.core.async.buffer.call(null,buf_or_n__$1):buf_or_n__$1),xform,ex_handler);
});

cljs.core.async.chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates a promise channel with an optional transducer, and an optional
 *   exception-handler. A promise channel can take exactly one value that consumers
 *   will receive. Once full, puts complete but val is dropped (no transfer).
 *   Consumers will block until either a value is placed in the channel or the
 *   channel is closed. See chan for the semantics of xform and ex-handler.
 */
cljs.core.async.promise_chan = (function cljs$core$async$promise_chan(var_args){
var G__3884 = arguments.length;
switch (G__3884) {
case 0:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0();

break;
case 1:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$0 = (function (){
return cljs.core.async.promise_chan.call(null,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$1 = (function (xform){
return cljs.core.async.promise_chan.call(null,xform,null);
});

cljs.core.async.promise_chan.cljs$core$IFn$_invoke$arity$2 = (function (xform,ex_handler){
return cljs.core.async.chan.call(null,cljs.core.async.impl.buffers.promise_buffer.call(null),xform,ex_handler);
});

cljs.core.async.promise_chan.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel that will close after msecs
 */
cljs.core.async.timeout = (function cljs$core$async$timeout(msecs){
return cljs.core.async.impl.timers.timeout.call(null,msecs);
});
/**
 * takes a val from port. Must be called inside a (go ...) block. Will
 *   return nil if closed. Will park if nothing is available.
 *   Returns true unless port is already closed
 */
cljs.core.async._LT__BANG_ = (function cljs$core$async$_LT__BANG_(port){
throw (new Error("<! used not in (go ...) block"));
});
/**
 * Asynchronously takes a val from port, passing to fn1. Will pass nil
 * if closed. If on-caller? (default true) is true, and value is
 * immediately available, will call fn1 on calling thread.
 * Returns nil.
 */
cljs.core.async.take_BANG_ = (function cljs$core$async$take_BANG_(var_args){
var G__3887 = arguments.length;
switch (G__3887) {
case 2:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,fn1){
return cljs.core.async.take_BANG_.call(null,port,fn1,true);
});

cljs.core.async.take_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,fn1,on_caller_QMARK_){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(ret)){
var val_3889 = cljs.core.deref.call(null,ret);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,val_3889);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (val_3889,ret){
return (function (){
return fn1.call(null,val_3889);
});})(val_3889,ret))
);
}
} else {
}

return null;
});

cljs.core.async.take_BANG_.cljs$lang$maxFixedArity = 3;

cljs.core.async.nop = (function cljs$core$async$nop(_){
return null;
});
cljs.core.async.fhnop = cljs.core.async.fn_handler.call(null,cljs.core.async.nop);
/**
 * puts a val into port. nil values are not allowed. Must be called
 *   inside a (go ...) block. Will park if no buffer space is available.
 *   Returns true unless port is already closed.
 */
cljs.core.async._GT__BANG_ = (function cljs$core$async$_GT__BANG_(port,val){
throw (new Error(">! used not in (go ...) block"));
});
/**
 * Asynchronously puts a val into port, calling fn0 (if supplied) when
 * complete. nil values are not allowed. Will throw if closed. If
 * on-caller? (default true) is true, and the put is immediately
 * accepted, will call fn0 on calling thread.  Returns nil.
 */
cljs.core.async.put_BANG_ = (function cljs$core$async$put_BANG_(var_args){
var G__3891 = arguments.length;
switch (G__3891) {
case 2:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$2 = (function (port,val){
var temp__5455__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fhnop);
if(cljs.core.truth_(temp__5455__auto__)){
var ret = temp__5455__auto__;
return cljs.core.deref.call(null,ret);
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$3 = (function (port,val,fn1){
return cljs.core.async.put_BANG_.call(null,port,val,fn1,true);
});

cljs.core.async.put_BANG_.cljs$core$IFn$_invoke$arity$4 = (function (port,val,fn1,on_caller_QMARK_){
var temp__5455__auto__ = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,fn1));
if(cljs.core.truth_(temp__5455__auto__)){
var retb = temp__5455__auto__;
var ret = cljs.core.deref.call(null,retb);
if(cljs.core.truth_(on_caller_QMARK_)){
fn1.call(null,ret);
} else {
cljs.core.async.impl.dispatch.run.call(null,((function (ret,retb,temp__5455__auto__){
return (function (){
return fn1.call(null,ret);
});})(ret,retb,temp__5455__auto__))
);
}

return ret;
} else {
return true;
}
});

cljs.core.async.put_BANG_.cljs$lang$maxFixedArity = 4;

cljs.core.async.close_BANG_ = (function cljs$core$async$close_BANG_(port){
return cljs.core.async.impl.protocols.close_BANG_.call(null,port);
});
cljs.core.async.random_array = (function cljs$core$async$random_array(n){
var a = (new Array(n));
var n__4376__auto___3893 = n;
var x_3894 = (0);
while(true){
if((x_3894 < n__4376__auto___3893)){
(a[x_3894] = (0));

var G__3895 = (x_3894 + (1));
x_3894 = G__3895;
continue;
} else {
}
break;
}

var i = (1);
while(true){
if(cljs.core._EQ_.call(null,i,n)){
return a;
} else {
var j = cljs.core.rand_int.call(null,i);
(a[i] = (a[j]));

(a[j] = i);

var G__3896 = (i + (1));
i = G__3896;
continue;
}
break;
}
});
cljs.core.async.alt_flag = (function cljs$core$async$alt_flag(){
var flag = cljs.core.atom.call(null,true);
if(typeof cljs.core.async.t_cljs$core$async3897 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3897 = (function (flag,meta3898){
this.flag = flag;
this.meta3898 = meta3898;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3897.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (flag){
return (function (_3899,meta3898__$1){
var self__ = this;
var _3899__$1 = this;
return (new cljs.core.async.t_cljs$core$async3897(self__.flag,meta3898__$1));
});})(flag))
;

cljs.core.async.t_cljs$core$async3897.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (flag){
return (function (_3899){
var self__ = this;
var _3899__$1 = this;
return self__.meta3898;
});})(flag))
;

cljs.core.async.t_cljs$core$async3897.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3897.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.deref.call(null,self__.flag);
});})(flag))
;

cljs.core.async.t_cljs$core$async3897.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async3897.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (flag){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.flag,null);

return true;
});})(flag))
;

cljs.core.async.t_cljs$core$async3897.getBasis = ((function (flag){
return (function (){
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"meta3898","meta3898",2144208347,null)], null);
});})(flag))
;

cljs.core.async.t_cljs$core$async3897.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3897.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3897";

cljs.core.async.t_cljs$core$async3897.cljs$lang$ctorPrWriter = ((function (flag){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async3897");
});})(flag))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3897.
 */
cljs.core.async.__GT_t_cljs$core$async3897 = ((function (flag){
return (function cljs$core$async$alt_flag_$___GT_t_cljs$core$async3897(flag__$1,meta3898){
return (new cljs.core.async.t_cljs$core$async3897(flag__$1,meta3898));
});})(flag))
;

}

return (new cljs.core.async.t_cljs$core$async3897(flag,cljs.core.PersistentArrayMap.EMPTY));
});
cljs.core.async.alt_handler = (function cljs$core$async$alt_handler(flag,cb){
if(typeof cljs.core.async.t_cljs$core$async3900 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async3900 = (function (flag,cb,meta3901){
this.flag = flag;
this.cb = cb;
this.meta3901 = meta3901;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async3900.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_3902,meta3901__$1){
var self__ = this;
var _3902__$1 = this;
return (new cljs.core.async.t_cljs$core$async3900(self__.flag,self__.cb,meta3901__$1));
});

cljs.core.async.t_cljs$core$async3900.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_3902){
var self__ = this;
var _3902__$1 = this;
return self__.meta3901;
});

cljs.core.async.t_cljs$core$async3900.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async3900.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.flag);
});

cljs.core.async.t_cljs$core$async3900.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return true;
});

cljs.core.async.t_cljs$core$async3900.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.async.impl.protocols.commit.call(null,self__.flag);

return self__.cb;
});

cljs.core.async.t_cljs$core$async3900.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"flag","flag",-1565787888,null),new cljs.core.Symbol(null,"cb","cb",-2064487928,null),new cljs.core.Symbol(null,"meta3901","meta3901",2083005359,null)], null);
});

cljs.core.async.t_cljs$core$async3900.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async3900.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async3900";

cljs.core.async.t_cljs$core$async3900.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async3900");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async3900.
 */
cljs.core.async.__GT_t_cljs$core$async3900 = (function cljs$core$async$alt_handler_$___GT_t_cljs$core$async3900(flag__$1,cb__$1,meta3901){
return (new cljs.core.async.t_cljs$core$async3900(flag__$1,cb__$1,meta3901));
});

}

return (new cljs.core.async.t_cljs$core$async3900(flag,cb,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * returns derefable [val port] if immediate, nil if enqueued
 */
cljs.core.async.do_alts = (function cljs$core$async$do_alts(fret,ports,opts){
var flag = cljs.core.async.alt_flag.call(null);
var n = cljs.core.count.call(null,ports);
var idxs = cljs.core.async.random_array.call(null,n);
var priority = new cljs.core.Keyword(null,"priority","priority",1431093715).cljs$core$IFn$_invoke$arity$1(opts);
var ret = (function (){var i = (0);
while(true){
if((i < n)){
var idx = (cljs.core.truth_(priority)?i:(idxs[i]));
var port = cljs.core.nth.call(null,ports,idx);
var wport = ((cljs.core.vector_QMARK_.call(null,port))?port.call(null,(0)):null);
var vbox = (cljs.core.truth_(wport)?(function (){var val = port.call(null,(1));
return cljs.core.async.impl.protocols.put_BANG_.call(null,wport,val,cljs.core.async.alt_handler.call(null,flag,((function (i,val,idx,port,wport,flag,n,idxs,priority){
return (function (p1__3903_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__3903_SHARP_,wport], null));
});})(i,val,idx,port,wport,flag,n,idxs,priority))
));
})():cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.alt_handler.call(null,flag,((function (i,idx,port,wport,flag,n,idxs,priority){
return (function (p1__3904_SHARP_){
return fret.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [p1__3904_SHARP_,port], null));
});})(i,idx,port,wport,flag,n,idxs,priority))
)));
if(cljs.core.truth_(vbox)){
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [cljs.core.deref.call(null,vbox),(function (){var or__3922__auto__ = wport;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return port;
}
})()], null));
} else {
var G__3905 = (i + (1));
i = G__3905;
continue;
}
} else {
return null;
}
break;
}
})();
var or__3922__auto__ = ret;
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
if(cljs.core.contains_QMARK_.call(null,opts,new cljs.core.Keyword(null,"default","default",-1987822328))){
var temp__5457__auto__ = (function (){var and__3911__auto__ = cljs.core.async.impl.protocols.active_QMARK_.call(null,flag);
if(cljs.core.truth_(and__3911__auto__)){
return cljs.core.async.impl.protocols.commit.call(null,flag);
} else {
return and__3911__auto__;
}
})();
if(cljs.core.truth_(temp__5457__auto__)){
var got = temp__5457__auto__;
return cljs.core.async.impl.channels.box.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"default","default",-1987822328).cljs$core$IFn$_invoke$arity$1(opts),new cljs.core.Keyword(null,"default","default",-1987822328)], null));
} else {
return null;
}
} else {
return null;
}
}
});
/**
 * Completes at most one of several channel operations. Must be called
 * inside a (go ...) block. ports is a vector of channel endpoints,
 * which can be either a channel to take from or a vector of
 *   [channel-to-put-to val-to-put], in any combination. Takes will be
 *   made as if by <!, and puts will be made as if by >!. Unless
 *   the :priority option is true, if more than one port operation is
 *   ready a non-deterministic choice will be made. If no operation is
 *   ready and a :default value is supplied, [default-val :default] will
 *   be returned, otherwise alts! will park until the first operation to
 *   become ready completes. Returns [val port] of the completed
 *   operation, where val is the value taken for takes, and a
 *   boolean (true unless already closed, as per put!) for puts.
 * 
 *   opts are passed as :key val ... Supported options:
 * 
 *   :default val - the value to use if none of the operations are immediately ready
 *   :priority true - (default nil) when true, the operations will be tried in order.
 * 
 *   Note: there is no guarantee that the port exps or val exprs will be
 *   used, nor in what order should they be, so they should not be
 *   depended upon for side effects.
 */
cljs.core.async.alts_BANG_ = (function cljs$core$async$alts_BANG_(var_args){
var args__4502__auto__ = [];
var len__4499__auto___3911 = arguments.length;
var i__4500__auto___3912 = (0);
while(true){
if((i__4500__auto___3912 < len__4499__auto___3911)){
args__4502__auto__.push((arguments[i__4500__auto___3912]));

var G__3913 = (i__4500__auto___3912 + (1));
i__4500__auto___3912 = G__3913;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((1) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((1)),(0),null)):null);
return cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),argseq__4503__auto__);
});

cljs.core.async.alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (ports,p__3908){
var map__3909 = p__3908;
var map__3909__$1 = ((((!((map__3909 == null)))?(((((map__3909.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__3909.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__3909):map__3909);
var opts = map__3909__$1;
throw (new Error("alts! used not in (go ...) block"));
});

cljs.core.async.alts_BANG_.cljs$lang$maxFixedArity = (1);

/** @this {Function} */
cljs.core.async.alts_BANG_.cljs$lang$applyTo = (function (seq3906){
var G__3907 = cljs.core.first.call(null,seq3906);
var seq3906__$1 = cljs.core.next.call(null,seq3906);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__3907,seq3906__$1);
});

/**
 * Puts a val into port if it's possible to do so immediately.
 *   nil values are not allowed. Never blocks. Returns true if offer succeeds.
 */
cljs.core.async.offer_BANG_ = (function cljs$core$async$offer_BANG_(port,val){
var ret = cljs.core.async.impl.protocols.put_BANG_.call(null,port,val,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes a val from port if it's possible to do so immediately.
 *   Never blocks. Returns value if successful, nil otherwise.
 */
cljs.core.async.poll_BANG_ = (function cljs$core$async$poll_BANG_(port){
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,port,cljs.core.async.fn_handler.call(null,cljs.core.async.nop,false));
if(cljs.core.truth_(ret)){
return cljs.core.deref.call(null,ret);
} else {
return null;
}
});
/**
 * Takes elements from the from channel and supplies them to the to
 * channel. By default, the to channel will be closed when the from
 * channel closes, but can be determined by the close?  parameter. Will
 * stop consuming the from channel if the to channel closes
 */
cljs.core.async.pipe = (function cljs$core$async$pipe(var_args){
var G__3915 = arguments.length;
switch (G__3915) {
case 2:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$2 = (function (from,to){
return cljs.core.async.pipe.call(null,from,to,true);
});

cljs.core.async.pipe.cljs$core$IFn$_invoke$arity$3 = (function (from,to,close_QMARK_){
var c__3814__auto___3961 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___3961){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___3961){
return (function (state_3939){
var state_val_3940 = (state_3939[(1)]);
if((state_val_3940 === (7))){
var inst_3935 = (state_3939[(2)]);
var state_3939__$1 = state_3939;
var statearr_3941_3962 = state_3939__$1;
(statearr_3941_3962[(2)] = inst_3935);

(statearr_3941_3962[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (1))){
var state_3939__$1 = state_3939;
var statearr_3942_3963 = state_3939__$1;
(statearr_3942_3963[(2)] = null);

(statearr_3942_3963[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (4))){
var inst_3918 = (state_3939[(7)]);
var inst_3918__$1 = (state_3939[(2)]);
var inst_3919 = (inst_3918__$1 == null);
var state_3939__$1 = (function (){var statearr_3943 = state_3939;
(statearr_3943[(7)] = inst_3918__$1);

return statearr_3943;
})();
if(cljs.core.truth_(inst_3919)){
var statearr_3944_3964 = state_3939__$1;
(statearr_3944_3964[(1)] = (5));

} else {
var statearr_3945_3965 = state_3939__$1;
(statearr_3945_3965[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (13))){
var state_3939__$1 = state_3939;
var statearr_3946_3966 = state_3939__$1;
(statearr_3946_3966[(2)] = null);

(statearr_3946_3966[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (6))){
var inst_3918 = (state_3939[(7)]);
var state_3939__$1 = state_3939;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3939__$1,(11),to,inst_3918);
} else {
if((state_val_3940 === (3))){
var inst_3937 = (state_3939[(2)]);
var state_3939__$1 = state_3939;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3939__$1,inst_3937);
} else {
if((state_val_3940 === (12))){
var state_3939__$1 = state_3939;
var statearr_3947_3967 = state_3939__$1;
(statearr_3947_3967[(2)] = null);

(statearr_3947_3967[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (2))){
var state_3939__$1 = state_3939;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_3939__$1,(4),from);
} else {
if((state_val_3940 === (11))){
var inst_3928 = (state_3939[(2)]);
var state_3939__$1 = state_3939;
if(cljs.core.truth_(inst_3928)){
var statearr_3948_3968 = state_3939__$1;
(statearr_3948_3968[(1)] = (12));

} else {
var statearr_3949_3969 = state_3939__$1;
(statearr_3949_3969[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (9))){
var state_3939__$1 = state_3939;
var statearr_3950_3970 = state_3939__$1;
(statearr_3950_3970[(2)] = null);

(statearr_3950_3970[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (5))){
var state_3939__$1 = state_3939;
if(cljs.core.truth_(close_QMARK_)){
var statearr_3951_3971 = state_3939__$1;
(statearr_3951_3971[(1)] = (8));

} else {
var statearr_3952_3972 = state_3939__$1;
(statearr_3952_3972[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (14))){
var inst_3933 = (state_3939[(2)]);
var state_3939__$1 = state_3939;
var statearr_3953_3973 = state_3939__$1;
(statearr_3953_3973[(2)] = inst_3933);

(statearr_3953_3973[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (10))){
var inst_3925 = (state_3939[(2)]);
var state_3939__$1 = state_3939;
var statearr_3954_3974 = state_3939__$1;
(statearr_3954_3974[(2)] = inst_3925);

(statearr_3954_3974[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_3940 === (8))){
var inst_3922 = cljs.core.async.close_BANG_.call(null,to);
var state_3939__$1 = state_3939;
var statearr_3955_3975 = state_3939__$1;
(statearr_3955_3975[(2)] = inst_3922);

(statearr_3955_3975[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___3961))
;
return ((function (switch__3724__auto__,c__3814__auto___3961){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_3956 = [null,null,null,null,null,null,null,null];
(statearr_3956[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_3956[(1)] = (1));

return statearr_3956;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_3939){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_3939);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e3957){if((e3957 instanceof Object)){
var ex__3728__auto__ = e3957;
var statearr_3958_3976 = state_3939;
(statearr_3958_3976[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3939);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3957;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__3977 = state_3939;
state_3939 = G__3977;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_3939){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_3939);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___3961))
})();
var state__3816__auto__ = (function (){var statearr_3959 = f__3815__auto__.call(null);
(statearr_3959[(6)] = c__3814__auto___3961);

return statearr_3959;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___3961))
);


return to;
});

cljs.core.async.pipe.cljs$lang$maxFixedArity = 3;

cljs.core.async.pipeline_STAR_ = (function cljs$core$async$pipeline_STAR_(n,to,xf,from,close_QMARK_,ex_handler,type){
if((n > (0))){
} else {
throw (new Error("Assert failed: (pos? n)"));
}

var jobs = cljs.core.async.chan.call(null,n);
var results = cljs.core.async.chan.call(null,n);
var process = ((function (jobs,results){
return (function (p__3978){
var vec__3979 = p__3978;
var v = cljs.core.nth.call(null,vec__3979,(0),null);
var p = cljs.core.nth.call(null,vec__3979,(1),null);
var job = vec__3979;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1),xf,ex_handler);
var c__3814__auto___4150 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___4150,res,vec__3979,v,p,job,jobs,results){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___4150,res,vec__3979,v,p,job,jobs,results){
return (function (state_3986){
var state_val_3987 = (state_3986[(1)]);
if((state_val_3987 === (1))){
var state_3986__$1 = state_3986;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_3986__$1,(2),res,v);
} else {
if((state_val_3987 === (2))){
var inst_3983 = (state_3986[(2)]);
var inst_3984 = cljs.core.async.close_BANG_.call(null,res);
var state_3986__$1 = (function (){var statearr_3988 = state_3986;
(statearr_3988[(7)] = inst_3983);

return statearr_3988;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_3986__$1,inst_3984);
} else {
return null;
}
}
});})(c__3814__auto___4150,res,vec__3979,v,p,job,jobs,results))
;
return ((function (switch__3724__auto__,c__3814__auto___4150,res,vec__3979,v,p,job,jobs,results){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0 = (function (){
var statearr_3989 = [null,null,null,null,null,null,null,null];
(statearr_3989[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__);

(statearr_3989[(1)] = (1));

return statearr_3989;
});
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1 = (function (state_3986){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_3986);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e3990){if((e3990 instanceof Object)){
var ex__3728__auto__ = e3990;
var statearr_3991_4151 = state_3986;
(statearr_3991_4151[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_3986);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e3990;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4152 = state_3986;
state_3986 = G__4152;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = function(state_3986){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1.call(this,state_3986);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___4150,res,vec__3979,v,p,job,jobs,results))
})();
var state__3816__auto__ = (function (){var statearr_3992 = f__3815__auto__.call(null);
(statearr_3992[(6)] = c__3814__auto___4150);

return statearr_3992;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___4150,res,vec__3979,v,p,job,jobs,results))
);


cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results))
;
var async = ((function (jobs,results,process){
return (function (p__3993){
var vec__3994 = p__3993;
var v = cljs.core.nth.call(null,vec__3994,(0),null);
var p = cljs.core.nth.call(null,vec__3994,(1),null);
var job = vec__3994;
if((job == null)){
cljs.core.async.close_BANG_.call(null,results);

return null;
} else {
var res = cljs.core.async.chan.call(null,(1));
xf.call(null,v,res);

cljs.core.async.put_BANG_.call(null,p,res);

return true;
}
});})(jobs,results,process))
;
var n__4376__auto___4153 = n;
var __4154 = (0);
while(true){
if((__4154 < n__4376__auto___4153)){
var G__3997_4155 = type;
var G__3997_4156__$1 = (((G__3997_4155 instanceof cljs.core.Keyword))?G__3997_4155.fqn:null);
switch (G__3997_4156__$1) {
case "compute":
var c__3814__auto___4158 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__4154,c__3814__auto___4158,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (__4154,c__3814__auto___4158,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async){
return (function (state_4010){
var state_val_4011 = (state_4010[(1)]);
if((state_val_4011 === (1))){
var state_4010__$1 = state_4010;
var statearr_4012_4159 = state_4010__$1;
(statearr_4012_4159[(2)] = null);

(statearr_4012_4159[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4011 === (2))){
var state_4010__$1 = state_4010;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4010__$1,(4),jobs);
} else {
if((state_val_4011 === (3))){
var inst_4008 = (state_4010[(2)]);
var state_4010__$1 = state_4010;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4010__$1,inst_4008);
} else {
if((state_val_4011 === (4))){
var inst_4000 = (state_4010[(2)]);
var inst_4001 = process.call(null,inst_4000);
var state_4010__$1 = state_4010;
if(cljs.core.truth_(inst_4001)){
var statearr_4013_4160 = state_4010__$1;
(statearr_4013_4160[(1)] = (5));

} else {
var statearr_4014_4161 = state_4010__$1;
(statearr_4014_4161[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4011 === (5))){
var state_4010__$1 = state_4010;
var statearr_4015_4162 = state_4010__$1;
(statearr_4015_4162[(2)] = null);

(statearr_4015_4162[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4011 === (6))){
var state_4010__$1 = state_4010;
var statearr_4016_4163 = state_4010__$1;
(statearr_4016_4163[(2)] = null);

(statearr_4016_4163[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4011 === (7))){
var inst_4006 = (state_4010[(2)]);
var state_4010__$1 = state_4010;
var statearr_4017_4164 = state_4010__$1;
(statearr_4017_4164[(2)] = inst_4006);

(statearr_4017_4164[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__4154,c__3814__auto___4158,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async))
;
return ((function (__4154,switch__3724__auto__,c__3814__auto___4158,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0 = (function (){
var statearr_4018 = [null,null,null,null,null,null,null];
(statearr_4018[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__);

(statearr_4018[(1)] = (1));

return statearr_4018;
});
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1 = (function (state_4010){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4010);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4019){if((e4019 instanceof Object)){
var ex__3728__auto__ = e4019;
var statearr_4020_4165 = state_4010;
(statearr_4020_4165[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4010);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4019;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4166 = state_4010;
state_4010 = G__4166;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = function(state_4010){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1.call(this,state_4010);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__;
})()
;})(__4154,switch__3724__auto__,c__3814__auto___4158,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async))
})();
var state__3816__auto__ = (function (){var statearr_4021 = f__3815__auto__.call(null);
(statearr_4021[(6)] = c__3814__auto___4158);

return statearr_4021;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(__4154,c__3814__auto___4158,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async))
);


break;
case "async":
var c__3814__auto___4167 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (__4154,c__3814__auto___4167,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (__4154,c__3814__auto___4167,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async){
return (function (state_4034){
var state_val_4035 = (state_4034[(1)]);
if((state_val_4035 === (1))){
var state_4034__$1 = state_4034;
var statearr_4036_4168 = state_4034__$1;
(statearr_4036_4168[(2)] = null);

(statearr_4036_4168[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4035 === (2))){
var state_4034__$1 = state_4034;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4034__$1,(4),jobs);
} else {
if((state_val_4035 === (3))){
var inst_4032 = (state_4034[(2)]);
var state_4034__$1 = state_4034;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4034__$1,inst_4032);
} else {
if((state_val_4035 === (4))){
var inst_4024 = (state_4034[(2)]);
var inst_4025 = async.call(null,inst_4024);
var state_4034__$1 = state_4034;
if(cljs.core.truth_(inst_4025)){
var statearr_4037_4169 = state_4034__$1;
(statearr_4037_4169[(1)] = (5));

} else {
var statearr_4038_4170 = state_4034__$1;
(statearr_4038_4170[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4035 === (5))){
var state_4034__$1 = state_4034;
var statearr_4039_4171 = state_4034__$1;
(statearr_4039_4171[(2)] = null);

(statearr_4039_4171[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4035 === (6))){
var state_4034__$1 = state_4034;
var statearr_4040_4172 = state_4034__$1;
(statearr_4040_4172[(2)] = null);

(statearr_4040_4172[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4035 === (7))){
var inst_4030 = (state_4034[(2)]);
var state_4034__$1 = state_4034;
var statearr_4041_4173 = state_4034__$1;
(statearr_4041_4173[(2)] = inst_4030);

(statearr_4041_4173[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
});})(__4154,c__3814__auto___4167,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async))
;
return ((function (__4154,switch__3724__auto__,c__3814__auto___4167,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0 = (function (){
var statearr_4042 = [null,null,null,null,null,null,null];
(statearr_4042[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__);

(statearr_4042[(1)] = (1));

return statearr_4042;
});
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1 = (function (state_4034){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4034);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4043){if((e4043 instanceof Object)){
var ex__3728__auto__ = e4043;
var statearr_4044_4174 = state_4034;
(statearr_4044_4174[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4034);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4043;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4175 = state_4034;
state_4034 = G__4175;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = function(state_4034){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1.call(this,state_4034);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__;
})()
;})(__4154,switch__3724__auto__,c__3814__auto___4167,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async))
})();
var state__3816__auto__ = (function (){var statearr_4045 = f__3815__auto__.call(null);
(statearr_4045[(6)] = c__3814__auto___4167);

return statearr_4045;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(__4154,c__3814__auto___4167,G__3997_4155,G__3997_4156__$1,n__4376__auto___4153,jobs,results,process,async))
);


break;
default:
throw (new Error(["No matching clause: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(G__3997_4156__$1)].join('')));

}

var G__4176 = (__4154 + (1));
__4154 = G__4176;
continue;
} else {
}
break;
}

var c__3814__auto___4177 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___4177,jobs,results,process,async){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___4177,jobs,results,process,async){
return (function (state_4067){
var state_val_4068 = (state_4067[(1)]);
if((state_val_4068 === (1))){
var state_4067__$1 = state_4067;
var statearr_4069_4178 = state_4067__$1;
(statearr_4069_4178[(2)] = null);

(statearr_4069_4178[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4068 === (2))){
var state_4067__$1 = state_4067;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4067__$1,(4),from);
} else {
if((state_val_4068 === (3))){
var inst_4065 = (state_4067[(2)]);
var state_4067__$1 = state_4067;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4067__$1,inst_4065);
} else {
if((state_val_4068 === (4))){
var inst_4048 = (state_4067[(7)]);
var inst_4048__$1 = (state_4067[(2)]);
var inst_4049 = (inst_4048__$1 == null);
var state_4067__$1 = (function (){var statearr_4070 = state_4067;
(statearr_4070[(7)] = inst_4048__$1);

return statearr_4070;
})();
if(cljs.core.truth_(inst_4049)){
var statearr_4071_4179 = state_4067__$1;
(statearr_4071_4179[(1)] = (5));

} else {
var statearr_4072_4180 = state_4067__$1;
(statearr_4072_4180[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4068 === (5))){
var inst_4051 = cljs.core.async.close_BANG_.call(null,jobs);
var state_4067__$1 = state_4067;
var statearr_4073_4181 = state_4067__$1;
(statearr_4073_4181[(2)] = inst_4051);

(statearr_4073_4181[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4068 === (6))){
var inst_4048 = (state_4067[(7)]);
var inst_4053 = (state_4067[(8)]);
var inst_4053__$1 = cljs.core.async.chan.call(null,(1));
var inst_4054 = cljs.core.PersistentVector.EMPTY_NODE;
var inst_4055 = [inst_4048,inst_4053__$1];
var inst_4056 = (new cljs.core.PersistentVector(null,2,(5),inst_4054,inst_4055,null));
var state_4067__$1 = (function (){var statearr_4074 = state_4067;
(statearr_4074[(8)] = inst_4053__$1);

return statearr_4074;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4067__$1,(8),jobs,inst_4056);
} else {
if((state_val_4068 === (7))){
var inst_4063 = (state_4067[(2)]);
var state_4067__$1 = state_4067;
var statearr_4075_4182 = state_4067__$1;
(statearr_4075_4182[(2)] = inst_4063);

(statearr_4075_4182[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4068 === (8))){
var inst_4053 = (state_4067[(8)]);
var inst_4058 = (state_4067[(2)]);
var state_4067__$1 = (function (){var statearr_4076 = state_4067;
(statearr_4076[(9)] = inst_4058);

return statearr_4076;
})();
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4067__$1,(9),results,inst_4053);
} else {
if((state_val_4068 === (9))){
var inst_4060 = (state_4067[(2)]);
var state_4067__$1 = (function (){var statearr_4077 = state_4067;
(statearr_4077[(10)] = inst_4060);

return statearr_4077;
})();
var statearr_4078_4183 = state_4067__$1;
(statearr_4078_4183[(2)] = null);

(statearr_4078_4183[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___4177,jobs,results,process,async))
;
return ((function (switch__3724__auto__,c__3814__auto___4177,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0 = (function (){
var statearr_4079 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_4079[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__);

(statearr_4079[(1)] = (1));

return statearr_4079;
});
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1 = (function (state_4067){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4067);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4080){if((e4080 instanceof Object)){
var ex__3728__auto__ = e4080;
var statearr_4081_4184 = state_4067;
(statearr_4081_4184[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4067);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4080;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4185 = state_4067;
state_4067 = G__4185;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = function(state_4067){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1.call(this,state_4067);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___4177,jobs,results,process,async))
})();
var state__3816__auto__ = (function (){var statearr_4082 = f__3815__auto__.call(null);
(statearr_4082[(6)] = c__3814__auto___4177);

return statearr_4082;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___4177,jobs,results,process,async))
);


var c__3814__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto__,jobs,results,process,async){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto__,jobs,results,process,async){
return (function (state_4120){
var state_val_4121 = (state_4120[(1)]);
if((state_val_4121 === (7))){
var inst_4116 = (state_4120[(2)]);
var state_4120__$1 = state_4120;
var statearr_4122_4186 = state_4120__$1;
(statearr_4122_4186[(2)] = inst_4116);

(statearr_4122_4186[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (20))){
var state_4120__$1 = state_4120;
var statearr_4123_4187 = state_4120__$1;
(statearr_4123_4187[(2)] = null);

(statearr_4123_4187[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (1))){
var state_4120__$1 = state_4120;
var statearr_4124_4188 = state_4120__$1;
(statearr_4124_4188[(2)] = null);

(statearr_4124_4188[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (4))){
var inst_4085 = (state_4120[(7)]);
var inst_4085__$1 = (state_4120[(2)]);
var inst_4086 = (inst_4085__$1 == null);
var state_4120__$1 = (function (){var statearr_4125 = state_4120;
(statearr_4125[(7)] = inst_4085__$1);

return statearr_4125;
})();
if(cljs.core.truth_(inst_4086)){
var statearr_4126_4189 = state_4120__$1;
(statearr_4126_4189[(1)] = (5));

} else {
var statearr_4127_4190 = state_4120__$1;
(statearr_4127_4190[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (15))){
var inst_4098 = (state_4120[(8)]);
var state_4120__$1 = state_4120;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4120__$1,(18),to,inst_4098);
} else {
if((state_val_4121 === (21))){
var inst_4111 = (state_4120[(2)]);
var state_4120__$1 = state_4120;
var statearr_4128_4191 = state_4120__$1;
(statearr_4128_4191[(2)] = inst_4111);

(statearr_4128_4191[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (13))){
var inst_4113 = (state_4120[(2)]);
var state_4120__$1 = (function (){var statearr_4129 = state_4120;
(statearr_4129[(9)] = inst_4113);

return statearr_4129;
})();
var statearr_4130_4192 = state_4120__$1;
(statearr_4130_4192[(2)] = null);

(statearr_4130_4192[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (6))){
var inst_4085 = (state_4120[(7)]);
var state_4120__$1 = state_4120;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4120__$1,(11),inst_4085);
} else {
if((state_val_4121 === (17))){
var inst_4106 = (state_4120[(2)]);
var state_4120__$1 = state_4120;
if(cljs.core.truth_(inst_4106)){
var statearr_4131_4193 = state_4120__$1;
(statearr_4131_4193[(1)] = (19));

} else {
var statearr_4132_4194 = state_4120__$1;
(statearr_4132_4194[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (3))){
var inst_4118 = (state_4120[(2)]);
var state_4120__$1 = state_4120;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4120__$1,inst_4118);
} else {
if((state_val_4121 === (12))){
var inst_4095 = (state_4120[(10)]);
var state_4120__$1 = state_4120;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4120__$1,(14),inst_4095);
} else {
if((state_val_4121 === (2))){
var state_4120__$1 = state_4120;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4120__$1,(4),results);
} else {
if((state_val_4121 === (19))){
var state_4120__$1 = state_4120;
var statearr_4133_4195 = state_4120__$1;
(statearr_4133_4195[(2)] = null);

(statearr_4133_4195[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (11))){
var inst_4095 = (state_4120[(2)]);
var state_4120__$1 = (function (){var statearr_4134 = state_4120;
(statearr_4134[(10)] = inst_4095);

return statearr_4134;
})();
var statearr_4135_4196 = state_4120__$1;
(statearr_4135_4196[(2)] = null);

(statearr_4135_4196[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (9))){
var state_4120__$1 = state_4120;
var statearr_4136_4197 = state_4120__$1;
(statearr_4136_4197[(2)] = null);

(statearr_4136_4197[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (5))){
var state_4120__$1 = state_4120;
if(cljs.core.truth_(close_QMARK_)){
var statearr_4137_4198 = state_4120__$1;
(statearr_4137_4198[(1)] = (8));

} else {
var statearr_4138_4199 = state_4120__$1;
(statearr_4138_4199[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (14))){
var inst_4100 = (state_4120[(11)]);
var inst_4098 = (state_4120[(8)]);
var inst_4098__$1 = (state_4120[(2)]);
var inst_4099 = (inst_4098__$1 == null);
var inst_4100__$1 = cljs.core.not.call(null,inst_4099);
var state_4120__$1 = (function (){var statearr_4139 = state_4120;
(statearr_4139[(11)] = inst_4100__$1);

(statearr_4139[(8)] = inst_4098__$1);

return statearr_4139;
})();
if(inst_4100__$1){
var statearr_4140_4200 = state_4120__$1;
(statearr_4140_4200[(1)] = (15));

} else {
var statearr_4141_4201 = state_4120__$1;
(statearr_4141_4201[(1)] = (16));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (16))){
var inst_4100 = (state_4120[(11)]);
var state_4120__$1 = state_4120;
var statearr_4142_4202 = state_4120__$1;
(statearr_4142_4202[(2)] = inst_4100);

(statearr_4142_4202[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (10))){
var inst_4092 = (state_4120[(2)]);
var state_4120__$1 = state_4120;
var statearr_4143_4203 = state_4120__$1;
(statearr_4143_4203[(2)] = inst_4092);

(statearr_4143_4203[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (18))){
var inst_4103 = (state_4120[(2)]);
var state_4120__$1 = state_4120;
var statearr_4144_4204 = state_4120__$1;
(statearr_4144_4204[(2)] = inst_4103);

(statearr_4144_4204[(1)] = (17));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4121 === (8))){
var inst_4089 = cljs.core.async.close_BANG_.call(null,to);
var state_4120__$1 = state_4120;
var statearr_4145_4205 = state_4120__$1;
(statearr_4145_4205[(2)] = inst_4089);

(statearr_4145_4205[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto__,jobs,results,process,async))
;
return ((function (switch__3724__auto__,c__3814__auto__,jobs,results,process,async){
return (function() {
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = null;
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0 = (function (){
var statearr_4146 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4146[(0)] = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__);

(statearr_4146[(1)] = (1));

return statearr_4146;
});
var cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1 = (function (state_4120){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4120);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4147){if((e4147 instanceof Object)){
var ex__3728__auto__ = e4147;
var statearr_4148_4206 = state_4120;
(statearr_4148_4206[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4120);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4147;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4207 = state_4120;
state_4120 = G__4207;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__ = function(state_4120){
switch(arguments.length){
case 0:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1.call(this,state_4120);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____0;
cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$pipeline_STAR__$_state_machine__3725__auto____1;
return cljs$core$async$pipeline_STAR__$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto__,jobs,results,process,async))
})();
var state__3816__auto__ = (function (){var statearr_4149 = f__3815__auto__.call(null);
(statearr_4149[(6)] = c__3814__auto__);

return statearr_4149;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto__,jobs,results,process,async))
);

return c__3814__auto__;
});
/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the async function af, with parallelism n. af
 *   must be a function of two arguments, the first an input value and
 *   the second a channel on which to place the result(s). af must close!
 *   the channel before returning.  The presumption is that af will
 *   return immediately, having launched some asynchronous operation
 *   whose completion/callback will manipulate the result channel. Outputs
 *   will be returned in order relative to  the inputs. By default, the to
 *   channel will be closed when the from channel closes, but can be
 *   determined by the close?  parameter. Will stop consuming the from
 *   channel if the to channel closes.
 */
cljs.core.async.pipeline_async = (function cljs$core$async$pipeline_async(var_args){
var G__4209 = arguments.length;
switch (G__4209) {
case 4:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$4 = (function (n,to,af,from){
return cljs.core.async.pipeline_async.call(null,n,to,af,from,true);
});

cljs.core.async.pipeline_async.cljs$core$IFn$_invoke$arity$5 = (function (n,to,af,from,close_QMARK_){
return cljs.core.async.pipeline_STAR_.call(null,n,to,af,from,close_QMARK_,null,new cljs.core.Keyword(null,"async","async",1050769601));
});

cljs.core.async.pipeline_async.cljs$lang$maxFixedArity = 5;

/**
 * Takes elements from the from channel and supplies them to the to
 *   channel, subject to the transducer xf, with parallelism n. Because
 *   it is parallel, the transducer will be applied independently to each
 *   element, not across elements, and may produce zero or more outputs
 *   per input.  Outputs will be returned in order relative to the
 *   inputs. By default, the to channel will be closed when the from
 *   channel closes, but can be determined by the close?  parameter. Will
 *   stop consuming the from channel if the to channel closes.
 * 
 *   Note this is supplied for API compatibility with the Clojure version.
 *   Values of N > 1 will not result in actual concurrency in a
 *   single-threaded runtime.
 */
cljs.core.async.pipeline = (function cljs$core$async$pipeline(var_args){
var G__4212 = arguments.length;
switch (G__4212) {
case 4:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
case 5:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]));

break;
case 6:
return cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]),(arguments[(4)]),(arguments[(5)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$4 = (function (n,to,xf,from){
return cljs.core.async.pipeline.call(null,n,to,xf,from,true);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$5 = (function (n,to,xf,from,close_QMARK_){
return cljs.core.async.pipeline.call(null,n,to,xf,from,close_QMARK_,null);
});

cljs.core.async.pipeline.cljs$core$IFn$_invoke$arity$6 = (function (n,to,xf,from,close_QMARK_,ex_handler){
return cljs.core.async.pipeline_STAR_.call(null,n,to,xf,from,close_QMARK_,ex_handler,new cljs.core.Keyword(null,"compute","compute",1555393130));
});

cljs.core.async.pipeline.cljs$lang$maxFixedArity = 6;

/**
 * Takes a predicate and a source channel and returns a vector of two
 *   channels, the first of which will contain the values for which the
 *   predicate returned true, the second those for which it returned
 *   false.
 * 
 *   The out channels will be unbuffered by default, or two buf-or-ns can
 *   be supplied. The channels will close after the source channel has
 *   closed.
 */
cljs.core.async.split = (function cljs$core$async$split(var_args){
var G__4215 = arguments.length;
switch (G__4215) {
case 2:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 4:
return cljs.core.async.split.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.split.call(null,p,ch,null,null);
});

cljs.core.async.split.cljs$core$IFn$_invoke$arity$4 = (function (p,ch,t_buf_or_n,f_buf_or_n){
var tc = cljs.core.async.chan.call(null,t_buf_or_n);
var fc = cljs.core.async.chan.call(null,f_buf_or_n);
var c__3814__auto___4264 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___4264,tc,fc){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___4264,tc,fc){
return (function (state_4241){
var state_val_4242 = (state_4241[(1)]);
if((state_val_4242 === (7))){
var inst_4237 = (state_4241[(2)]);
var state_4241__$1 = state_4241;
var statearr_4243_4265 = state_4241__$1;
(statearr_4243_4265[(2)] = inst_4237);

(statearr_4243_4265[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (1))){
var state_4241__$1 = state_4241;
var statearr_4244_4266 = state_4241__$1;
(statearr_4244_4266[(2)] = null);

(statearr_4244_4266[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (4))){
var inst_4218 = (state_4241[(7)]);
var inst_4218__$1 = (state_4241[(2)]);
var inst_4219 = (inst_4218__$1 == null);
var state_4241__$1 = (function (){var statearr_4245 = state_4241;
(statearr_4245[(7)] = inst_4218__$1);

return statearr_4245;
})();
if(cljs.core.truth_(inst_4219)){
var statearr_4246_4267 = state_4241__$1;
(statearr_4246_4267[(1)] = (5));

} else {
var statearr_4247_4268 = state_4241__$1;
(statearr_4247_4268[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (13))){
var state_4241__$1 = state_4241;
var statearr_4248_4269 = state_4241__$1;
(statearr_4248_4269[(2)] = null);

(statearr_4248_4269[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (6))){
var inst_4218 = (state_4241[(7)]);
var inst_4224 = p.call(null,inst_4218);
var state_4241__$1 = state_4241;
if(cljs.core.truth_(inst_4224)){
var statearr_4249_4270 = state_4241__$1;
(statearr_4249_4270[(1)] = (9));

} else {
var statearr_4250_4271 = state_4241__$1;
(statearr_4250_4271[(1)] = (10));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (3))){
var inst_4239 = (state_4241[(2)]);
var state_4241__$1 = state_4241;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4241__$1,inst_4239);
} else {
if((state_val_4242 === (12))){
var state_4241__$1 = state_4241;
var statearr_4251_4272 = state_4241__$1;
(statearr_4251_4272[(2)] = null);

(statearr_4251_4272[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (2))){
var state_4241__$1 = state_4241;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4241__$1,(4),ch);
} else {
if((state_val_4242 === (11))){
var inst_4218 = (state_4241[(7)]);
var inst_4228 = (state_4241[(2)]);
var state_4241__$1 = state_4241;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4241__$1,(8),inst_4228,inst_4218);
} else {
if((state_val_4242 === (9))){
var state_4241__$1 = state_4241;
var statearr_4252_4273 = state_4241__$1;
(statearr_4252_4273[(2)] = tc);

(statearr_4252_4273[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (5))){
var inst_4221 = cljs.core.async.close_BANG_.call(null,tc);
var inst_4222 = cljs.core.async.close_BANG_.call(null,fc);
var state_4241__$1 = (function (){var statearr_4253 = state_4241;
(statearr_4253[(8)] = inst_4221);

return statearr_4253;
})();
var statearr_4254_4274 = state_4241__$1;
(statearr_4254_4274[(2)] = inst_4222);

(statearr_4254_4274[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (14))){
var inst_4235 = (state_4241[(2)]);
var state_4241__$1 = state_4241;
var statearr_4255_4275 = state_4241__$1;
(statearr_4255_4275[(2)] = inst_4235);

(statearr_4255_4275[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (10))){
var state_4241__$1 = state_4241;
var statearr_4256_4276 = state_4241__$1;
(statearr_4256_4276[(2)] = fc);

(statearr_4256_4276[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4242 === (8))){
var inst_4230 = (state_4241[(2)]);
var state_4241__$1 = state_4241;
if(cljs.core.truth_(inst_4230)){
var statearr_4257_4277 = state_4241__$1;
(statearr_4257_4277[(1)] = (12));

} else {
var statearr_4258_4278 = state_4241__$1;
(statearr_4258_4278[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___4264,tc,fc))
;
return ((function (switch__3724__auto__,c__3814__auto___4264,tc,fc){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_4259 = [null,null,null,null,null,null,null,null,null];
(statearr_4259[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_4259[(1)] = (1));

return statearr_4259;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_4241){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4241);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4260){if((e4260 instanceof Object)){
var ex__3728__auto__ = e4260;
var statearr_4261_4279 = state_4241;
(statearr_4261_4279[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4241);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4260;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4280 = state_4241;
state_4241 = G__4280;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_4241){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_4241);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___4264,tc,fc))
})();
var state__3816__auto__ = (function (){var statearr_4262 = f__3815__auto__.call(null);
(statearr_4262[(6)] = c__3814__auto___4264);

return statearr_4262;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___4264,tc,fc))
);


return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [tc,fc], null);
});

cljs.core.async.split.cljs$lang$maxFixedArity = 4;

/**
 * f should be a function of 2 arguments. Returns a channel containing
 *   the single result of applying f to init and the first item from the
 *   channel, then applying f to that result and the 2nd item, etc. If
 *   the channel closes without yielding items, returns init and f is not
 *   called. ch must close before reduce produces a result.
 */
cljs.core.async.reduce = (function cljs$core$async$reduce(f,init,ch){
var c__3814__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto__){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto__){
return (function (state_4301){
var state_val_4302 = (state_4301[(1)]);
if((state_val_4302 === (7))){
var inst_4297 = (state_4301[(2)]);
var state_4301__$1 = state_4301;
var statearr_4303_4321 = state_4301__$1;
(statearr_4303_4321[(2)] = inst_4297);

(statearr_4303_4321[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (1))){
var inst_4281 = init;
var state_4301__$1 = (function (){var statearr_4304 = state_4301;
(statearr_4304[(7)] = inst_4281);

return statearr_4304;
})();
var statearr_4305_4322 = state_4301__$1;
(statearr_4305_4322[(2)] = null);

(statearr_4305_4322[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (4))){
var inst_4284 = (state_4301[(8)]);
var inst_4284__$1 = (state_4301[(2)]);
var inst_4285 = (inst_4284__$1 == null);
var state_4301__$1 = (function (){var statearr_4306 = state_4301;
(statearr_4306[(8)] = inst_4284__$1);

return statearr_4306;
})();
if(cljs.core.truth_(inst_4285)){
var statearr_4307_4323 = state_4301__$1;
(statearr_4307_4323[(1)] = (5));

} else {
var statearr_4308_4324 = state_4301__$1;
(statearr_4308_4324[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (6))){
var inst_4284 = (state_4301[(8)]);
var inst_4281 = (state_4301[(7)]);
var inst_4288 = (state_4301[(9)]);
var inst_4288__$1 = f.call(null,inst_4281,inst_4284);
var inst_4289 = cljs.core.reduced_QMARK_.call(null,inst_4288__$1);
var state_4301__$1 = (function (){var statearr_4309 = state_4301;
(statearr_4309[(9)] = inst_4288__$1);

return statearr_4309;
})();
if(inst_4289){
var statearr_4310_4325 = state_4301__$1;
(statearr_4310_4325[(1)] = (8));

} else {
var statearr_4311_4326 = state_4301__$1;
(statearr_4311_4326[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (3))){
var inst_4299 = (state_4301[(2)]);
var state_4301__$1 = state_4301;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4301__$1,inst_4299);
} else {
if((state_val_4302 === (2))){
var state_4301__$1 = state_4301;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4301__$1,(4),ch);
} else {
if((state_val_4302 === (9))){
var inst_4288 = (state_4301[(9)]);
var inst_4281 = inst_4288;
var state_4301__$1 = (function (){var statearr_4312 = state_4301;
(statearr_4312[(7)] = inst_4281);

return statearr_4312;
})();
var statearr_4313_4327 = state_4301__$1;
(statearr_4313_4327[(2)] = null);

(statearr_4313_4327[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (5))){
var inst_4281 = (state_4301[(7)]);
var state_4301__$1 = state_4301;
var statearr_4314_4328 = state_4301__$1;
(statearr_4314_4328[(2)] = inst_4281);

(statearr_4314_4328[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (10))){
var inst_4295 = (state_4301[(2)]);
var state_4301__$1 = state_4301;
var statearr_4315_4329 = state_4301__$1;
(statearr_4315_4329[(2)] = inst_4295);

(statearr_4315_4329[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4302 === (8))){
var inst_4288 = (state_4301[(9)]);
var inst_4291 = cljs.core.deref.call(null,inst_4288);
var state_4301__$1 = state_4301;
var statearr_4316_4330 = state_4301__$1;
(statearr_4316_4330[(2)] = inst_4291);

(statearr_4316_4330[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto__))
;
return ((function (switch__3724__auto__,c__3814__auto__){
return (function() {
var cljs$core$async$reduce_$_state_machine__3725__auto__ = null;
var cljs$core$async$reduce_$_state_machine__3725__auto____0 = (function (){
var statearr_4317 = [null,null,null,null,null,null,null,null,null,null];
(statearr_4317[(0)] = cljs$core$async$reduce_$_state_machine__3725__auto__);

(statearr_4317[(1)] = (1));

return statearr_4317;
});
var cljs$core$async$reduce_$_state_machine__3725__auto____1 = (function (state_4301){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4301);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4318){if((e4318 instanceof Object)){
var ex__3728__auto__ = e4318;
var statearr_4319_4331 = state_4301;
(statearr_4319_4331[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4301);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4318;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4332 = state_4301;
state_4301 = G__4332;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$reduce_$_state_machine__3725__auto__ = function(state_4301){
switch(arguments.length){
case 0:
return cljs$core$async$reduce_$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$reduce_$_state_machine__3725__auto____1.call(this,state_4301);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$reduce_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$reduce_$_state_machine__3725__auto____0;
cljs$core$async$reduce_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$reduce_$_state_machine__3725__auto____1;
return cljs$core$async$reduce_$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto__))
})();
var state__3816__auto__ = (function (){var statearr_4320 = f__3815__auto__.call(null);
(statearr_4320[(6)] = c__3814__auto__);

return statearr_4320;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto__))
);

return c__3814__auto__;
});
/**
 * async/reduces a channel with a transformation (xform f).
 *   Returns a channel containing the result.  ch must close before
 *   transduce produces a result.
 */
cljs.core.async.transduce = (function cljs$core$async$transduce(xform,f,init,ch){
var f__$1 = xform.call(null,f);
var c__3814__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto__,f__$1){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto__,f__$1){
return (function (state_4338){
var state_val_4339 = (state_4338[(1)]);
if((state_val_4339 === (1))){
var inst_4333 = cljs.core.async.reduce.call(null,f__$1,init,ch);
var state_4338__$1 = state_4338;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4338__$1,(2),inst_4333);
} else {
if((state_val_4339 === (2))){
var inst_4335 = (state_4338[(2)]);
var inst_4336 = f__$1.call(null,inst_4335);
var state_4338__$1 = state_4338;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4338__$1,inst_4336);
} else {
return null;
}
}
});})(c__3814__auto__,f__$1))
;
return ((function (switch__3724__auto__,c__3814__auto__,f__$1){
return (function() {
var cljs$core$async$transduce_$_state_machine__3725__auto__ = null;
var cljs$core$async$transduce_$_state_machine__3725__auto____0 = (function (){
var statearr_4340 = [null,null,null,null,null,null,null];
(statearr_4340[(0)] = cljs$core$async$transduce_$_state_machine__3725__auto__);

(statearr_4340[(1)] = (1));

return statearr_4340;
});
var cljs$core$async$transduce_$_state_machine__3725__auto____1 = (function (state_4338){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4338);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4341){if((e4341 instanceof Object)){
var ex__3728__auto__ = e4341;
var statearr_4342_4344 = state_4338;
(statearr_4342_4344[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4338);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4341;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4345 = state_4338;
state_4338 = G__4345;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$transduce_$_state_machine__3725__auto__ = function(state_4338){
switch(arguments.length){
case 0:
return cljs$core$async$transduce_$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$transduce_$_state_machine__3725__auto____1.call(this,state_4338);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$transduce_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$transduce_$_state_machine__3725__auto____0;
cljs$core$async$transduce_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$transduce_$_state_machine__3725__auto____1;
return cljs$core$async$transduce_$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto__,f__$1))
})();
var state__3816__auto__ = (function (){var statearr_4343 = f__3815__auto__.call(null);
(statearr_4343[(6)] = c__3814__auto__);

return statearr_4343;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto__,f__$1))
);

return c__3814__auto__;
});
/**
 * Puts the contents of coll into the supplied channel.
 * 
 *   By default the channel will be closed after the items are copied,
 *   but can be determined by the close? parameter.
 * 
 *   Returns a channel which will close after the items are copied.
 */
cljs.core.async.onto_chan = (function cljs$core$async$onto_chan(var_args){
var G__4347 = arguments.length;
switch (G__4347) {
case 2:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$2 = (function (ch,coll){
return cljs.core.async.onto_chan.call(null,ch,coll,true);
});

cljs.core.async.onto_chan.cljs$core$IFn$_invoke$arity$3 = (function (ch,coll,close_QMARK_){
var c__3814__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto__){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto__){
return (function (state_4372){
var state_val_4373 = (state_4372[(1)]);
if((state_val_4373 === (7))){
var inst_4354 = (state_4372[(2)]);
var state_4372__$1 = state_4372;
var statearr_4374_4395 = state_4372__$1;
(statearr_4374_4395[(2)] = inst_4354);

(statearr_4374_4395[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (1))){
var inst_4348 = cljs.core.seq.call(null,coll);
var inst_4349 = inst_4348;
var state_4372__$1 = (function (){var statearr_4375 = state_4372;
(statearr_4375[(7)] = inst_4349);

return statearr_4375;
})();
var statearr_4376_4396 = state_4372__$1;
(statearr_4376_4396[(2)] = null);

(statearr_4376_4396[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (4))){
var inst_4349 = (state_4372[(7)]);
var inst_4352 = cljs.core.first.call(null,inst_4349);
var state_4372__$1 = state_4372;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4372__$1,(7),ch,inst_4352);
} else {
if((state_val_4373 === (13))){
var inst_4366 = (state_4372[(2)]);
var state_4372__$1 = state_4372;
var statearr_4377_4397 = state_4372__$1;
(statearr_4377_4397[(2)] = inst_4366);

(statearr_4377_4397[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (6))){
var inst_4357 = (state_4372[(2)]);
var state_4372__$1 = state_4372;
if(cljs.core.truth_(inst_4357)){
var statearr_4378_4398 = state_4372__$1;
(statearr_4378_4398[(1)] = (8));

} else {
var statearr_4379_4399 = state_4372__$1;
(statearr_4379_4399[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (3))){
var inst_4370 = (state_4372[(2)]);
var state_4372__$1 = state_4372;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4372__$1,inst_4370);
} else {
if((state_val_4373 === (12))){
var state_4372__$1 = state_4372;
var statearr_4380_4400 = state_4372__$1;
(statearr_4380_4400[(2)] = null);

(statearr_4380_4400[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (2))){
var inst_4349 = (state_4372[(7)]);
var state_4372__$1 = state_4372;
if(cljs.core.truth_(inst_4349)){
var statearr_4381_4401 = state_4372__$1;
(statearr_4381_4401[(1)] = (4));

} else {
var statearr_4382_4402 = state_4372__$1;
(statearr_4382_4402[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (11))){
var inst_4363 = cljs.core.async.close_BANG_.call(null,ch);
var state_4372__$1 = state_4372;
var statearr_4383_4403 = state_4372__$1;
(statearr_4383_4403[(2)] = inst_4363);

(statearr_4383_4403[(1)] = (13));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (9))){
var state_4372__$1 = state_4372;
if(cljs.core.truth_(close_QMARK_)){
var statearr_4384_4404 = state_4372__$1;
(statearr_4384_4404[(1)] = (11));

} else {
var statearr_4385_4405 = state_4372__$1;
(statearr_4385_4405[(1)] = (12));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (5))){
var inst_4349 = (state_4372[(7)]);
var state_4372__$1 = state_4372;
var statearr_4386_4406 = state_4372__$1;
(statearr_4386_4406[(2)] = inst_4349);

(statearr_4386_4406[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (10))){
var inst_4368 = (state_4372[(2)]);
var state_4372__$1 = state_4372;
var statearr_4387_4407 = state_4372__$1;
(statearr_4387_4407[(2)] = inst_4368);

(statearr_4387_4407[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4373 === (8))){
var inst_4349 = (state_4372[(7)]);
var inst_4359 = cljs.core.next.call(null,inst_4349);
var inst_4349__$1 = inst_4359;
var state_4372__$1 = (function (){var statearr_4388 = state_4372;
(statearr_4388[(7)] = inst_4349__$1);

return statearr_4388;
})();
var statearr_4389_4408 = state_4372__$1;
(statearr_4389_4408[(2)] = null);

(statearr_4389_4408[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto__))
;
return ((function (switch__3724__auto__,c__3814__auto__){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_4390 = [null,null,null,null,null,null,null,null];
(statearr_4390[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_4390[(1)] = (1));

return statearr_4390;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_4372){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4372);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4391){if((e4391 instanceof Object)){
var ex__3728__auto__ = e4391;
var statearr_4392_4409 = state_4372;
(statearr_4392_4409[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4372);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4391;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4410 = state_4372;
state_4372 = G__4410;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_4372){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_4372);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto__))
})();
var state__3816__auto__ = (function (){var statearr_4393 = f__3815__auto__.call(null);
(statearr_4393[(6)] = c__3814__auto__);

return statearr_4393;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto__))
);

return c__3814__auto__;
});

cljs.core.async.onto_chan.cljs$lang$maxFixedArity = 3;

/**
 * Creates and returns a channel which contains the contents of coll,
 *   closing when exhausted.
 */
cljs.core.async.to_chan = (function cljs$core$async$to_chan(coll){
var ch = cljs.core.async.chan.call(null,cljs.core.bounded_count.call(null,(100),coll));
cljs.core.async.onto_chan.call(null,ch,coll);

return ch;
});

/**
 * @interface
 */
cljs.core.async.Mux = function(){};

cljs.core.async.muxch_STAR_ = (function cljs$core$async$muxch_STAR_(_){
if(((!((_ == null))) && (!((_.cljs$core$async$Mux$muxch_STAR_$arity$1 == null))))){
return _.cljs$core$async$Mux$muxch_STAR_$arity$1(_);
} else {
var x__4211__auto__ = (((_ == null))?null:_);
var m__4212__auto__ = (cljs.core.async.muxch_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,_);
} else {
var m__4212__auto____$1 = (cljs.core.async.muxch_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,_);
} else {
throw cljs.core.missing_protocol.call(null,"Mux.muxch*",_);
}
}
}
});


/**
 * @interface
 */
cljs.core.async.Mult = function(){};

cljs.core.async.tap_STAR_ = (function cljs$core$async$tap_STAR_(m,ch,close_QMARK_){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$tap_STAR_$arity$3 == null))))){
return m.cljs$core$async$Mult$tap_STAR_$arity$3(m,ch,close_QMARK_);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.tap_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch,close_QMARK_);
} else {
var m__4212__auto____$1 = (cljs.core.async.tap_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.tap*",m);
}
}
}
});

cljs.core.async.untap_STAR_ = (function cljs$core$async$untap_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$untap_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mult$untap_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.untap_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.untap_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap*",m);
}
}
}
});

cljs.core.async.untap_all_STAR_ = (function cljs$core$async$untap_all_STAR_(m){
if(((!((m == null))) && (!((m.cljs$core$async$Mult$untap_all_STAR_$arity$1 == null))))){
return m.cljs$core$async$Mult$untap_all_STAR_$arity$1(m);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.untap_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m);
} else {
var m__4212__auto____$1 = (cljs.core.async.untap_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mult.untap-all*",m);
}
}
}
});

/**
 * Creates and returns a mult(iple) of the supplied channel. Channels
 *   containing copies of the channel can be created with 'tap', and
 *   detached with 'untap'.
 * 
 *   Each item is distributed to all taps in parallel and synchronously,
 *   i.e. each tap must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow taps from holding up the mult.
 * 
 *   Items received when there are no taps get dropped.
 * 
 *   If a tap puts to a closed channel, it will be removed from the mult.
 */
cljs.core.async.mult = (function cljs$core$async$mult(ch){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async4411 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Mult}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4411 = (function (ch,cs,meta4412){
this.ch = ch;
this.cs = cs;
this.meta4412 = meta4412;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs){
return (function (_4413,meta4412__$1){
var self__ = this;
var _4413__$1 = this;
return (new cljs.core.async.t_cljs$core$async4411(self__.ch,self__.cs,meta4412__$1));
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs){
return (function (_4413){
var self__ = this;
var _4413__$1 = this;
return self__.meta4412;
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$async$Mult$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$async$Mult$tap_STAR_$arity$3 = ((function (cs){
return (function (_,ch__$1,close_QMARK_){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch__$1,close_QMARK_);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$async$Mult$untap_STAR_$arity$2 = ((function (cs){
return (function (_,ch__$1){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch__$1);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.prototype.cljs$core$async$Mult$untap_all_STAR_$arity$1 = ((function (cs){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return null;
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.getBasis = ((function (cs){
return (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"meta4412","meta4412",38633150,null)], null);
});})(cs))
;

cljs.core.async.t_cljs$core$async4411.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4411.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4411";

cljs.core.async.t_cljs$core$async4411.cljs$lang$ctorPrWriter = ((function (cs){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async4411");
});})(cs))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4411.
 */
cljs.core.async.__GT_t_cljs$core$async4411 = ((function (cs){
return (function cljs$core$async$mult_$___GT_t_cljs$core$async4411(ch__$1,cs__$1,meta4412){
return (new cljs.core.async.t_cljs$core$async4411(ch__$1,cs__$1,meta4412));
});})(cs))
;

}

return (new cljs.core.async.t_cljs$core$async4411(ch,cs,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = ((function (cs,m,dchan,dctr){
return (function (_){
if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,true);
} else {
return null;
}
});})(cs,m,dchan,dctr))
;
var c__3814__auto___4633 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___4633,cs,m,dchan,dctr,done){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___4633,cs,m,dchan,dctr,done){
return (function (state_4548){
var state_val_4549 = (state_4548[(1)]);
if((state_val_4549 === (7))){
var inst_4544 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4550_4634 = state_4548__$1;
(statearr_4550_4634[(2)] = inst_4544);

(statearr_4550_4634[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (20))){
var inst_4447 = (state_4548[(7)]);
var inst_4459 = cljs.core.first.call(null,inst_4447);
var inst_4460 = cljs.core.nth.call(null,inst_4459,(0),null);
var inst_4461 = cljs.core.nth.call(null,inst_4459,(1),null);
var state_4548__$1 = (function (){var statearr_4551 = state_4548;
(statearr_4551[(8)] = inst_4460);

return statearr_4551;
})();
if(cljs.core.truth_(inst_4461)){
var statearr_4552_4635 = state_4548__$1;
(statearr_4552_4635[(1)] = (22));

} else {
var statearr_4553_4636 = state_4548__$1;
(statearr_4553_4636[(1)] = (23));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (27))){
var inst_4496 = (state_4548[(9)]);
var inst_4491 = (state_4548[(10)]);
var inst_4489 = (state_4548[(11)]);
var inst_4416 = (state_4548[(12)]);
var inst_4496__$1 = cljs.core._nth.call(null,inst_4489,inst_4491);
var inst_4497 = cljs.core.async.put_BANG_.call(null,inst_4496__$1,inst_4416,done);
var state_4548__$1 = (function (){var statearr_4554 = state_4548;
(statearr_4554[(9)] = inst_4496__$1);

return statearr_4554;
})();
if(cljs.core.truth_(inst_4497)){
var statearr_4555_4637 = state_4548__$1;
(statearr_4555_4637[(1)] = (30));

} else {
var statearr_4556_4638 = state_4548__$1;
(statearr_4556_4638[(1)] = (31));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (1))){
var state_4548__$1 = state_4548;
var statearr_4557_4639 = state_4548__$1;
(statearr_4557_4639[(2)] = null);

(statearr_4557_4639[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (24))){
var inst_4447 = (state_4548[(7)]);
var inst_4466 = (state_4548[(2)]);
var inst_4467 = cljs.core.next.call(null,inst_4447);
var inst_4425 = inst_4467;
var inst_4426 = null;
var inst_4427 = (0);
var inst_4428 = (0);
var state_4548__$1 = (function (){var statearr_4558 = state_4548;
(statearr_4558[(13)] = inst_4428);

(statearr_4558[(14)] = inst_4466);

(statearr_4558[(15)] = inst_4426);

(statearr_4558[(16)] = inst_4425);

(statearr_4558[(17)] = inst_4427);

return statearr_4558;
})();
var statearr_4559_4640 = state_4548__$1;
(statearr_4559_4640[(2)] = null);

(statearr_4559_4640[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (39))){
var state_4548__$1 = state_4548;
var statearr_4563_4641 = state_4548__$1;
(statearr_4563_4641[(2)] = null);

(statearr_4563_4641[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (4))){
var inst_4416 = (state_4548[(12)]);
var inst_4416__$1 = (state_4548[(2)]);
var inst_4417 = (inst_4416__$1 == null);
var state_4548__$1 = (function (){var statearr_4564 = state_4548;
(statearr_4564[(12)] = inst_4416__$1);

return statearr_4564;
})();
if(cljs.core.truth_(inst_4417)){
var statearr_4565_4642 = state_4548__$1;
(statearr_4565_4642[(1)] = (5));

} else {
var statearr_4566_4643 = state_4548__$1;
(statearr_4566_4643[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (15))){
var inst_4428 = (state_4548[(13)]);
var inst_4426 = (state_4548[(15)]);
var inst_4425 = (state_4548[(16)]);
var inst_4427 = (state_4548[(17)]);
var inst_4443 = (state_4548[(2)]);
var inst_4444 = (inst_4428 + (1));
var tmp4560 = inst_4426;
var tmp4561 = inst_4425;
var tmp4562 = inst_4427;
var inst_4425__$1 = tmp4561;
var inst_4426__$1 = tmp4560;
var inst_4427__$1 = tmp4562;
var inst_4428__$1 = inst_4444;
var state_4548__$1 = (function (){var statearr_4567 = state_4548;
(statearr_4567[(13)] = inst_4428__$1);

(statearr_4567[(15)] = inst_4426__$1);

(statearr_4567[(16)] = inst_4425__$1);

(statearr_4567[(18)] = inst_4443);

(statearr_4567[(17)] = inst_4427__$1);

return statearr_4567;
})();
var statearr_4568_4644 = state_4548__$1;
(statearr_4568_4644[(2)] = null);

(statearr_4568_4644[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (21))){
var inst_4470 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4572_4645 = state_4548__$1;
(statearr_4572_4645[(2)] = inst_4470);

(statearr_4572_4645[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (31))){
var inst_4496 = (state_4548[(9)]);
var inst_4500 = done.call(null,null);
var inst_4501 = cljs.core.async.untap_STAR_.call(null,m,inst_4496);
var state_4548__$1 = (function (){var statearr_4573 = state_4548;
(statearr_4573[(19)] = inst_4500);

return statearr_4573;
})();
var statearr_4574_4646 = state_4548__$1;
(statearr_4574_4646[(2)] = inst_4501);

(statearr_4574_4646[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (32))){
var inst_4491 = (state_4548[(10)]);
var inst_4488 = (state_4548[(20)]);
var inst_4489 = (state_4548[(11)]);
var inst_4490 = (state_4548[(21)]);
var inst_4503 = (state_4548[(2)]);
var inst_4504 = (inst_4491 + (1));
var tmp4569 = inst_4488;
var tmp4570 = inst_4489;
var tmp4571 = inst_4490;
var inst_4488__$1 = tmp4569;
var inst_4489__$1 = tmp4570;
var inst_4490__$1 = tmp4571;
var inst_4491__$1 = inst_4504;
var state_4548__$1 = (function (){var statearr_4575 = state_4548;
(statearr_4575[(22)] = inst_4503);

(statearr_4575[(10)] = inst_4491__$1);

(statearr_4575[(20)] = inst_4488__$1);

(statearr_4575[(11)] = inst_4489__$1);

(statearr_4575[(21)] = inst_4490__$1);

return statearr_4575;
})();
var statearr_4576_4647 = state_4548__$1;
(statearr_4576_4647[(2)] = null);

(statearr_4576_4647[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (40))){
var inst_4516 = (state_4548[(23)]);
var inst_4520 = done.call(null,null);
var inst_4521 = cljs.core.async.untap_STAR_.call(null,m,inst_4516);
var state_4548__$1 = (function (){var statearr_4577 = state_4548;
(statearr_4577[(24)] = inst_4520);

return statearr_4577;
})();
var statearr_4578_4648 = state_4548__$1;
(statearr_4578_4648[(2)] = inst_4521);

(statearr_4578_4648[(1)] = (41));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (33))){
var inst_4507 = (state_4548[(25)]);
var inst_4509 = cljs.core.chunked_seq_QMARK_.call(null,inst_4507);
var state_4548__$1 = state_4548;
if(inst_4509){
var statearr_4579_4649 = state_4548__$1;
(statearr_4579_4649[(1)] = (36));

} else {
var statearr_4580_4650 = state_4548__$1;
(statearr_4580_4650[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (13))){
var inst_4437 = (state_4548[(26)]);
var inst_4440 = cljs.core.async.close_BANG_.call(null,inst_4437);
var state_4548__$1 = state_4548;
var statearr_4581_4651 = state_4548__$1;
(statearr_4581_4651[(2)] = inst_4440);

(statearr_4581_4651[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (22))){
var inst_4460 = (state_4548[(8)]);
var inst_4463 = cljs.core.async.close_BANG_.call(null,inst_4460);
var state_4548__$1 = state_4548;
var statearr_4582_4652 = state_4548__$1;
(statearr_4582_4652[(2)] = inst_4463);

(statearr_4582_4652[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (36))){
var inst_4507 = (state_4548[(25)]);
var inst_4511 = cljs.core.chunk_first.call(null,inst_4507);
var inst_4512 = cljs.core.chunk_rest.call(null,inst_4507);
var inst_4513 = cljs.core.count.call(null,inst_4511);
var inst_4488 = inst_4512;
var inst_4489 = inst_4511;
var inst_4490 = inst_4513;
var inst_4491 = (0);
var state_4548__$1 = (function (){var statearr_4583 = state_4548;
(statearr_4583[(10)] = inst_4491);

(statearr_4583[(20)] = inst_4488);

(statearr_4583[(11)] = inst_4489);

(statearr_4583[(21)] = inst_4490);

return statearr_4583;
})();
var statearr_4584_4653 = state_4548__$1;
(statearr_4584_4653[(2)] = null);

(statearr_4584_4653[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (41))){
var inst_4507 = (state_4548[(25)]);
var inst_4523 = (state_4548[(2)]);
var inst_4524 = cljs.core.next.call(null,inst_4507);
var inst_4488 = inst_4524;
var inst_4489 = null;
var inst_4490 = (0);
var inst_4491 = (0);
var state_4548__$1 = (function (){var statearr_4585 = state_4548;
(statearr_4585[(10)] = inst_4491);

(statearr_4585[(20)] = inst_4488);

(statearr_4585[(11)] = inst_4489);

(statearr_4585[(27)] = inst_4523);

(statearr_4585[(21)] = inst_4490);

return statearr_4585;
})();
var statearr_4586_4654 = state_4548__$1;
(statearr_4586_4654[(2)] = null);

(statearr_4586_4654[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (43))){
var state_4548__$1 = state_4548;
var statearr_4587_4655 = state_4548__$1;
(statearr_4587_4655[(2)] = null);

(statearr_4587_4655[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (29))){
var inst_4532 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4588_4656 = state_4548__$1;
(statearr_4588_4656[(2)] = inst_4532);

(statearr_4588_4656[(1)] = (26));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (44))){
var inst_4541 = (state_4548[(2)]);
var state_4548__$1 = (function (){var statearr_4589 = state_4548;
(statearr_4589[(28)] = inst_4541);

return statearr_4589;
})();
var statearr_4590_4657 = state_4548__$1;
(statearr_4590_4657[(2)] = null);

(statearr_4590_4657[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (6))){
var inst_4480 = (state_4548[(29)]);
var inst_4479 = cljs.core.deref.call(null,cs);
var inst_4480__$1 = cljs.core.keys.call(null,inst_4479);
var inst_4481 = cljs.core.count.call(null,inst_4480__$1);
var inst_4482 = cljs.core.reset_BANG_.call(null,dctr,inst_4481);
var inst_4487 = cljs.core.seq.call(null,inst_4480__$1);
var inst_4488 = inst_4487;
var inst_4489 = null;
var inst_4490 = (0);
var inst_4491 = (0);
var state_4548__$1 = (function (){var statearr_4591 = state_4548;
(statearr_4591[(10)] = inst_4491);

(statearr_4591[(20)] = inst_4488);

(statearr_4591[(29)] = inst_4480__$1);

(statearr_4591[(11)] = inst_4489);

(statearr_4591[(30)] = inst_4482);

(statearr_4591[(21)] = inst_4490);

return statearr_4591;
})();
var statearr_4592_4658 = state_4548__$1;
(statearr_4592_4658[(2)] = null);

(statearr_4592_4658[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (28))){
var inst_4488 = (state_4548[(20)]);
var inst_4507 = (state_4548[(25)]);
var inst_4507__$1 = cljs.core.seq.call(null,inst_4488);
var state_4548__$1 = (function (){var statearr_4593 = state_4548;
(statearr_4593[(25)] = inst_4507__$1);

return statearr_4593;
})();
if(inst_4507__$1){
var statearr_4594_4659 = state_4548__$1;
(statearr_4594_4659[(1)] = (33));

} else {
var statearr_4595_4660 = state_4548__$1;
(statearr_4595_4660[(1)] = (34));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (25))){
var inst_4491 = (state_4548[(10)]);
var inst_4490 = (state_4548[(21)]);
var inst_4493 = (inst_4491 < inst_4490);
var inst_4494 = inst_4493;
var state_4548__$1 = state_4548;
if(cljs.core.truth_(inst_4494)){
var statearr_4596_4661 = state_4548__$1;
(statearr_4596_4661[(1)] = (27));

} else {
var statearr_4597_4662 = state_4548__$1;
(statearr_4597_4662[(1)] = (28));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (34))){
var state_4548__$1 = state_4548;
var statearr_4598_4663 = state_4548__$1;
(statearr_4598_4663[(2)] = null);

(statearr_4598_4663[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (17))){
var state_4548__$1 = state_4548;
var statearr_4599_4664 = state_4548__$1;
(statearr_4599_4664[(2)] = null);

(statearr_4599_4664[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (3))){
var inst_4546 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4548__$1,inst_4546);
} else {
if((state_val_4549 === (12))){
var inst_4475 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4600_4665 = state_4548__$1;
(statearr_4600_4665[(2)] = inst_4475);

(statearr_4600_4665[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (2))){
var state_4548__$1 = state_4548;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4548__$1,(4),ch);
} else {
if((state_val_4549 === (23))){
var state_4548__$1 = state_4548;
var statearr_4601_4666 = state_4548__$1;
(statearr_4601_4666[(2)] = null);

(statearr_4601_4666[(1)] = (24));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (35))){
var inst_4530 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4602_4667 = state_4548__$1;
(statearr_4602_4667[(2)] = inst_4530);

(statearr_4602_4667[(1)] = (29));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (19))){
var inst_4447 = (state_4548[(7)]);
var inst_4451 = cljs.core.chunk_first.call(null,inst_4447);
var inst_4452 = cljs.core.chunk_rest.call(null,inst_4447);
var inst_4453 = cljs.core.count.call(null,inst_4451);
var inst_4425 = inst_4452;
var inst_4426 = inst_4451;
var inst_4427 = inst_4453;
var inst_4428 = (0);
var state_4548__$1 = (function (){var statearr_4603 = state_4548;
(statearr_4603[(13)] = inst_4428);

(statearr_4603[(15)] = inst_4426);

(statearr_4603[(16)] = inst_4425);

(statearr_4603[(17)] = inst_4427);

return statearr_4603;
})();
var statearr_4604_4668 = state_4548__$1;
(statearr_4604_4668[(2)] = null);

(statearr_4604_4668[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (11))){
var inst_4425 = (state_4548[(16)]);
var inst_4447 = (state_4548[(7)]);
var inst_4447__$1 = cljs.core.seq.call(null,inst_4425);
var state_4548__$1 = (function (){var statearr_4605 = state_4548;
(statearr_4605[(7)] = inst_4447__$1);

return statearr_4605;
})();
if(inst_4447__$1){
var statearr_4606_4669 = state_4548__$1;
(statearr_4606_4669[(1)] = (16));

} else {
var statearr_4607_4670 = state_4548__$1;
(statearr_4607_4670[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (9))){
var inst_4477 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4608_4671 = state_4548__$1;
(statearr_4608_4671[(2)] = inst_4477);

(statearr_4608_4671[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (5))){
var inst_4423 = cljs.core.deref.call(null,cs);
var inst_4424 = cljs.core.seq.call(null,inst_4423);
var inst_4425 = inst_4424;
var inst_4426 = null;
var inst_4427 = (0);
var inst_4428 = (0);
var state_4548__$1 = (function (){var statearr_4609 = state_4548;
(statearr_4609[(13)] = inst_4428);

(statearr_4609[(15)] = inst_4426);

(statearr_4609[(16)] = inst_4425);

(statearr_4609[(17)] = inst_4427);

return statearr_4609;
})();
var statearr_4610_4672 = state_4548__$1;
(statearr_4610_4672[(2)] = null);

(statearr_4610_4672[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (14))){
var state_4548__$1 = state_4548;
var statearr_4611_4673 = state_4548__$1;
(statearr_4611_4673[(2)] = null);

(statearr_4611_4673[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (45))){
var inst_4538 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4612_4674 = state_4548__$1;
(statearr_4612_4674[(2)] = inst_4538);

(statearr_4612_4674[(1)] = (44));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (26))){
var inst_4480 = (state_4548[(29)]);
var inst_4534 = (state_4548[(2)]);
var inst_4535 = cljs.core.seq.call(null,inst_4480);
var state_4548__$1 = (function (){var statearr_4613 = state_4548;
(statearr_4613[(31)] = inst_4534);

return statearr_4613;
})();
if(inst_4535){
var statearr_4614_4675 = state_4548__$1;
(statearr_4614_4675[(1)] = (42));

} else {
var statearr_4615_4676 = state_4548__$1;
(statearr_4615_4676[(1)] = (43));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (16))){
var inst_4447 = (state_4548[(7)]);
var inst_4449 = cljs.core.chunked_seq_QMARK_.call(null,inst_4447);
var state_4548__$1 = state_4548;
if(inst_4449){
var statearr_4616_4677 = state_4548__$1;
(statearr_4616_4677[(1)] = (19));

} else {
var statearr_4617_4678 = state_4548__$1;
(statearr_4617_4678[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (38))){
var inst_4527 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4618_4679 = state_4548__$1;
(statearr_4618_4679[(2)] = inst_4527);

(statearr_4618_4679[(1)] = (35));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (30))){
var state_4548__$1 = state_4548;
var statearr_4619_4680 = state_4548__$1;
(statearr_4619_4680[(2)] = null);

(statearr_4619_4680[(1)] = (32));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (10))){
var inst_4428 = (state_4548[(13)]);
var inst_4426 = (state_4548[(15)]);
var inst_4436 = cljs.core._nth.call(null,inst_4426,inst_4428);
var inst_4437 = cljs.core.nth.call(null,inst_4436,(0),null);
var inst_4438 = cljs.core.nth.call(null,inst_4436,(1),null);
var state_4548__$1 = (function (){var statearr_4620 = state_4548;
(statearr_4620[(26)] = inst_4437);

return statearr_4620;
})();
if(cljs.core.truth_(inst_4438)){
var statearr_4621_4681 = state_4548__$1;
(statearr_4621_4681[(1)] = (13));

} else {
var statearr_4622_4682 = state_4548__$1;
(statearr_4622_4682[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (18))){
var inst_4473 = (state_4548[(2)]);
var state_4548__$1 = state_4548;
var statearr_4623_4683 = state_4548__$1;
(statearr_4623_4683[(2)] = inst_4473);

(statearr_4623_4683[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (42))){
var state_4548__$1 = state_4548;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_4548__$1,(45),dchan);
} else {
if((state_val_4549 === (37))){
var inst_4507 = (state_4548[(25)]);
var inst_4516 = (state_4548[(23)]);
var inst_4416 = (state_4548[(12)]);
var inst_4516__$1 = cljs.core.first.call(null,inst_4507);
var inst_4517 = cljs.core.async.put_BANG_.call(null,inst_4516__$1,inst_4416,done);
var state_4548__$1 = (function (){var statearr_4624 = state_4548;
(statearr_4624[(23)] = inst_4516__$1);

return statearr_4624;
})();
if(cljs.core.truth_(inst_4517)){
var statearr_4625_4684 = state_4548__$1;
(statearr_4625_4684[(1)] = (39));

} else {
var statearr_4626_4685 = state_4548__$1;
(statearr_4626_4685[(1)] = (40));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4549 === (8))){
var inst_4428 = (state_4548[(13)]);
var inst_4427 = (state_4548[(17)]);
var inst_4430 = (inst_4428 < inst_4427);
var inst_4431 = inst_4430;
var state_4548__$1 = state_4548;
if(cljs.core.truth_(inst_4431)){
var statearr_4627_4686 = state_4548__$1;
(statearr_4627_4686[(1)] = (10));

} else {
var statearr_4628_4687 = state_4548__$1;
(statearr_4628_4687[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___4633,cs,m,dchan,dctr,done))
;
return ((function (switch__3724__auto__,c__3814__auto___4633,cs,m,dchan,dctr,done){
return (function() {
var cljs$core$async$mult_$_state_machine__3725__auto__ = null;
var cljs$core$async$mult_$_state_machine__3725__auto____0 = (function (){
var statearr_4629 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4629[(0)] = cljs$core$async$mult_$_state_machine__3725__auto__);

(statearr_4629[(1)] = (1));

return statearr_4629;
});
var cljs$core$async$mult_$_state_machine__3725__auto____1 = (function (state_4548){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4548);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4630){if((e4630 instanceof Object)){
var ex__3728__auto__ = e4630;
var statearr_4631_4688 = state_4548;
(statearr_4631_4688[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4548);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4630;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4689 = state_4548;
state_4548 = G__4689;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$mult_$_state_machine__3725__auto__ = function(state_4548){
switch(arguments.length){
case 0:
return cljs$core$async$mult_$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$mult_$_state_machine__3725__auto____1.call(this,state_4548);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mult_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mult_$_state_machine__3725__auto____0;
cljs$core$async$mult_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mult_$_state_machine__3725__auto____1;
return cljs$core$async$mult_$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___4633,cs,m,dchan,dctr,done))
})();
var state__3816__auto__ = (function (){var statearr_4632 = f__3815__auto__.call(null);
(statearr_4632[(6)] = c__3814__auto___4633);

return statearr_4632;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___4633,cs,m,dchan,dctr,done))
);


return m;
});
/**
 * Copies the mult source onto the supplied channel.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.tap = (function cljs$core$async$tap(var_args){
var G__4691 = arguments.length;
switch (G__4691) {
case 2:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$2 = (function (mult,ch){
return cljs.core.async.tap.call(null,mult,ch,true);
});

cljs.core.async.tap.cljs$core$IFn$_invoke$arity$3 = (function (mult,ch,close_QMARK_){
cljs.core.async.tap_STAR_.call(null,mult,ch,close_QMARK_);

return ch;
});

cljs.core.async.tap.cljs$lang$maxFixedArity = 3;

/**
 * Disconnects a target channel from a mult
 */
cljs.core.async.untap = (function cljs$core$async$untap(mult,ch){
return cljs.core.async.untap_STAR_.call(null,mult,ch);
});
/**
 * Disconnects all target channels from a mult
 */
cljs.core.async.untap_all = (function cljs$core$async$untap_all(mult){
return cljs.core.async.untap_all_STAR_.call(null,mult);
});

/**
 * @interface
 */
cljs.core.async.Mix = function(){};

cljs.core.async.admix_STAR_ = (function cljs$core$async$admix_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$admix_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$admix_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.admix_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.admix_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.admix*",m);
}
}
}
});

cljs.core.async.unmix_STAR_ = (function cljs$core$async$unmix_STAR_(m,ch){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$unmix_STAR_$arity$2(m,ch);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.unmix_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.unmix_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix*",m);
}
}
}
});

cljs.core.async.unmix_all_STAR_ = (function cljs$core$async$unmix_all_STAR_(m){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$unmix_all_STAR_$arity$1 == null))))){
return m.cljs$core$async$Mix$unmix_all_STAR_$arity$1(m);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.unmix_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m);
} else {
var m__4212__auto____$1 = (cljs.core.async.unmix_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.unmix-all*",m);
}
}
}
});

cljs.core.async.toggle_STAR_ = (function cljs$core$async$toggle_STAR_(m,state_map){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$toggle_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$toggle_STAR_$arity$2(m,state_map);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.toggle_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,state_map);
} else {
var m__4212__auto____$1 = (cljs.core.async.toggle_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,state_map);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.toggle*",m);
}
}
}
});

cljs.core.async.solo_mode_STAR_ = (function cljs$core$async$solo_mode_STAR_(m,mode){
if(((!((m == null))) && (!((m.cljs$core$async$Mix$solo_mode_STAR_$arity$2 == null))))){
return m.cljs$core$async$Mix$solo_mode_STAR_$arity$2(m,mode);
} else {
var x__4211__auto__ = (((m == null))?null:m);
var m__4212__auto__ = (cljs.core.async.solo_mode_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,m,mode);
} else {
var m__4212__auto____$1 = (cljs.core.async.solo_mode_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,m,mode);
} else {
throw cljs.core.missing_protocol.call(null,"Mix.solo-mode*",m);
}
}
}
});

cljs.core.async.ioc_alts_BANG_ = (function cljs$core$async$ioc_alts_BANG_(var_args){
var args__4502__auto__ = [];
var len__4499__auto___4703 = arguments.length;
var i__4500__auto___4704 = (0);
while(true){
if((i__4500__auto___4704 < len__4499__auto___4703)){
args__4502__auto__.push((arguments[i__4500__auto___4704]));

var G__4705 = (i__4500__auto___4704 + (1));
i__4500__auto___4704 = G__4705;
continue;
} else {
}
break;
}

var argseq__4503__auto__ = ((((3) < args__4502__auto__.length))?(new cljs.core.IndexedSeq(args__4502__auto__.slice((3)),(0),null)):null);
return cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),argseq__4503__auto__);
});

cljs.core.async.ioc_alts_BANG_.cljs$core$IFn$_invoke$arity$variadic = (function (state,cont_block,ports,p__4697){
var map__4698 = p__4697;
var map__4698__$1 = ((((!((map__4698 == null)))?(((((map__4698.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__4698.cljs$core$ISeq$))))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__4698):map__4698);
var opts = map__4698__$1;
var statearr_4700_4706 = state;
(statearr_4700_4706[(1)] = cont_block);


var temp__5457__auto__ = cljs.core.async.do_alts.call(null,((function (map__4698,map__4698__$1,opts){
return (function (val){
var statearr_4701_4707 = state;
(statearr_4701_4707[(2)] = val);


return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state);
});})(map__4698,map__4698__$1,opts))
,ports,opts);
if(cljs.core.truth_(temp__5457__auto__)){
var cb = temp__5457__auto__;
var statearr_4702_4708 = state;
(statearr_4702_4708[(2)] = cljs.core.deref.call(null,cb));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
});

cljs.core.async.ioc_alts_BANG_.cljs$lang$maxFixedArity = (3);

/** @this {Function} */
cljs.core.async.ioc_alts_BANG_.cljs$lang$applyTo = (function (seq4693){
var G__4694 = cljs.core.first.call(null,seq4693);
var seq4693__$1 = cljs.core.next.call(null,seq4693);
var G__4695 = cljs.core.first.call(null,seq4693__$1);
var seq4693__$2 = cljs.core.next.call(null,seq4693__$1);
var G__4696 = cljs.core.first.call(null,seq4693__$2);
var seq4693__$3 = cljs.core.next.call(null,seq4693__$2);
var self__4486__auto__ = this;
return self__4486__auto__.cljs$core$IFn$_invoke$arity$variadic(G__4694,G__4695,G__4696,seq4693__$3);
});

/**
 * Creates and returns a mix of one or more input channels which will
 *   be put on the supplied out channel. Input sources can be added to
 *   the mix with 'admix', and removed with 'unmix'. A mix supports
 *   soloing, muting and pausing multiple inputs atomically using
 *   'toggle', and can solo using either muting or pausing as determined
 *   by 'solo-mode'.
 * 
 *   Each channel can have zero or more boolean modes set via 'toggle':
 * 
 *   :solo - when true, only this (ond other soloed) channel(s) will appear
 *        in the mix output channel. :mute and :pause states of soloed
 *        channels are ignored. If solo-mode is :mute, non-soloed
 *        channels are muted, if :pause, non-soloed channels are
 *        paused.
 * 
 *   :mute - muted channels will have their contents consumed but not included in the mix
 *   :pause - paused channels will not have their contents consumed (and thus also not included in the mix)
 */
cljs.core.async.mix = (function cljs$core$async$mix(out){
var cs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var solo_modes = new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"pause","pause",-2095325672),null,new cljs.core.Keyword(null,"mute","mute",1151223646),null], null), null);
var attrs = cljs.core.conj.call(null,solo_modes,new cljs.core.Keyword(null,"solo","solo",-316350075));
var solo_mode = cljs.core.atom.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646));
var change = cljs.core.async.chan.call(null);
var changed = ((function (cs,solo_modes,attrs,solo_mode,change){
return (function (){
return cljs.core.async.put_BANG_.call(null,change,true);
});})(cs,solo_modes,attrs,solo_mode,change))
;
var pick = ((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (attr,chs){
return cljs.core.reduce_kv.call(null,((function (cs,solo_modes,attrs,solo_mode,change,changed){
return (function (ret,c,v){
if(cljs.core.truth_(attr.call(null,v))){
return cljs.core.conj.call(null,ret,c);
} else {
return ret;
}
});})(cs,solo_modes,attrs,solo_mode,change,changed))
,cljs.core.PersistentHashSet.EMPTY,chs);
});})(cs,solo_modes,attrs,solo_mode,change,changed))
;
var calc_state = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick){
return (function (){
var chs = cljs.core.deref.call(null,cs);
var mode = cljs.core.deref.call(null,solo_mode);
var solos = pick.call(null,new cljs.core.Keyword(null,"solo","solo",-316350075),chs);
var pauses = pick.call(null,new cljs.core.Keyword(null,"pause","pause",-2095325672),chs);
return new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"solos","solos",1441458643),solos,new cljs.core.Keyword(null,"mutes","mutes",1068806309),pick.call(null,new cljs.core.Keyword(null,"mute","mute",1151223646),chs),new cljs.core.Keyword(null,"reads","reads",-1215067361),cljs.core.conj.call(null,((((cljs.core._EQ_.call(null,mode,new cljs.core.Keyword(null,"pause","pause",-2095325672))) && (!(cljs.core.empty_QMARK_.call(null,solos)))))?cljs.core.vec.call(null,solos):cljs.core.vec.call(null,cljs.core.remove.call(null,pauses,cljs.core.keys.call(null,chs)))),change)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick))
;
var m = (function (){
if(typeof cljs.core.async.t_cljs$core$async4709 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mix}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4709 = (function (out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,meta4710){
this.out = out;
this.cs = cs;
this.solo_modes = solo_modes;
this.attrs = attrs;
this.solo_mode = solo_mode;
this.change = change;
this.changed = changed;
this.pick = pick;
this.calc_state = calc_state;
this.meta4710 = meta4710;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_4711,meta4710__$1){
var self__ = this;
var _4711__$1 = this;
return (new cljs.core.async.t_cljs$core$async4709(self__.out,self__.cs,self__.solo_modes,self__.attrs,self__.solo_mode,self__.change,self__.changed,self__.pick,self__.calc_state,meta4710__$1));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_4711){
var self__ = this;
var _4711__$1 = this;
return self__.meta4710;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.out;
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mix$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mix$admix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.assoc,ch,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mix$unmix_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,ch){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.dissoc,ch);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mix$unmix_all_STAR_$arity$1 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_){
var self__ = this;
var ___$1 = this;
cljs.core.reset_BANG_.call(null,self__.cs,cljs.core.PersistentArrayMap.EMPTY);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mix$toggle_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,state_map){
var self__ = this;
var ___$1 = this;
cljs.core.swap_BANG_.call(null,self__.cs,cljs.core.partial.call(null,cljs.core.merge_with,cljs.core.merge),state_map);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.prototype.cljs$core$async$Mix$solo_mode_STAR_$arity$2 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (_,mode){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.solo_modes.call(null,mode))){
} else {
throw (new Error(["Assert failed: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(["mode must be one of: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(self__.solo_modes)].join('')),"\n","(solo-modes mode)"].join('')));
}

cljs.core.reset_BANG_.call(null,self__.solo_mode,mode);

return self__.changed.call(null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.getBasis = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (){
return new cljs.core.PersistentVector(null, 10, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"out","out",729986010,null),new cljs.core.Symbol(null,"cs","cs",-117024463,null),new cljs.core.Symbol(null,"solo-modes","solo-modes",882180540,null),new cljs.core.Symbol(null,"attrs","attrs",-450137186,null),new cljs.core.Symbol(null,"solo-mode","solo-mode",2031788074,null),new cljs.core.Symbol(null,"change","change",477485025,null),new cljs.core.Symbol(null,"changed","changed",-2083710852,null),new cljs.core.Symbol(null,"pick","pick",1300068175,null),new cljs.core.Symbol(null,"calc-state","calc-state",-349968968,null),new cljs.core.Symbol(null,"meta4710","meta4710",789909213,null)], null);
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

cljs.core.async.t_cljs$core$async4709.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4709.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4709";

cljs.core.async.t_cljs$core$async4709.cljs$lang$ctorPrWriter = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async4709");
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4709.
 */
cljs.core.async.__GT_t_cljs$core$async4709 = ((function (cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state){
return (function cljs$core$async$mix_$___GT_t_cljs$core$async4709(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta4710){
return (new cljs.core.async.t_cljs$core$async4709(out__$1,cs__$1,solo_modes__$1,attrs__$1,solo_mode__$1,change__$1,changed__$1,pick__$1,calc_state__$1,meta4710));
});})(cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state))
;

}

return (new cljs.core.async.t_cljs$core$async4709(out,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__3814__auto___4873 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___4873,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___4873,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function (state_4813){
var state_val_4814 = (state_4813[(1)]);
if((state_val_4814 === (7))){
var inst_4728 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
var statearr_4815_4874 = state_4813__$1;
(statearr_4815_4874[(2)] = inst_4728);

(statearr_4815_4874[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (20))){
var inst_4740 = (state_4813[(7)]);
var state_4813__$1 = state_4813;
var statearr_4816_4875 = state_4813__$1;
(statearr_4816_4875[(2)] = inst_4740);

(statearr_4816_4875[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (27))){
var state_4813__$1 = state_4813;
var statearr_4817_4876 = state_4813__$1;
(statearr_4817_4876[(2)] = null);

(statearr_4817_4876[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (1))){
var inst_4715 = (state_4813[(8)]);
var inst_4715__$1 = calc_state.call(null);
var inst_4717 = (inst_4715__$1 == null);
var inst_4718 = cljs.core.not.call(null,inst_4717);
var state_4813__$1 = (function (){var statearr_4818 = state_4813;
(statearr_4818[(8)] = inst_4715__$1);

return statearr_4818;
})();
if(inst_4718){
var statearr_4819_4877 = state_4813__$1;
(statearr_4819_4877[(1)] = (2));

} else {
var statearr_4820_4878 = state_4813__$1;
(statearr_4820_4878[(1)] = (3));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (24))){
var inst_4773 = (state_4813[(9)]);
var inst_4787 = (state_4813[(10)]);
var inst_4764 = (state_4813[(11)]);
var inst_4787__$1 = inst_4764.call(null,inst_4773);
var state_4813__$1 = (function (){var statearr_4821 = state_4813;
(statearr_4821[(10)] = inst_4787__$1);

return statearr_4821;
})();
if(cljs.core.truth_(inst_4787__$1)){
var statearr_4822_4879 = state_4813__$1;
(statearr_4822_4879[(1)] = (29));

} else {
var statearr_4823_4880 = state_4813__$1;
(statearr_4823_4880[(1)] = (30));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (4))){
var inst_4731 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4731)){
var statearr_4824_4881 = state_4813__$1;
(statearr_4824_4881[(1)] = (8));

} else {
var statearr_4825_4882 = state_4813__$1;
(statearr_4825_4882[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (15))){
var inst_4758 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4758)){
var statearr_4826_4883 = state_4813__$1;
(statearr_4826_4883[(1)] = (19));

} else {
var statearr_4827_4884 = state_4813__$1;
(statearr_4827_4884[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (21))){
var inst_4763 = (state_4813[(12)]);
var inst_4763__$1 = (state_4813[(2)]);
var inst_4764 = cljs.core.get.call(null,inst_4763__$1,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_4765 = cljs.core.get.call(null,inst_4763__$1,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_4766 = cljs.core.get.call(null,inst_4763__$1,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var state_4813__$1 = (function (){var statearr_4828 = state_4813;
(statearr_4828[(13)] = inst_4765);

(statearr_4828[(12)] = inst_4763__$1);

(statearr_4828[(11)] = inst_4764);

return statearr_4828;
})();
return cljs.core.async.ioc_alts_BANG_.call(null,state_4813__$1,(22),inst_4766);
} else {
if((state_val_4814 === (31))){
var inst_4795 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4795)){
var statearr_4829_4885 = state_4813__$1;
(statearr_4829_4885[(1)] = (32));

} else {
var statearr_4830_4886 = state_4813__$1;
(statearr_4830_4886[(1)] = (33));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (32))){
var inst_4772 = (state_4813[(14)]);
var state_4813__$1 = state_4813;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_4813__$1,(35),out,inst_4772);
} else {
if((state_val_4814 === (33))){
var inst_4763 = (state_4813[(12)]);
var inst_4740 = inst_4763;
var state_4813__$1 = (function (){var statearr_4831 = state_4813;
(statearr_4831[(7)] = inst_4740);

return statearr_4831;
})();
var statearr_4832_4887 = state_4813__$1;
(statearr_4832_4887[(2)] = null);

(statearr_4832_4887[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (13))){
var inst_4740 = (state_4813[(7)]);
var inst_4747 = inst_4740.cljs$lang$protocol_mask$partition0$;
var inst_4748 = (inst_4747 & (64));
var inst_4749 = inst_4740.cljs$core$ISeq$;
var inst_4750 = (cljs.core.PROTOCOL_SENTINEL === inst_4749);
var inst_4751 = ((inst_4748) || (inst_4750));
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4751)){
var statearr_4833_4888 = state_4813__$1;
(statearr_4833_4888[(1)] = (16));

} else {
var statearr_4834_4889 = state_4813__$1;
(statearr_4834_4889[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (22))){
var inst_4773 = (state_4813[(9)]);
var inst_4772 = (state_4813[(14)]);
var inst_4771 = (state_4813[(2)]);
var inst_4772__$1 = cljs.core.nth.call(null,inst_4771,(0),null);
var inst_4773__$1 = cljs.core.nth.call(null,inst_4771,(1),null);
var inst_4774 = (inst_4772__$1 == null);
var inst_4775 = cljs.core._EQ_.call(null,inst_4773__$1,change);
var inst_4776 = ((inst_4774) || (inst_4775));
var state_4813__$1 = (function (){var statearr_4835 = state_4813;
(statearr_4835[(9)] = inst_4773__$1);

(statearr_4835[(14)] = inst_4772__$1);

return statearr_4835;
})();
if(cljs.core.truth_(inst_4776)){
var statearr_4836_4890 = state_4813__$1;
(statearr_4836_4890[(1)] = (23));

} else {
var statearr_4837_4891 = state_4813__$1;
(statearr_4837_4891[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (36))){
var inst_4763 = (state_4813[(12)]);
var inst_4740 = inst_4763;
var state_4813__$1 = (function (){var statearr_4838 = state_4813;
(statearr_4838[(7)] = inst_4740);

return statearr_4838;
})();
var statearr_4839_4892 = state_4813__$1;
(statearr_4839_4892[(2)] = null);

(statearr_4839_4892[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (29))){
var inst_4787 = (state_4813[(10)]);
var state_4813__$1 = state_4813;
var statearr_4840_4893 = state_4813__$1;
(statearr_4840_4893[(2)] = inst_4787);

(statearr_4840_4893[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (6))){
var state_4813__$1 = state_4813;
var statearr_4841_4894 = state_4813__$1;
(statearr_4841_4894[(2)] = false);

(statearr_4841_4894[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (28))){
var inst_4783 = (state_4813[(2)]);
var inst_4784 = calc_state.call(null);
var inst_4740 = inst_4784;
var state_4813__$1 = (function (){var statearr_4842 = state_4813;
(statearr_4842[(7)] = inst_4740);

(statearr_4842[(15)] = inst_4783);

return statearr_4842;
})();
var statearr_4843_4895 = state_4813__$1;
(statearr_4843_4895[(2)] = null);

(statearr_4843_4895[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (25))){
var inst_4809 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
var statearr_4844_4896 = state_4813__$1;
(statearr_4844_4896[(2)] = inst_4809);

(statearr_4844_4896[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (34))){
var inst_4807 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
var statearr_4845_4897 = state_4813__$1;
(statearr_4845_4897[(2)] = inst_4807);

(statearr_4845_4897[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (17))){
var state_4813__$1 = state_4813;
var statearr_4846_4898 = state_4813__$1;
(statearr_4846_4898[(2)] = false);

(statearr_4846_4898[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (3))){
var state_4813__$1 = state_4813;
var statearr_4847_4899 = state_4813__$1;
(statearr_4847_4899[(2)] = false);

(statearr_4847_4899[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (12))){
var inst_4811 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_4813__$1,inst_4811);
} else {
if((state_val_4814 === (2))){
var inst_4715 = (state_4813[(8)]);
var inst_4720 = inst_4715.cljs$lang$protocol_mask$partition0$;
var inst_4721 = (inst_4720 & (64));
var inst_4722 = inst_4715.cljs$core$ISeq$;
var inst_4723 = (cljs.core.PROTOCOL_SENTINEL === inst_4722);
var inst_4724 = ((inst_4721) || (inst_4723));
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4724)){
var statearr_4848_4900 = state_4813__$1;
(statearr_4848_4900[(1)] = (5));

} else {
var statearr_4849_4901 = state_4813__$1;
(statearr_4849_4901[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (23))){
var inst_4772 = (state_4813[(14)]);
var inst_4778 = (inst_4772 == null);
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4778)){
var statearr_4850_4902 = state_4813__$1;
(statearr_4850_4902[(1)] = (26));

} else {
var statearr_4851_4903 = state_4813__$1;
(statearr_4851_4903[(1)] = (27));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (35))){
var inst_4798 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
if(cljs.core.truth_(inst_4798)){
var statearr_4852_4904 = state_4813__$1;
(statearr_4852_4904[(1)] = (36));

} else {
var statearr_4853_4905 = state_4813__$1;
(statearr_4853_4905[(1)] = (37));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (19))){
var inst_4740 = (state_4813[(7)]);
var inst_4760 = cljs.core.apply.call(null,cljs.core.hash_map,inst_4740);
var state_4813__$1 = state_4813;
var statearr_4854_4906 = state_4813__$1;
(statearr_4854_4906[(2)] = inst_4760);

(statearr_4854_4906[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (11))){
var inst_4740 = (state_4813[(7)]);
var inst_4744 = (inst_4740 == null);
var inst_4745 = cljs.core.not.call(null,inst_4744);
var state_4813__$1 = state_4813;
if(inst_4745){
var statearr_4855_4907 = state_4813__$1;
(statearr_4855_4907[(1)] = (13));

} else {
var statearr_4856_4908 = state_4813__$1;
(statearr_4856_4908[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (9))){
var inst_4715 = (state_4813[(8)]);
var state_4813__$1 = state_4813;
var statearr_4857_4909 = state_4813__$1;
(statearr_4857_4909[(2)] = inst_4715);

(statearr_4857_4909[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (5))){
var state_4813__$1 = state_4813;
var statearr_4858_4910 = state_4813__$1;
(statearr_4858_4910[(2)] = true);

(statearr_4858_4910[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (14))){
var state_4813__$1 = state_4813;
var statearr_4859_4911 = state_4813__$1;
(statearr_4859_4911[(2)] = false);

(statearr_4859_4911[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (26))){
var inst_4773 = (state_4813[(9)]);
var inst_4780 = cljs.core.swap_BANG_.call(null,cs,cljs.core.dissoc,inst_4773);
var state_4813__$1 = state_4813;
var statearr_4860_4912 = state_4813__$1;
(statearr_4860_4912[(2)] = inst_4780);

(statearr_4860_4912[(1)] = (28));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (16))){
var state_4813__$1 = state_4813;
var statearr_4861_4913 = state_4813__$1;
(statearr_4861_4913[(2)] = true);

(statearr_4861_4913[(1)] = (18));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (38))){
var inst_4803 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
var statearr_4862_4914 = state_4813__$1;
(statearr_4862_4914[(2)] = inst_4803);

(statearr_4862_4914[(1)] = (34));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (30))){
var inst_4773 = (state_4813[(9)]);
var inst_4765 = (state_4813[(13)]);
var inst_4764 = (state_4813[(11)]);
var inst_4790 = cljs.core.empty_QMARK_.call(null,inst_4764);
var inst_4791 = inst_4765.call(null,inst_4773);
var inst_4792 = cljs.core.not.call(null,inst_4791);
var inst_4793 = ((inst_4790) && (inst_4792));
var state_4813__$1 = state_4813;
var statearr_4863_4915 = state_4813__$1;
(statearr_4863_4915[(2)] = inst_4793);

(statearr_4863_4915[(1)] = (31));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (10))){
var inst_4715 = (state_4813[(8)]);
var inst_4736 = (state_4813[(2)]);
var inst_4737 = cljs.core.get.call(null,inst_4736,new cljs.core.Keyword(null,"solos","solos",1441458643));
var inst_4738 = cljs.core.get.call(null,inst_4736,new cljs.core.Keyword(null,"mutes","mutes",1068806309));
var inst_4739 = cljs.core.get.call(null,inst_4736,new cljs.core.Keyword(null,"reads","reads",-1215067361));
var inst_4740 = inst_4715;
var state_4813__$1 = (function (){var statearr_4864 = state_4813;
(statearr_4864[(16)] = inst_4738);

(statearr_4864[(17)] = inst_4737);

(statearr_4864[(7)] = inst_4740);

(statearr_4864[(18)] = inst_4739);

return statearr_4864;
})();
var statearr_4865_4916 = state_4813__$1;
(statearr_4865_4916[(2)] = null);

(statearr_4865_4916[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (18))){
var inst_4755 = (state_4813[(2)]);
var state_4813__$1 = state_4813;
var statearr_4866_4917 = state_4813__$1;
(statearr_4866_4917[(2)] = inst_4755);

(statearr_4866_4917[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (37))){
var state_4813__$1 = state_4813;
var statearr_4867_4918 = state_4813__$1;
(statearr_4867_4918[(2)] = null);

(statearr_4867_4918[(1)] = (38));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_4814 === (8))){
var inst_4715 = (state_4813[(8)]);
var inst_4733 = cljs.core.apply.call(null,cljs.core.hash_map,inst_4715);
var state_4813__$1 = state_4813;
var statearr_4868_4919 = state_4813__$1;
(statearr_4868_4919[(2)] = inst_4733);

(statearr_4868_4919[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___4873,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
;
return ((function (switch__3724__auto__,c__3814__auto___4873,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m){
return (function() {
var cljs$core$async$mix_$_state_machine__3725__auto__ = null;
var cljs$core$async$mix_$_state_machine__3725__auto____0 = (function (){
var statearr_4869 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_4869[(0)] = cljs$core$async$mix_$_state_machine__3725__auto__);

(statearr_4869[(1)] = (1));

return statearr_4869;
});
var cljs$core$async$mix_$_state_machine__3725__auto____1 = (function (state_4813){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_4813);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e4870){if((e4870 instanceof Object)){
var ex__3728__auto__ = e4870;
var statearr_4871_4920 = state_4813;
(statearr_4871_4920[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_4813);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e4870;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__4921 = state_4813;
state_4813 = G__4921;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$mix_$_state_machine__3725__auto__ = function(state_4813){
switch(arguments.length){
case 0:
return cljs$core$async$mix_$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$mix_$_state_machine__3725__auto____1.call(this,state_4813);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mix_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mix_$_state_machine__3725__auto____0;
cljs$core$async$mix_$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mix_$_state_machine__3725__auto____1;
return cljs$core$async$mix_$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___4873,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
})();
var state__3816__auto__ = (function (){var statearr_4872 = f__3815__auto__.call(null);
(statearr_4872[(6)] = c__3814__auto___4873);

return statearr_4872;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___4873,cs,solo_modes,attrs,solo_mode,change,changed,pick,calc_state,m))
);


return m;
});
/**
 * Adds ch as an input to the mix
 */
cljs.core.async.admix = (function cljs$core$async$admix(mix,ch){
return cljs.core.async.admix_STAR_.call(null,mix,ch);
});
/**
 * Removes ch as an input to the mix
 */
cljs.core.async.unmix = (function cljs$core$async$unmix(mix,ch){
return cljs.core.async.unmix_STAR_.call(null,mix,ch);
});
/**
 * removes all inputs from the mix
 */
cljs.core.async.unmix_all = (function cljs$core$async$unmix_all(mix){
return cljs.core.async.unmix_all_STAR_.call(null,mix);
});
/**
 * Atomically sets the state(s) of one or more channels in a mix. The
 *   state map is a map of channels -> channel-state-map. A
 *   channel-state-map is a map of attrs -> boolean, where attr is one or
 *   more of :mute, :pause or :solo. Any states supplied are merged with
 *   the current state.
 * 
 *   Note that channels can be added to a mix via toggle, which can be
 *   used to add channels in a particular (e.g. paused) state.
 */
cljs.core.async.toggle = (function cljs$core$async$toggle(mix,state_map){
return cljs.core.async.toggle_STAR_.call(null,mix,state_map);
});
/**
 * Sets the solo mode of the mix. mode must be one of :mute or :pause
 */
cljs.core.async.solo_mode = (function cljs$core$async$solo_mode(mix,mode){
return cljs.core.async.solo_mode_STAR_.call(null,mix,mode);
});

/**
 * @interface
 */
cljs.core.async.Pub = function(){};

cljs.core.async.sub_STAR_ = (function cljs$core$async$sub_STAR_(p,v,ch,close_QMARK_){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$sub_STAR_$arity$4 == null))))){
return p.cljs$core$async$Pub$sub_STAR_$arity$4(p,v,ch,close_QMARK_);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.sub_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v,ch,close_QMARK_);
} else {
var m__4212__auto____$1 = (cljs.core.async.sub_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v,ch,close_QMARK_);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.sub*",p);
}
}
}
});

cljs.core.async.unsub_STAR_ = (function cljs$core$async$unsub_STAR_(p,v,ch){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_STAR_$arity$3 == null))))){
return p.cljs$core$async$Pub$unsub_STAR_$arity$3(p,v,ch);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v,ch);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v,ch);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_ = (function cljs$core$async$unsub_all_STAR_(var_args){
var G__4923 = arguments.length;
switch (G__4923) {
case 1:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$1 = (function (p){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$1 == null))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$1(p);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$core$IFn$_invoke$arity$2 = (function (p,v){
if(((!((p == null))) && (!((p.cljs$core$async$Pub$unsub_all_STAR_$arity$2 == null))))){
return p.cljs$core$async$Pub$unsub_all_STAR_$arity$2(p,v);
} else {
var x__4211__auto__ = (((p == null))?null:p);
var m__4212__auto__ = (cljs.core.async.unsub_all_STAR_[goog.typeOf(x__4211__auto__)]);
if(!((m__4212__auto__ == null))){
return m__4212__auto__.call(null,p,v);
} else {
var m__4212__auto____$1 = (cljs.core.async.unsub_all_STAR_["_"]);
if(!((m__4212__auto____$1 == null))){
return m__4212__auto____$1.call(null,p,v);
} else {
throw cljs.core.missing_protocol.call(null,"Pub.unsub-all*",p);
}
}
}
});

cljs.core.async.unsub_all_STAR_.cljs$lang$maxFixedArity = 2;


/**
 * Creates and returns a pub(lication) of the supplied channel,
 *   partitioned into topics by the topic-fn. topic-fn will be applied to
 *   each value on the channel and the result will determine the 'topic'
 *   on which that value will be put. Channels can be subscribed to
 *   receive copies of topics using 'sub', and unsubscribed using
 *   'unsub'. Each topic will be handled by an internal mult on a
 *   dedicated channel. By default these internal channels are
 *   unbuffered, but a buf-fn can be supplied which, given a topic,
 *   creates a buffer with desired properties.
 * 
 *   Each item is distributed to all subs in parallel and synchronously,
 *   i.e. each sub must accept before the next item is distributed. Use
 *   buffering/windowing to prevent slow subs from holding up the pub.
 * 
 *   Items received when there are no matching subs get dropped.
 * 
 *   Note that if buf-fns are used then each topic is handled
 *   asynchronously, i.e. if a channel is subscribed to more than one
 *   topic it should not expect them to be interleaved identically with
 *   the source.
 */
cljs.core.async.pub = (function cljs$core$async$pub(var_args){
var G__4927 = arguments.length;
switch (G__4927) {
case 2:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$2 = (function (ch,topic_fn){
return cljs.core.async.pub.call(null,ch,topic_fn,cljs.core.constantly.call(null,null));
});

cljs.core.async.pub.cljs$core$IFn$_invoke$arity$3 = (function (ch,topic_fn,buf_fn){
var mults = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
var ensure_mult = ((function (mults){
return (function (topic){
var or__3922__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,mults),topic);
if(cljs.core.truth_(or__3922__auto__)){
return or__3922__auto__;
} else {
return cljs.core.get.call(null,cljs.core.swap_BANG_.call(null,mults,((function (or__3922__auto__,mults){
return (function (p1__4925_SHARP_){
if(cljs.core.truth_(p1__4925_SHARP_.call(null,topic))){
return p1__4925_SHARP_;
} else {
return cljs.core.assoc.call(null,p1__4925_SHARP_,topic,cljs.core.async.mult.call(null,cljs.core.async.chan.call(null,buf_fn.call(null,topic))));
}
});})(or__3922__auto__,mults))
),topic);
}
});})(mults))
;
var p = (function (){
if(typeof cljs.core.async.t_cljs$core$async4928 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.Pub}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.async.Mux}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async4928 = (function (ch,topic_fn,buf_fn,mults,ensure_mult,meta4929){
this.ch = ch;
this.topic_fn = topic_fn;
this.buf_fn = buf_fn;
this.mults = mults;
this.ensure_mult = ensure_mult;
this.meta4929 = meta4929;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (mults,ensure_mult){
return (function (_4930,meta4929__$1){
var self__ = this;
var _4930__$1 = this;
return (new cljs.core.async.t_cljs$core$async4928(self__.ch,self__.topic_fn,self__.buf_fn,self__.mults,self__.ensure_mult,meta4929__$1));
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (mults,ensure_mult){
return (function (_4930){
var self__ = this;
var _4930__$1 = this;
return self__.meta4929;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Mux$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Mux$muxch_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return self__.ch;
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Pub$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Pub$sub_STAR_$arity$4 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1,close_QMARK_){
var self__ = this;
var p__$1 = this;
var m = self__.ensure_mult.call(null,topic);
return cljs.core.async.tap.call(null,m,ch__$1,close_QMARK_);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Pub$unsub_STAR_$arity$3 = ((function (mults,ensure_mult){
return (function (p,topic,ch__$1){
var self__ = this;
var p__$1 = this;
var temp__5457__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,self__.mults),topic);
if(cljs.core.truth_(temp__5457__auto__)){
var m = temp__5457__auto__;
return cljs.core.async.untap.call(null,m,ch__$1);
} else {
return null;
}
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$1 = ((function (mults,ensure_mult){
return (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.reset_BANG_.call(null,self__.mults,cljs.core.PersistentArrayMap.EMPTY);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.prototype.cljs$core$async$Pub$unsub_all_STAR_$arity$2 = ((function (mults,ensure_mult){
return (function (_,topic){
var self__ = this;
var ___$1 = this;
return cljs.core.swap_BANG_.call(null,self__.mults,cljs.core.dissoc,topic);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.getBasis = ((function (mults,ensure_mult){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"topic-fn","topic-fn",-862449736,null),new cljs.core.Symbol(null,"buf-fn","buf-fn",-1200281591,null),new cljs.core.Symbol(null,"mults","mults",-461114485,null),new cljs.core.Symbol(null,"ensure-mult","ensure-mult",1796584816,null),new cljs.core.Symbol(null,"meta4929","meta4929",726905924,null)], null);
});})(mults,ensure_mult))
;

cljs.core.async.t_cljs$core$async4928.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async4928.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async4928";

cljs.core.async.t_cljs$core$async4928.cljs$lang$ctorPrWriter = ((function (mults,ensure_mult){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async4928");
});})(mults,ensure_mult))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async4928.
 */
cljs.core.async.__GT_t_cljs$core$async4928 = ((function (mults,ensure_mult){
return (function cljs$core$async$__GT_t_cljs$core$async4928(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta4929){
return (new cljs.core.async.t_cljs$core$async4928(ch__$1,topic_fn__$1,buf_fn__$1,mults__$1,ensure_mult__$1,meta4929));
});})(mults,ensure_mult))
;

}

return (new cljs.core.async.t_cljs$core$async4928(ch,topic_fn,buf_fn,mults,ensure_mult,cljs.core.PersistentArrayMap.EMPTY));
})()
;
var c__3814__auto___5048 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5048,mults,ensure_mult,p){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5048,mults,ensure_mult,p){
return (function (state_5002){
var state_val_5003 = (state_5002[(1)]);
if((state_val_5003 === (7))){
var inst_4998 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
var statearr_5004_5049 = state_5002__$1;
(statearr_5004_5049[(2)] = inst_4998);

(statearr_5004_5049[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (20))){
var state_5002__$1 = state_5002;
var statearr_5005_5050 = state_5002__$1;
(statearr_5005_5050[(2)] = null);

(statearr_5005_5050[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (1))){
var state_5002__$1 = state_5002;
var statearr_5006_5051 = state_5002__$1;
(statearr_5006_5051[(2)] = null);

(statearr_5006_5051[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (24))){
var inst_4981 = (state_5002[(7)]);
var inst_4990 = cljs.core.swap_BANG_.call(null,mults,cljs.core.dissoc,inst_4981);
var state_5002__$1 = state_5002;
var statearr_5007_5052 = state_5002__$1;
(statearr_5007_5052[(2)] = inst_4990);

(statearr_5007_5052[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (4))){
var inst_4933 = (state_5002[(8)]);
var inst_4933__$1 = (state_5002[(2)]);
var inst_4934 = (inst_4933__$1 == null);
var state_5002__$1 = (function (){var statearr_5008 = state_5002;
(statearr_5008[(8)] = inst_4933__$1);

return statearr_5008;
})();
if(cljs.core.truth_(inst_4934)){
var statearr_5009_5053 = state_5002__$1;
(statearr_5009_5053[(1)] = (5));

} else {
var statearr_5010_5054 = state_5002__$1;
(statearr_5010_5054[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (15))){
var inst_4975 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
var statearr_5011_5055 = state_5002__$1;
(statearr_5011_5055[(2)] = inst_4975);

(statearr_5011_5055[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (21))){
var inst_4995 = (state_5002[(2)]);
var state_5002__$1 = (function (){var statearr_5012 = state_5002;
(statearr_5012[(9)] = inst_4995);

return statearr_5012;
})();
var statearr_5013_5056 = state_5002__$1;
(statearr_5013_5056[(2)] = null);

(statearr_5013_5056[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (13))){
var inst_4957 = (state_5002[(10)]);
var inst_4959 = cljs.core.chunked_seq_QMARK_.call(null,inst_4957);
var state_5002__$1 = state_5002;
if(inst_4959){
var statearr_5014_5057 = state_5002__$1;
(statearr_5014_5057[(1)] = (16));

} else {
var statearr_5015_5058 = state_5002__$1;
(statearr_5015_5058[(1)] = (17));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (22))){
var inst_4987 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
if(cljs.core.truth_(inst_4987)){
var statearr_5016_5059 = state_5002__$1;
(statearr_5016_5059[(1)] = (23));

} else {
var statearr_5017_5060 = state_5002__$1;
(statearr_5017_5060[(1)] = (24));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (6))){
var inst_4981 = (state_5002[(7)]);
var inst_4983 = (state_5002[(11)]);
var inst_4933 = (state_5002[(8)]);
var inst_4981__$1 = topic_fn.call(null,inst_4933);
var inst_4982 = cljs.core.deref.call(null,mults);
var inst_4983__$1 = cljs.core.get.call(null,inst_4982,inst_4981__$1);
var state_5002__$1 = (function (){var statearr_5018 = state_5002;
(statearr_5018[(7)] = inst_4981__$1);

(statearr_5018[(11)] = inst_4983__$1);

return statearr_5018;
})();
if(cljs.core.truth_(inst_4983__$1)){
var statearr_5019_5061 = state_5002__$1;
(statearr_5019_5061[(1)] = (19));

} else {
var statearr_5020_5062 = state_5002__$1;
(statearr_5020_5062[(1)] = (20));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (25))){
var inst_4992 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
var statearr_5021_5063 = state_5002__$1;
(statearr_5021_5063[(2)] = inst_4992);

(statearr_5021_5063[(1)] = (21));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (17))){
var inst_4957 = (state_5002[(10)]);
var inst_4966 = cljs.core.first.call(null,inst_4957);
var inst_4967 = cljs.core.async.muxch_STAR_.call(null,inst_4966);
var inst_4968 = cljs.core.async.close_BANG_.call(null,inst_4967);
var inst_4969 = cljs.core.next.call(null,inst_4957);
var inst_4943 = inst_4969;
var inst_4944 = null;
var inst_4945 = (0);
var inst_4946 = (0);
var state_5002__$1 = (function (){var statearr_5022 = state_5002;
(statearr_5022[(12)] = inst_4945);

(statearr_5022[(13)] = inst_4944);

(statearr_5022[(14)] = inst_4946);

(statearr_5022[(15)] = inst_4968);

(statearr_5022[(16)] = inst_4943);

return statearr_5022;
})();
var statearr_5023_5064 = state_5002__$1;
(statearr_5023_5064[(2)] = null);

(statearr_5023_5064[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (3))){
var inst_5000 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5002__$1,inst_5000);
} else {
if((state_val_5003 === (12))){
var inst_4977 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
var statearr_5024_5065 = state_5002__$1;
(statearr_5024_5065[(2)] = inst_4977);

(statearr_5024_5065[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (2))){
var state_5002__$1 = state_5002;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5002__$1,(4),ch);
} else {
if((state_val_5003 === (23))){
var state_5002__$1 = state_5002;
var statearr_5025_5066 = state_5002__$1;
(statearr_5025_5066[(2)] = null);

(statearr_5025_5066[(1)] = (25));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (19))){
var inst_4983 = (state_5002[(11)]);
var inst_4933 = (state_5002[(8)]);
var inst_4985 = cljs.core.async.muxch_STAR_.call(null,inst_4983);
var state_5002__$1 = state_5002;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5002__$1,(22),inst_4985,inst_4933);
} else {
if((state_val_5003 === (11))){
var inst_4943 = (state_5002[(16)]);
var inst_4957 = (state_5002[(10)]);
var inst_4957__$1 = cljs.core.seq.call(null,inst_4943);
var state_5002__$1 = (function (){var statearr_5026 = state_5002;
(statearr_5026[(10)] = inst_4957__$1);

return statearr_5026;
})();
if(inst_4957__$1){
var statearr_5027_5067 = state_5002__$1;
(statearr_5027_5067[(1)] = (13));

} else {
var statearr_5028_5068 = state_5002__$1;
(statearr_5028_5068[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (9))){
var inst_4979 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
var statearr_5029_5069 = state_5002__$1;
(statearr_5029_5069[(2)] = inst_4979);

(statearr_5029_5069[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (5))){
var inst_4940 = cljs.core.deref.call(null,mults);
var inst_4941 = cljs.core.vals.call(null,inst_4940);
var inst_4942 = cljs.core.seq.call(null,inst_4941);
var inst_4943 = inst_4942;
var inst_4944 = null;
var inst_4945 = (0);
var inst_4946 = (0);
var state_5002__$1 = (function (){var statearr_5030 = state_5002;
(statearr_5030[(12)] = inst_4945);

(statearr_5030[(13)] = inst_4944);

(statearr_5030[(14)] = inst_4946);

(statearr_5030[(16)] = inst_4943);

return statearr_5030;
})();
var statearr_5031_5070 = state_5002__$1;
(statearr_5031_5070[(2)] = null);

(statearr_5031_5070[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (14))){
var state_5002__$1 = state_5002;
var statearr_5035_5071 = state_5002__$1;
(statearr_5035_5071[(2)] = null);

(statearr_5035_5071[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (16))){
var inst_4957 = (state_5002[(10)]);
var inst_4961 = cljs.core.chunk_first.call(null,inst_4957);
var inst_4962 = cljs.core.chunk_rest.call(null,inst_4957);
var inst_4963 = cljs.core.count.call(null,inst_4961);
var inst_4943 = inst_4962;
var inst_4944 = inst_4961;
var inst_4945 = inst_4963;
var inst_4946 = (0);
var state_5002__$1 = (function (){var statearr_5036 = state_5002;
(statearr_5036[(12)] = inst_4945);

(statearr_5036[(13)] = inst_4944);

(statearr_5036[(14)] = inst_4946);

(statearr_5036[(16)] = inst_4943);

return statearr_5036;
})();
var statearr_5037_5072 = state_5002__$1;
(statearr_5037_5072[(2)] = null);

(statearr_5037_5072[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (10))){
var inst_4945 = (state_5002[(12)]);
var inst_4944 = (state_5002[(13)]);
var inst_4946 = (state_5002[(14)]);
var inst_4943 = (state_5002[(16)]);
var inst_4951 = cljs.core._nth.call(null,inst_4944,inst_4946);
var inst_4952 = cljs.core.async.muxch_STAR_.call(null,inst_4951);
var inst_4953 = cljs.core.async.close_BANG_.call(null,inst_4952);
var inst_4954 = (inst_4946 + (1));
var tmp5032 = inst_4945;
var tmp5033 = inst_4944;
var tmp5034 = inst_4943;
var inst_4943__$1 = tmp5034;
var inst_4944__$1 = tmp5033;
var inst_4945__$1 = tmp5032;
var inst_4946__$1 = inst_4954;
var state_5002__$1 = (function (){var statearr_5038 = state_5002;
(statearr_5038[(12)] = inst_4945__$1);

(statearr_5038[(13)] = inst_4944__$1);

(statearr_5038[(17)] = inst_4953);

(statearr_5038[(14)] = inst_4946__$1);

(statearr_5038[(16)] = inst_4943__$1);

return statearr_5038;
})();
var statearr_5039_5073 = state_5002__$1;
(statearr_5039_5073[(2)] = null);

(statearr_5039_5073[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (18))){
var inst_4972 = (state_5002[(2)]);
var state_5002__$1 = state_5002;
var statearr_5040_5074 = state_5002__$1;
(statearr_5040_5074[(2)] = inst_4972);

(statearr_5040_5074[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5003 === (8))){
var inst_4945 = (state_5002[(12)]);
var inst_4946 = (state_5002[(14)]);
var inst_4948 = (inst_4946 < inst_4945);
var inst_4949 = inst_4948;
var state_5002__$1 = state_5002;
if(cljs.core.truth_(inst_4949)){
var statearr_5041_5075 = state_5002__$1;
(statearr_5041_5075[(1)] = (10));

} else {
var statearr_5042_5076 = state_5002__$1;
(statearr_5042_5076[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5048,mults,ensure_mult,p))
;
return ((function (switch__3724__auto__,c__3814__auto___5048,mults,ensure_mult,p){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5043 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5043[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5043[(1)] = (1));

return statearr_5043;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5002){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5002);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5044){if((e5044 instanceof Object)){
var ex__3728__auto__ = e5044;
var statearr_5045_5077 = state_5002;
(statearr_5045_5077[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5002);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5044;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5078 = state_5002;
state_5002 = G__5078;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5002){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5002);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5048,mults,ensure_mult,p))
})();
var state__3816__auto__ = (function (){var statearr_5046 = f__3815__auto__.call(null);
(statearr_5046[(6)] = c__3814__auto___5048);

return statearr_5046;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5048,mults,ensure_mult,p))
);


return p;
});

cljs.core.async.pub.cljs$lang$maxFixedArity = 3;

/**
 * Subscribes a channel to a topic of a pub.
 * 
 *   By default the channel will be closed when the source closes,
 *   but can be determined by the close? parameter.
 */
cljs.core.async.sub = (function cljs$core$async$sub(var_args){
var G__5080 = arguments.length;
switch (G__5080) {
case 3:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
case 4:
return cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4((arguments[(0)]),(arguments[(1)]),(arguments[(2)]),(arguments[(3)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$3 = (function (p,topic,ch){
return cljs.core.async.sub.call(null,p,topic,ch,true);
});

cljs.core.async.sub.cljs$core$IFn$_invoke$arity$4 = (function (p,topic,ch,close_QMARK_){
return cljs.core.async.sub_STAR_.call(null,p,topic,ch,close_QMARK_);
});

cljs.core.async.sub.cljs$lang$maxFixedArity = 4;

/**
 * Unsubscribes a channel from a topic of a pub
 */
cljs.core.async.unsub = (function cljs$core$async$unsub(p,topic,ch){
return cljs.core.async.unsub_STAR_.call(null,p,topic,ch);
});
/**
 * Unsubscribes all channels from a pub, or a topic of a pub
 */
cljs.core.async.unsub_all = (function cljs$core$async$unsub_all(var_args){
var G__5083 = arguments.length;
switch (G__5083) {
case 1:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$1 = (function (p){
return cljs.core.async.unsub_all_STAR_.call(null,p);
});

cljs.core.async.unsub_all.cljs$core$IFn$_invoke$arity$2 = (function (p,topic){
return cljs.core.async.unsub_all_STAR_.call(null,p,topic);
});

cljs.core.async.unsub_all.cljs$lang$maxFixedArity = 2;

/**
 * Takes a function and a collection of source channels, and returns a
 *   channel which contains the values produced by applying f to the set
 *   of first items taken from each source channel, followed by applying
 *   f to the set of second items from each channel, until any one of the
 *   channels is closed, at which point the output channel will be
 *   closed. The returned channel will be unbuffered by default, or a
 *   buf-or-n can be supplied
 */
cljs.core.async.map = (function cljs$core$async$map(var_args){
var G__5086 = arguments.length;
switch (G__5086) {
case 2:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.map.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$2 = (function (f,chs){
return cljs.core.async.map.call(null,f,chs,null);
});

cljs.core.async.map.cljs$core$IFn$_invoke$arity$3 = (function (f,chs,buf_or_n){
var chs__$1 = cljs.core.vec.call(null,chs);
var out = cljs.core.async.chan.call(null,buf_or_n);
var cnt = cljs.core.count.call(null,chs__$1);
var rets = cljs.core.object_array.call(null,cnt);
var dchan = cljs.core.async.chan.call(null,(1));
var dctr = cljs.core.atom.call(null,null);
var done = cljs.core.mapv.call(null,((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (i){
return ((function (chs__$1,out,cnt,rets,dchan,dctr){
return (function (ret){
(rets[i] = ret);

if((cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec) === (0))){
return cljs.core.async.put_BANG_.call(null,dchan,rets.slice((0)));
} else {
return null;
}
});
;})(chs__$1,out,cnt,rets,dchan,dctr))
});})(chs__$1,out,cnt,rets,dchan,dctr))
,cljs.core.range.call(null,cnt));
var c__3814__auto___5153 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5153,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5153,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function (state_5125){
var state_val_5126 = (state_5125[(1)]);
if((state_val_5126 === (7))){
var state_5125__$1 = state_5125;
var statearr_5127_5154 = state_5125__$1;
(statearr_5127_5154[(2)] = null);

(statearr_5127_5154[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (1))){
var state_5125__$1 = state_5125;
var statearr_5128_5155 = state_5125__$1;
(statearr_5128_5155[(2)] = null);

(statearr_5128_5155[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (4))){
var inst_5089 = (state_5125[(7)]);
var inst_5091 = (inst_5089 < cnt);
var state_5125__$1 = state_5125;
if(cljs.core.truth_(inst_5091)){
var statearr_5129_5156 = state_5125__$1;
(statearr_5129_5156[(1)] = (6));

} else {
var statearr_5130_5157 = state_5125__$1;
(statearr_5130_5157[(1)] = (7));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (15))){
var inst_5121 = (state_5125[(2)]);
var state_5125__$1 = state_5125;
var statearr_5131_5158 = state_5125__$1;
(statearr_5131_5158[(2)] = inst_5121);

(statearr_5131_5158[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (13))){
var inst_5114 = cljs.core.async.close_BANG_.call(null,out);
var state_5125__$1 = state_5125;
var statearr_5132_5159 = state_5125__$1;
(statearr_5132_5159[(2)] = inst_5114);

(statearr_5132_5159[(1)] = (15));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (6))){
var state_5125__$1 = state_5125;
var statearr_5133_5160 = state_5125__$1;
(statearr_5133_5160[(2)] = null);

(statearr_5133_5160[(1)] = (11));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (3))){
var inst_5123 = (state_5125[(2)]);
var state_5125__$1 = state_5125;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5125__$1,inst_5123);
} else {
if((state_val_5126 === (12))){
var inst_5111 = (state_5125[(8)]);
var inst_5111__$1 = (state_5125[(2)]);
var inst_5112 = cljs.core.some.call(null,cljs.core.nil_QMARK_,inst_5111__$1);
var state_5125__$1 = (function (){var statearr_5134 = state_5125;
(statearr_5134[(8)] = inst_5111__$1);

return statearr_5134;
})();
if(cljs.core.truth_(inst_5112)){
var statearr_5135_5161 = state_5125__$1;
(statearr_5135_5161[(1)] = (13));

} else {
var statearr_5136_5162 = state_5125__$1;
(statearr_5136_5162[(1)] = (14));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (2))){
var inst_5088 = cljs.core.reset_BANG_.call(null,dctr,cnt);
var inst_5089 = (0);
var state_5125__$1 = (function (){var statearr_5137 = state_5125;
(statearr_5137[(7)] = inst_5089);

(statearr_5137[(9)] = inst_5088);

return statearr_5137;
})();
var statearr_5138_5163 = state_5125__$1;
(statearr_5138_5163[(2)] = null);

(statearr_5138_5163[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (11))){
var inst_5089 = (state_5125[(7)]);
var _ = cljs.core.async.impl.ioc_helpers.add_exception_frame.call(null,state_5125,(10),Object,null,(9));
var inst_5098 = chs__$1.call(null,inst_5089);
var inst_5099 = done.call(null,inst_5089);
var inst_5100 = cljs.core.async.take_BANG_.call(null,inst_5098,inst_5099);
var state_5125__$1 = state_5125;
var statearr_5139_5164 = state_5125__$1;
(statearr_5139_5164[(2)] = inst_5100);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5125__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (9))){
var inst_5089 = (state_5125[(7)]);
var inst_5102 = (state_5125[(2)]);
var inst_5103 = (inst_5089 + (1));
var inst_5089__$1 = inst_5103;
var state_5125__$1 = (function (){var statearr_5140 = state_5125;
(statearr_5140[(10)] = inst_5102);

(statearr_5140[(7)] = inst_5089__$1);

return statearr_5140;
})();
var statearr_5141_5165 = state_5125__$1;
(statearr_5141_5165[(2)] = null);

(statearr_5141_5165[(1)] = (4));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (5))){
var inst_5109 = (state_5125[(2)]);
var state_5125__$1 = (function (){var statearr_5142 = state_5125;
(statearr_5142[(11)] = inst_5109);

return statearr_5142;
})();
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5125__$1,(12),dchan);
} else {
if((state_val_5126 === (14))){
var inst_5111 = (state_5125[(8)]);
var inst_5116 = cljs.core.apply.call(null,f,inst_5111);
var state_5125__$1 = state_5125;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5125__$1,(16),out,inst_5116);
} else {
if((state_val_5126 === (16))){
var inst_5118 = (state_5125[(2)]);
var state_5125__$1 = (function (){var statearr_5143 = state_5125;
(statearr_5143[(12)] = inst_5118);

return statearr_5143;
})();
var statearr_5144_5166 = state_5125__$1;
(statearr_5144_5166[(2)] = null);

(statearr_5144_5166[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (10))){
var inst_5093 = (state_5125[(2)]);
var inst_5094 = cljs.core.swap_BANG_.call(null,dctr,cljs.core.dec);
var state_5125__$1 = (function (){var statearr_5145 = state_5125;
(statearr_5145[(13)] = inst_5093);

return statearr_5145;
})();
var statearr_5146_5167 = state_5125__$1;
(statearr_5146_5167[(2)] = inst_5094);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5125__$1);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5126 === (8))){
var inst_5107 = (state_5125[(2)]);
var state_5125__$1 = state_5125;
var statearr_5147_5168 = state_5125__$1;
(statearr_5147_5168[(2)] = inst_5107);

(statearr_5147_5168[(1)] = (5));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5153,chs__$1,out,cnt,rets,dchan,dctr,done))
;
return ((function (switch__3724__auto__,c__3814__auto___5153,chs__$1,out,cnt,rets,dchan,dctr,done){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5148 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5148[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5148[(1)] = (1));

return statearr_5148;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5125){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5125);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5149){if((e5149 instanceof Object)){
var ex__3728__auto__ = e5149;
var statearr_5150_5169 = state_5125;
(statearr_5150_5169[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5125);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5149;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5170 = state_5125;
state_5125 = G__5170;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5125){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5125);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5153,chs__$1,out,cnt,rets,dchan,dctr,done))
})();
var state__3816__auto__ = (function (){var statearr_5151 = f__3815__auto__.call(null);
(statearr_5151[(6)] = c__3814__auto___5153);

return statearr_5151;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5153,chs__$1,out,cnt,rets,dchan,dctr,done))
);


return out;
});

cljs.core.async.map.cljs$lang$maxFixedArity = 3;

/**
 * Takes a collection of source channels and returns a channel which
 *   contains all values taken from them. The returned channel will be
 *   unbuffered by default, or a buf-or-n can be supplied. The channel
 *   will close after all the source channels have closed.
 */
cljs.core.async.merge = (function cljs$core$async$merge(var_args){
var G__5173 = arguments.length;
switch (G__5173) {
case 1:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$1 = (function (chs){
return cljs.core.async.merge.call(null,chs,null);
});

cljs.core.async.merge.cljs$core$IFn$_invoke$arity$2 = (function (chs,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__3814__auto___5227 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5227,out){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5227,out){
return (function (state_5205){
var state_val_5206 = (state_5205[(1)]);
if((state_val_5206 === (7))){
var inst_5185 = (state_5205[(7)]);
var inst_5184 = (state_5205[(8)]);
var inst_5184__$1 = (state_5205[(2)]);
var inst_5185__$1 = cljs.core.nth.call(null,inst_5184__$1,(0),null);
var inst_5186 = cljs.core.nth.call(null,inst_5184__$1,(1),null);
var inst_5187 = (inst_5185__$1 == null);
var state_5205__$1 = (function (){var statearr_5207 = state_5205;
(statearr_5207[(7)] = inst_5185__$1);

(statearr_5207[(8)] = inst_5184__$1);

(statearr_5207[(9)] = inst_5186);

return statearr_5207;
})();
if(cljs.core.truth_(inst_5187)){
var statearr_5208_5228 = state_5205__$1;
(statearr_5208_5228[(1)] = (8));

} else {
var statearr_5209_5229 = state_5205__$1;
(statearr_5209_5229[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (1))){
var inst_5174 = cljs.core.vec.call(null,chs);
var inst_5175 = inst_5174;
var state_5205__$1 = (function (){var statearr_5210 = state_5205;
(statearr_5210[(10)] = inst_5175);

return statearr_5210;
})();
var statearr_5211_5230 = state_5205__$1;
(statearr_5211_5230[(2)] = null);

(statearr_5211_5230[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (4))){
var inst_5175 = (state_5205[(10)]);
var state_5205__$1 = state_5205;
return cljs.core.async.ioc_alts_BANG_.call(null,state_5205__$1,(7),inst_5175);
} else {
if((state_val_5206 === (6))){
var inst_5201 = (state_5205[(2)]);
var state_5205__$1 = state_5205;
var statearr_5212_5231 = state_5205__$1;
(statearr_5212_5231[(2)] = inst_5201);

(statearr_5212_5231[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (3))){
var inst_5203 = (state_5205[(2)]);
var state_5205__$1 = state_5205;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5205__$1,inst_5203);
} else {
if((state_val_5206 === (2))){
var inst_5175 = (state_5205[(10)]);
var inst_5177 = cljs.core.count.call(null,inst_5175);
var inst_5178 = (inst_5177 > (0));
var state_5205__$1 = state_5205;
if(cljs.core.truth_(inst_5178)){
var statearr_5214_5232 = state_5205__$1;
(statearr_5214_5232[(1)] = (4));

} else {
var statearr_5215_5233 = state_5205__$1;
(statearr_5215_5233[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (11))){
var inst_5175 = (state_5205[(10)]);
var inst_5194 = (state_5205[(2)]);
var tmp5213 = inst_5175;
var inst_5175__$1 = tmp5213;
var state_5205__$1 = (function (){var statearr_5216 = state_5205;
(statearr_5216[(11)] = inst_5194);

(statearr_5216[(10)] = inst_5175__$1);

return statearr_5216;
})();
var statearr_5217_5234 = state_5205__$1;
(statearr_5217_5234[(2)] = null);

(statearr_5217_5234[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (9))){
var inst_5185 = (state_5205[(7)]);
var state_5205__$1 = state_5205;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5205__$1,(11),out,inst_5185);
} else {
if((state_val_5206 === (5))){
var inst_5199 = cljs.core.async.close_BANG_.call(null,out);
var state_5205__$1 = state_5205;
var statearr_5218_5235 = state_5205__$1;
(statearr_5218_5235[(2)] = inst_5199);

(statearr_5218_5235[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (10))){
var inst_5197 = (state_5205[(2)]);
var state_5205__$1 = state_5205;
var statearr_5219_5236 = state_5205__$1;
(statearr_5219_5236[(2)] = inst_5197);

(statearr_5219_5236[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5206 === (8))){
var inst_5185 = (state_5205[(7)]);
var inst_5184 = (state_5205[(8)]);
var inst_5186 = (state_5205[(9)]);
var inst_5175 = (state_5205[(10)]);
var inst_5189 = (function (){var cs = inst_5175;
var vec__5180 = inst_5184;
var v = inst_5185;
var c = inst_5186;
return ((function (cs,vec__5180,v,c,inst_5185,inst_5184,inst_5186,inst_5175,state_val_5206,c__3814__auto___5227,out){
return (function (p1__5171_SHARP_){
return cljs.core.not_EQ_.call(null,c,p1__5171_SHARP_);
});
;})(cs,vec__5180,v,c,inst_5185,inst_5184,inst_5186,inst_5175,state_val_5206,c__3814__auto___5227,out))
})();
var inst_5190 = cljs.core.filterv.call(null,inst_5189,inst_5175);
var inst_5175__$1 = inst_5190;
var state_5205__$1 = (function (){var statearr_5220 = state_5205;
(statearr_5220[(10)] = inst_5175__$1);

return statearr_5220;
})();
var statearr_5221_5237 = state_5205__$1;
(statearr_5221_5237[(2)] = null);

(statearr_5221_5237[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5227,out))
;
return ((function (switch__3724__auto__,c__3814__auto___5227,out){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5222 = [null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5222[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5222[(1)] = (1));

return statearr_5222;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5205){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5205);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5223){if((e5223 instanceof Object)){
var ex__3728__auto__ = e5223;
var statearr_5224_5238 = state_5205;
(statearr_5224_5238[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5205);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5223;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5239 = state_5205;
state_5205 = G__5239;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5205){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5205);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5227,out))
})();
var state__3816__auto__ = (function (){var statearr_5225 = f__3815__auto__.call(null);
(statearr_5225[(6)] = c__3814__auto___5227);

return statearr_5225;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5227,out))
);


return out;
});

cljs.core.async.merge.cljs$lang$maxFixedArity = 2;

/**
 * Returns a channel containing the single (collection) result of the
 *   items taken from the channel conjoined to the supplied
 *   collection. ch must close before into produces a result.
 */
cljs.core.async.into = (function cljs$core$async$into(coll,ch){
return cljs.core.async.reduce.call(null,cljs.core.conj,coll,ch);
});
/**
 * Returns a channel that will return, at most, n items from ch. After n items
 * have been returned, or ch has been closed, the return chanel will close.
 * 
 *   The output channel is unbuffered by default, unless buf-or-n is given.
 */
cljs.core.async.take = (function cljs$core$async$take(var_args){
var G__5241 = arguments.length;
switch (G__5241) {
case 2:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.take.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.take.call(null,n,ch,null);
});

cljs.core.async.take.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__3814__auto___5286 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5286,out){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5286,out){
return (function (state_5265){
var state_val_5266 = (state_5265[(1)]);
if((state_val_5266 === (7))){
var inst_5247 = (state_5265[(7)]);
var inst_5247__$1 = (state_5265[(2)]);
var inst_5248 = (inst_5247__$1 == null);
var inst_5249 = cljs.core.not.call(null,inst_5248);
var state_5265__$1 = (function (){var statearr_5267 = state_5265;
(statearr_5267[(7)] = inst_5247__$1);

return statearr_5267;
})();
if(inst_5249){
var statearr_5268_5287 = state_5265__$1;
(statearr_5268_5287[(1)] = (8));

} else {
var statearr_5269_5288 = state_5265__$1;
(statearr_5269_5288[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (1))){
var inst_5242 = (0);
var state_5265__$1 = (function (){var statearr_5270 = state_5265;
(statearr_5270[(8)] = inst_5242);

return statearr_5270;
})();
var statearr_5271_5289 = state_5265__$1;
(statearr_5271_5289[(2)] = null);

(statearr_5271_5289[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (4))){
var state_5265__$1 = state_5265;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5265__$1,(7),ch);
} else {
if((state_val_5266 === (6))){
var inst_5260 = (state_5265[(2)]);
var state_5265__$1 = state_5265;
var statearr_5272_5290 = state_5265__$1;
(statearr_5272_5290[(2)] = inst_5260);

(statearr_5272_5290[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (3))){
var inst_5262 = (state_5265[(2)]);
var inst_5263 = cljs.core.async.close_BANG_.call(null,out);
var state_5265__$1 = (function (){var statearr_5273 = state_5265;
(statearr_5273[(9)] = inst_5262);

return statearr_5273;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5265__$1,inst_5263);
} else {
if((state_val_5266 === (2))){
var inst_5242 = (state_5265[(8)]);
var inst_5244 = (inst_5242 < n);
var state_5265__$1 = state_5265;
if(cljs.core.truth_(inst_5244)){
var statearr_5274_5291 = state_5265__$1;
(statearr_5274_5291[(1)] = (4));

} else {
var statearr_5275_5292 = state_5265__$1;
(statearr_5275_5292[(1)] = (5));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (11))){
var inst_5242 = (state_5265[(8)]);
var inst_5252 = (state_5265[(2)]);
var inst_5253 = (inst_5242 + (1));
var inst_5242__$1 = inst_5253;
var state_5265__$1 = (function (){var statearr_5276 = state_5265;
(statearr_5276[(10)] = inst_5252);

(statearr_5276[(8)] = inst_5242__$1);

return statearr_5276;
})();
var statearr_5277_5293 = state_5265__$1;
(statearr_5277_5293[(2)] = null);

(statearr_5277_5293[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (9))){
var state_5265__$1 = state_5265;
var statearr_5278_5294 = state_5265__$1;
(statearr_5278_5294[(2)] = null);

(statearr_5278_5294[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (5))){
var state_5265__$1 = state_5265;
var statearr_5279_5295 = state_5265__$1;
(statearr_5279_5295[(2)] = null);

(statearr_5279_5295[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (10))){
var inst_5257 = (state_5265[(2)]);
var state_5265__$1 = state_5265;
var statearr_5280_5296 = state_5265__$1;
(statearr_5280_5296[(2)] = inst_5257);

(statearr_5280_5296[(1)] = (6));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5266 === (8))){
var inst_5247 = (state_5265[(7)]);
var state_5265__$1 = state_5265;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5265__$1,(11),out,inst_5247);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5286,out))
;
return ((function (switch__3724__auto__,c__3814__auto___5286,out){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5281 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_5281[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5281[(1)] = (1));

return statearr_5281;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5265){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5265);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5282){if((e5282 instanceof Object)){
var ex__3728__auto__ = e5282;
var statearr_5283_5297 = state_5265;
(statearr_5283_5297[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5265);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5282;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5298 = state_5265;
state_5265 = G__5298;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5265){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5265);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5286,out))
})();
var state__3816__auto__ = (function (){var statearr_5284 = f__3815__auto__.call(null);
(statearr_5284[(6)] = c__3814__auto___5286);

return statearr_5284;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5286,out))
);


return out;
});

cljs.core.async.take.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_LT_ = (function cljs$core$async$map_LT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async5300 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5300 = (function (f,ch,meta5301){
this.f = f;
this.ch = ch;
this.meta5301 = meta5301;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_5302,meta5301__$1){
var self__ = this;
var _5302__$1 = this;
return (new cljs.core.async.t_cljs$core$async5300(self__.f,self__.ch,meta5301__$1));
});

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_5302){
var self__ = this;
var _5302__$1 = this;
return self__.meta5301;
});

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
var ret = cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,(function (){
if(typeof cljs.core.async.t_cljs$core$async5303 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Handler}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5303 = (function (f,ch,meta5301,_,fn1,meta5304){
this.f = f;
this.ch = ch;
this.meta5301 = meta5301;
this._ = _;
this.fn1 = fn1;
this.meta5304 = meta5304;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5303.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = ((function (___$1){
return (function (_5305,meta5304__$1){
var self__ = this;
var _5305__$1 = this;
return (new cljs.core.async.t_cljs$core$async5303(self__.f,self__.ch,self__.meta5301,self__._,self__.fn1,meta5304__$1));
});})(___$1))
;

cljs.core.async.t_cljs$core$async5303.prototype.cljs$core$IMeta$_meta$arity$1 = ((function (___$1){
return (function (_5305){
var self__ = this;
var _5305__$1 = this;
return self__.meta5304;
});})(___$1))
;

cljs.core.async.t_cljs$core$async5303.prototype.cljs$core$async$impl$protocols$Handler$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5303.prototype.cljs$core$async$impl$protocols$Handler$active_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return cljs.core.async.impl.protocols.active_QMARK_.call(null,self__.fn1);
});})(___$1))
;

cljs.core.async.t_cljs$core$async5303.prototype.cljs$core$async$impl$protocols$Handler$blockable_QMARK_$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
return true;
});})(___$1))
;

cljs.core.async.t_cljs$core$async5303.prototype.cljs$core$async$impl$protocols$Handler$commit$arity$1 = ((function (___$1){
return (function (___$1){
var self__ = this;
var ___$2 = this;
var f1 = cljs.core.async.impl.protocols.commit.call(null,self__.fn1);
return ((function (f1,___$2,___$1){
return (function (p1__5299_SHARP_){
return f1.call(null,(((p1__5299_SHARP_ == null))?null:self__.f.call(null,p1__5299_SHARP_)));
});
;})(f1,___$2,___$1))
});})(___$1))
;

cljs.core.async.t_cljs$core$async5303.getBasis = ((function (___$1){
return (function (){
return new cljs.core.PersistentVector(null, 6, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta5301","meta5301",-904680076,null),cljs.core.with_meta(new cljs.core.Symbol(null,"_","_",-1201019570,null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Symbol("cljs.core.async","t_cljs$core$async5300","cljs.core.async/t_cljs$core$async5300",-1281987257,null)], null)),new cljs.core.Symbol(null,"fn1","fn1",895834444,null),new cljs.core.Symbol(null,"meta5304","meta5304",1589543338,null)], null);
});})(___$1))
;

cljs.core.async.t_cljs$core$async5303.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5303.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5303";

cljs.core.async.t_cljs$core$async5303.cljs$lang$ctorPrWriter = ((function (___$1){
return (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5303");
});})(___$1))
;

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5303.
 */
cljs.core.async.__GT_t_cljs$core$async5303 = ((function (___$1){
return (function cljs$core$async$map_LT__$___GT_t_cljs$core$async5303(f__$1,ch__$1,meta5301__$1,___$2,fn1__$1,meta5304){
return (new cljs.core.async.t_cljs$core$async5303(f__$1,ch__$1,meta5301__$1,___$2,fn1__$1,meta5304));
});})(___$1))
;

}

return (new cljs.core.async.t_cljs$core$async5303(self__.f,self__.ch,self__.meta5301,___$1,fn1,cljs.core.PersistentArrayMap.EMPTY));
})()
);
if(cljs.core.truth_((function (){var and__3911__auto__ = ret;
if(cljs.core.truth_(and__3911__auto__)){
return !((cljs.core.deref.call(null,ret) == null));
} else {
return and__3911__auto__;
}
})())){
return cljs.core.async.impl.channels.box.call(null,self__.f.call(null,cljs.core.deref.call(null,ret)));
} else {
return ret;
}
});

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5300.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
});

cljs.core.async.t_cljs$core$async5300.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta5301","meta5301",-904680076,null)], null);
});

cljs.core.async.t_cljs$core$async5300.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5300.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5300";

cljs.core.async.t_cljs$core$async5300.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5300");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5300.
 */
cljs.core.async.__GT_t_cljs$core$async5300 = (function cljs$core$async$map_LT__$___GT_t_cljs$core$async5300(f__$1,ch__$1,meta5301){
return (new cljs.core.async.t_cljs$core$async5300(f__$1,ch__$1,meta5301));
});

}

return (new cljs.core.async.t_cljs$core$async5300(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.map_GT_ = (function cljs$core$async$map_GT_(f,ch){
if(typeof cljs.core.async.t_cljs$core$async5306 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5306 = (function (f,ch,meta5307){
this.f = f;
this.ch = ch;
this.meta5307 = meta5307;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_5308,meta5307__$1){
var self__ = this;
var _5308__$1 = this;
return (new cljs.core.async.t_cljs$core$async5306(self__.f,self__.ch,meta5307__$1));
});

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_5308){
var self__ = this;
var _5308__$1 = this;
return self__.meta5307;
});

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5306.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,self__.f.call(null,val),fn1);
});

cljs.core.async.t_cljs$core$async5306.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"f","f",43394975,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta5307","meta5307",1830321050,null)], null);
});

cljs.core.async.t_cljs$core$async5306.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5306.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5306";

cljs.core.async.t_cljs$core$async5306.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5306");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5306.
 */
cljs.core.async.__GT_t_cljs$core$async5306 = (function cljs$core$async$map_GT__$___GT_t_cljs$core$async5306(f__$1,ch__$1,meta5307){
return (new cljs.core.async.t_cljs$core$async5306(f__$1,ch__$1,meta5307));
});

}

return (new cljs.core.async.t_cljs$core$async5306(f,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_GT_ = (function cljs$core$async$filter_GT_(p,ch){
if(typeof cljs.core.async.t_cljs$core$async5309 !== 'undefined'){
} else {

/**
* @constructor
 * @implements {cljs.core.async.impl.protocols.Channel}
 * @implements {cljs.core.async.impl.protocols.WritePort}
 * @implements {cljs.core.async.impl.protocols.ReadPort}
 * @implements {cljs.core.IMeta}
 * @implements {cljs.core.IWithMeta}
*/
cljs.core.async.t_cljs$core$async5309 = (function (p,ch,meta5310){
this.p = p;
this.ch = ch;
this.meta5310 = meta5310;
this.cljs$lang$protocol_mask$partition0$ = 393216;
this.cljs$lang$protocol_mask$partition1$ = 0;
});
cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$IWithMeta$_with_meta$arity$2 = (function (_5311,meta5310__$1){
var self__ = this;
var _5311__$1 = this;
return (new cljs.core.async.t_cljs$core$async5309(self__.p,self__.ch,meta5310__$1));
});

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$IMeta$_meta$arity$1 = (function (_5311){
var self__ = this;
var _5311__$1 = this;
return self__.meta5310;
});

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$Channel$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$Channel$close_BANG_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.close_BANG_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$Channel$closed_QMARK_$arity$1 = (function (_){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch);
});

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$ReadPort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$ReadPort$take_BANG_$arity$2 = (function (_,fn1){
var self__ = this;
var ___$1 = this;
return cljs.core.async.impl.protocols.take_BANG_.call(null,self__.ch,fn1);
});

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$WritePort$ = cljs.core.PROTOCOL_SENTINEL;

cljs.core.async.t_cljs$core$async5309.prototype.cljs$core$async$impl$protocols$WritePort$put_BANG_$arity$3 = (function (_,val,fn1){
var self__ = this;
var ___$1 = this;
if(cljs.core.truth_(self__.p.call(null,val))){
return cljs.core.async.impl.protocols.put_BANG_.call(null,self__.ch,val,fn1);
} else {
return cljs.core.async.impl.channels.box.call(null,cljs.core.not.call(null,cljs.core.async.impl.protocols.closed_QMARK_.call(null,self__.ch)));
}
});

cljs.core.async.t_cljs$core$async5309.getBasis = (function (){
return new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Symbol(null,"p","p",1791580836,null),new cljs.core.Symbol(null,"ch","ch",1085813622,null),new cljs.core.Symbol(null,"meta5310","meta5310",-1077415451,null)], null);
});

cljs.core.async.t_cljs$core$async5309.cljs$lang$type = true;

cljs.core.async.t_cljs$core$async5309.cljs$lang$ctorStr = "cljs.core.async/t_cljs$core$async5309";

cljs.core.async.t_cljs$core$async5309.cljs$lang$ctorPrWriter = (function (this__4161__auto__,writer__4162__auto__,opt__4163__auto__){
return cljs.core._write.call(null,writer__4162__auto__,"cljs.core.async/t_cljs$core$async5309");
});

/**
 * Positional factory function for cljs.core.async/t_cljs$core$async5309.
 */
cljs.core.async.__GT_t_cljs$core$async5309 = (function cljs$core$async$filter_GT__$___GT_t_cljs$core$async5309(p__$1,ch__$1,meta5310){
return (new cljs.core.async.t_cljs$core$async5309(p__$1,ch__$1,meta5310));
});

}

return (new cljs.core.async.t_cljs$core$async5309(p,ch,cljs.core.PersistentArrayMap.EMPTY));
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_GT_ = (function cljs$core$async$remove_GT_(p,ch){
return cljs.core.async.filter_GT_.call(null,cljs.core.complement.call(null,p),ch);
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.filter_LT_ = (function cljs$core$async$filter_LT_(var_args){
var G__5313 = arguments.length;
switch (G__5313) {
case 2:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.filter_LT_.call(null,p,ch,null);
});

cljs.core.async.filter_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__3814__auto___5353 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5353,out){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5353,out){
return (function (state_5334){
var state_val_5335 = (state_5334[(1)]);
if((state_val_5335 === (7))){
var inst_5330 = (state_5334[(2)]);
var state_5334__$1 = state_5334;
var statearr_5336_5354 = state_5334__$1;
(statearr_5336_5354[(2)] = inst_5330);

(statearr_5336_5354[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (1))){
var state_5334__$1 = state_5334;
var statearr_5337_5355 = state_5334__$1;
(statearr_5337_5355[(2)] = null);

(statearr_5337_5355[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (4))){
var inst_5316 = (state_5334[(7)]);
var inst_5316__$1 = (state_5334[(2)]);
var inst_5317 = (inst_5316__$1 == null);
var state_5334__$1 = (function (){var statearr_5338 = state_5334;
(statearr_5338[(7)] = inst_5316__$1);

return statearr_5338;
})();
if(cljs.core.truth_(inst_5317)){
var statearr_5339_5356 = state_5334__$1;
(statearr_5339_5356[(1)] = (5));

} else {
var statearr_5340_5357 = state_5334__$1;
(statearr_5340_5357[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (6))){
var inst_5316 = (state_5334[(7)]);
var inst_5321 = p.call(null,inst_5316);
var state_5334__$1 = state_5334;
if(cljs.core.truth_(inst_5321)){
var statearr_5341_5358 = state_5334__$1;
(statearr_5341_5358[(1)] = (8));

} else {
var statearr_5342_5359 = state_5334__$1;
(statearr_5342_5359[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (3))){
var inst_5332 = (state_5334[(2)]);
var state_5334__$1 = state_5334;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5334__$1,inst_5332);
} else {
if((state_val_5335 === (2))){
var state_5334__$1 = state_5334;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5334__$1,(4),ch);
} else {
if((state_val_5335 === (11))){
var inst_5324 = (state_5334[(2)]);
var state_5334__$1 = state_5334;
var statearr_5343_5360 = state_5334__$1;
(statearr_5343_5360[(2)] = inst_5324);

(statearr_5343_5360[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (9))){
var state_5334__$1 = state_5334;
var statearr_5344_5361 = state_5334__$1;
(statearr_5344_5361[(2)] = null);

(statearr_5344_5361[(1)] = (10));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (5))){
var inst_5319 = cljs.core.async.close_BANG_.call(null,out);
var state_5334__$1 = state_5334;
var statearr_5345_5362 = state_5334__$1;
(statearr_5345_5362[(2)] = inst_5319);

(statearr_5345_5362[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (10))){
var inst_5327 = (state_5334[(2)]);
var state_5334__$1 = (function (){var statearr_5346 = state_5334;
(statearr_5346[(8)] = inst_5327);

return statearr_5346;
})();
var statearr_5347_5363 = state_5334__$1;
(statearr_5347_5363[(2)] = null);

(statearr_5347_5363[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5335 === (8))){
var inst_5316 = (state_5334[(7)]);
var state_5334__$1 = state_5334;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5334__$1,(11),out,inst_5316);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5353,out))
;
return ((function (switch__3724__auto__,c__3814__auto___5353,out){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5348 = [null,null,null,null,null,null,null,null,null];
(statearr_5348[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5348[(1)] = (1));

return statearr_5348;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5334){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5334);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5349){if((e5349 instanceof Object)){
var ex__3728__auto__ = e5349;
var statearr_5350_5364 = state_5334;
(statearr_5350_5364[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5334);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5349;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5365 = state_5334;
state_5334 = G__5365;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5334){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5334);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5353,out))
})();
var state__3816__auto__ = (function (){var statearr_5351 = f__3815__auto__.call(null);
(statearr_5351[(6)] = c__3814__auto___5353);

return statearr_5351;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5353,out))
);


return out;
});

cljs.core.async.filter_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.remove_LT_ = (function cljs$core$async$remove_LT_(var_args){
var G__5367 = arguments.length;
switch (G__5367) {
case 2:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$2 = (function (p,ch){
return cljs.core.async.remove_LT_.call(null,p,ch,null);
});

cljs.core.async.remove_LT_.cljs$core$IFn$_invoke$arity$3 = (function (p,ch,buf_or_n){
return cljs.core.async.filter_LT_.call(null,cljs.core.complement.call(null,p),ch,buf_or_n);
});

cljs.core.async.remove_LT_.cljs$lang$maxFixedArity = 3;

cljs.core.async.mapcat_STAR_ = (function cljs$core$async$mapcat_STAR_(f,in$,out){
var c__3814__auto__ = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto__){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto__){
return (function (state_5430){
var state_val_5431 = (state_5430[(1)]);
if((state_val_5431 === (7))){
var inst_5426 = (state_5430[(2)]);
var state_5430__$1 = state_5430;
var statearr_5432_5470 = state_5430__$1;
(statearr_5432_5470[(2)] = inst_5426);

(statearr_5432_5470[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (20))){
var inst_5396 = (state_5430[(7)]);
var inst_5407 = (state_5430[(2)]);
var inst_5408 = cljs.core.next.call(null,inst_5396);
var inst_5382 = inst_5408;
var inst_5383 = null;
var inst_5384 = (0);
var inst_5385 = (0);
var state_5430__$1 = (function (){var statearr_5433 = state_5430;
(statearr_5433[(8)] = inst_5385);

(statearr_5433[(9)] = inst_5384);

(statearr_5433[(10)] = inst_5383);

(statearr_5433[(11)] = inst_5407);

(statearr_5433[(12)] = inst_5382);

return statearr_5433;
})();
var statearr_5434_5471 = state_5430__$1;
(statearr_5434_5471[(2)] = null);

(statearr_5434_5471[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (1))){
var state_5430__$1 = state_5430;
var statearr_5435_5472 = state_5430__$1;
(statearr_5435_5472[(2)] = null);

(statearr_5435_5472[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (4))){
var inst_5371 = (state_5430[(13)]);
var inst_5371__$1 = (state_5430[(2)]);
var inst_5372 = (inst_5371__$1 == null);
var state_5430__$1 = (function (){var statearr_5436 = state_5430;
(statearr_5436[(13)] = inst_5371__$1);

return statearr_5436;
})();
if(cljs.core.truth_(inst_5372)){
var statearr_5437_5473 = state_5430__$1;
(statearr_5437_5473[(1)] = (5));

} else {
var statearr_5438_5474 = state_5430__$1;
(statearr_5438_5474[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (15))){
var state_5430__$1 = state_5430;
var statearr_5442_5475 = state_5430__$1;
(statearr_5442_5475[(2)] = null);

(statearr_5442_5475[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (21))){
var state_5430__$1 = state_5430;
var statearr_5443_5476 = state_5430__$1;
(statearr_5443_5476[(2)] = null);

(statearr_5443_5476[(1)] = (23));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (13))){
var inst_5385 = (state_5430[(8)]);
var inst_5384 = (state_5430[(9)]);
var inst_5383 = (state_5430[(10)]);
var inst_5382 = (state_5430[(12)]);
var inst_5392 = (state_5430[(2)]);
var inst_5393 = (inst_5385 + (1));
var tmp5439 = inst_5384;
var tmp5440 = inst_5383;
var tmp5441 = inst_5382;
var inst_5382__$1 = tmp5441;
var inst_5383__$1 = tmp5440;
var inst_5384__$1 = tmp5439;
var inst_5385__$1 = inst_5393;
var state_5430__$1 = (function (){var statearr_5444 = state_5430;
(statearr_5444[(8)] = inst_5385__$1);

(statearr_5444[(9)] = inst_5384__$1);

(statearr_5444[(14)] = inst_5392);

(statearr_5444[(10)] = inst_5383__$1);

(statearr_5444[(12)] = inst_5382__$1);

return statearr_5444;
})();
var statearr_5445_5477 = state_5430__$1;
(statearr_5445_5477[(2)] = null);

(statearr_5445_5477[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (22))){
var state_5430__$1 = state_5430;
var statearr_5446_5478 = state_5430__$1;
(statearr_5446_5478[(2)] = null);

(statearr_5446_5478[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (6))){
var inst_5371 = (state_5430[(13)]);
var inst_5380 = f.call(null,inst_5371);
var inst_5381 = cljs.core.seq.call(null,inst_5380);
var inst_5382 = inst_5381;
var inst_5383 = null;
var inst_5384 = (0);
var inst_5385 = (0);
var state_5430__$1 = (function (){var statearr_5447 = state_5430;
(statearr_5447[(8)] = inst_5385);

(statearr_5447[(9)] = inst_5384);

(statearr_5447[(10)] = inst_5383);

(statearr_5447[(12)] = inst_5382);

return statearr_5447;
})();
var statearr_5448_5479 = state_5430__$1;
(statearr_5448_5479[(2)] = null);

(statearr_5448_5479[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (17))){
var inst_5396 = (state_5430[(7)]);
var inst_5400 = cljs.core.chunk_first.call(null,inst_5396);
var inst_5401 = cljs.core.chunk_rest.call(null,inst_5396);
var inst_5402 = cljs.core.count.call(null,inst_5400);
var inst_5382 = inst_5401;
var inst_5383 = inst_5400;
var inst_5384 = inst_5402;
var inst_5385 = (0);
var state_5430__$1 = (function (){var statearr_5449 = state_5430;
(statearr_5449[(8)] = inst_5385);

(statearr_5449[(9)] = inst_5384);

(statearr_5449[(10)] = inst_5383);

(statearr_5449[(12)] = inst_5382);

return statearr_5449;
})();
var statearr_5450_5480 = state_5430__$1;
(statearr_5450_5480[(2)] = null);

(statearr_5450_5480[(1)] = (8));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (3))){
var inst_5428 = (state_5430[(2)]);
var state_5430__$1 = state_5430;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5430__$1,inst_5428);
} else {
if((state_val_5431 === (12))){
var inst_5416 = (state_5430[(2)]);
var state_5430__$1 = state_5430;
var statearr_5451_5481 = state_5430__$1;
(statearr_5451_5481[(2)] = inst_5416);

(statearr_5451_5481[(1)] = (9));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (2))){
var state_5430__$1 = state_5430;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5430__$1,(4),in$);
} else {
if((state_val_5431 === (23))){
var inst_5424 = (state_5430[(2)]);
var state_5430__$1 = state_5430;
var statearr_5452_5482 = state_5430__$1;
(statearr_5452_5482[(2)] = inst_5424);

(statearr_5452_5482[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (19))){
var inst_5411 = (state_5430[(2)]);
var state_5430__$1 = state_5430;
var statearr_5453_5483 = state_5430__$1;
(statearr_5453_5483[(2)] = inst_5411);

(statearr_5453_5483[(1)] = (16));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (11))){
var inst_5396 = (state_5430[(7)]);
var inst_5382 = (state_5430[(12)]);
var inst_5396__$1 = cljs.core.seq.call(null,inst_5382);
var state_5430__$1 = (function (){var statearr_5454 = state_5430;
(statearr_5454[(7)] = inst_5396__$1);

return statearr_5454;
})();
if(inst_5396__$1){
var statearr_5455_5484 = state_5430__$1;
(statearr_5455_5484[(1)] = (14));

} else {
var statearr_5456_5485 = state_5430__$1;
(statearr_5456_5485[(1)] = (15));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (9))){
var inst_5418 = (state_5430[(2)]);
var inst_5419 = cljs.core.async.impl.protocols.closed_QMARK_.call(null,out);
var state_5430__$1 = (function (){var statearr_5457 = state_5430;
(statearr_5457[(15)] = inst_5418);

return statearr_5457;
})();
if(cljs.core.truth_(inst_5419)){
var statearr_5458_5486 = state_5430__$1;
(statearr_5458_5486[(1)] = (21));

} else {
var statearr_5459_5487 = state_5430__$1;
(statearr_5459_5487[(1)] = (22));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (5))){
var inst_5374 = cljs.core.async.close_BANG_.call(null,out);
var state_5430__$1 = state_5430;
var statearr_5460_5488 = state_5430__$1;
(statearr_5460_5488[(2)] = inst_5374);

(statearr_5460_5488[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (14))){
var inst_5396 = (state_5430[(7)]);
var inst_5398 = cljs.core.chunked_seq_QMARK_.call(null,inst_5396);
var state_5430__$1 = state_5430;
if(inst_5398){
var statearr_5461_5489 = state_5430__$1;
(statearr_5461_5489[(1)] = (17));

} else {
var statearr_5462_5490 = state_5430__$1;
(statearr_5462_5490[(1)] = (18));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (16))){
var inst_5414 = (state_5430[(2)]);
var state_5430__$1 = state_5430;
var statearr_5463_5491 = state_5430__$1;
(statearr_5463_5491[(2)] = inst_5414);

(statearr_5463_5491[(1)] = (12));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5431 === (10))){
var inst_5385 = (state_5430[(8)]);
var inst_5383 = (state_5430[(10)]);
var inst_5390 = cljs.core._nth.call(null,inst_5383,inst_5385);
var state_5430__$1 = state_5430;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5430__$1,(13),out,inst_5390);
} else {
if((state_val_5431 === (18))){
var inst_5396 = (state_5430[(7)]);
var inst_5405 = cljs.core.first.call(null,inst_5396);
var state_5430__$1 = state_5430;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5430__$1,(20),out,inst_5405);
} else {
if((state_val_5431 === (8))){
var inst_5385 = (state_5430[(8)]);
var inst_5384 = (state_5430[(9)]);
var inst_5387 = (inst_5385 < inst_5384);
var inst_5388 = inst_5387;
var state_5430__$1 = state_5430;
if(cljs.core.truth_(inst_5388)){
var statearr_5464_5492 = state_5430__$1;
(statearr_5464_5492[(1)] = (10));

} else {
var statearr_5465_5493 = state_5430__$1;
(statearr_5465_5493[(1)] = (11));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto__))
;
return ((function (switch__3724__auto__,c__3814__auto__){
return (function() {
var cljs$core$async$mapcat_STAR__$_state_machine__3725__auto__ = null;
var cljs$core$async$mapcat_STAR__$_state_machine__3725__auto____0 = (function (){
var statearr_5466 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5466[(0)] = cljs$core$async$mapcat_STAR__$_state_machine__3725__auto__);

(statearr_5466[(1)] = (1));

return statearr_5466;
});
var cljs$core$async$mapcat_STAR__$_state_machine__3725__auto____1 = (function (state_5430){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5430);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5467){if((e5467 instanceof Object)){
var ex__3728__auto__ = e5467;
var statearr_5468_5494 = state_5430;
(statearr_5468_5494[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5430);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5467;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5495 = state_5430;
state_5430 = G__5495;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$mapcat_STAR__$_state_machine__3725__auto__ = function(state_5430){
switch(arguments.length){
case 0:
return cljs$core$async$mapcat_STAR__$_state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$mapcat_STAR__$_state_machine__3725__auto____1.call(this,state_5430);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$mapcat_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$mapcat_STAR__$_state_machine__3725__auto____0;
cljs$core$async$mapcat_STAR__$_state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$mapcat_STAR__$_state_machine__3725__auto____1;
return cljs$core$async$mapcat_STAR__$_state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto__))
})();
var state__3816__auto__ = (function (){var statearr_5469 = f__3815__auto__.call(null);
(statearr_5469[(6)] = c__3814__auto__);

return statearr_5469;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto__))
);

return c__3814__auto__;
});
/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_LT_ = (function cljs$core$async$mapcat_LT_(var_args){
var G__5497 = arguments.length;
switch (G__5497) {
case 2:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$2 = (function (f,in$){
return cljs.core.async.mapcat_LT_.call(null,f,in$,null);
});

cljs.core.async.mapcat_LT_.cljs$core$IFn$_invoke$arity$3 = (function (f,in$,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return out;
});

cljs.core.async.mapcat_LT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.mapcat_GT_ = (function cljs$core$async$mapcat_GT_(var_args){
var G__5500 = arguments.length;
switch (G__5500) {
case 2:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$2 = (function (f,out){
return cljs.core.async.mapcat_GT_.call(null,f,out,null);
});

cljs.core.async.mapcat_GT_.cljs$core$IFn$_invoke$arity$3 = (function (f,out,buf_or_n){
var in$ = cljs.core.async.chan.call(null,buf_or_n);
cljs.core.async.mapcat_STAR_.call(null,f,in$,out);

return in$;
});

cljs.core.async.mapcat_GT_.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.unique = (function cljs$core$async$unique(var_args){
var G__5503 = arguments.length;
switch (G__5503) {
case 1:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1((arguments[(0)]));

break;
case 2:
return cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$1 = (function (ch){
return cljs.core.async.unique.call(null,ch,null);
});

cljs.core.async.unique.cljs$core$IFn$_invoke$arity$2 = (function (ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__3814__auto___5550 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5550,out){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5550,out){
return (function (state_5527){
var state_val_5528 = (state_5527[(1)]);
if((state_val_5528 === (7))){
var inst_5522 = (state_5527[(2)]);
var state_5527__$1 = state_5527;
var statearr_5529_5551 = state_5527__$1;
(statearr_5529_5551[(2)] = inst_5522);

(statearr_5529_5551[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (1))){
var inst_5504 = null;
var state_5527__$1 = (function (){var statearr_5530 = state_5527;
(statearr_5530[(7)] = inst_5504);

return statearr_5530;
})();
var statearr_5531_5552 = state_5527__$1;
(statearr_5531_5552[(2)] = null);

(statearr_5531_5552[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (4))){
var inst_5507 = (state_5527[(8)]);
var inst_5507__$1 = (state_5527[(2)]);
var inst_5508 = (inst_5507__$1 == null);
var inst_5509 = cljs.core.not.call(null,inst_5508);
var state_5527__$1 = (function (){var statearr_5532 = state_5527;
(statearr_5532[(8)] = inst_5507__$1);

return statearr_5532;
})();
if(inst_5509){
var statearr_5533_5553 = state_5527__$1;
(statearr_5533_5553[(1)] = (5));

} else {
var statearr_5534_5554 = state_5527__$1;
(statearr_5534_5554[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (6))){
var state_5527__$1 = state_5527;
var statearr_5535_5555 = state_5527__$1;
(statearr_5535_5555[(2)] = null);

(statearr_5535_5555[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (3))){
var inst_5524 = (state_5527[(2)]);
var inst_5525 = cljs.core.async.close_BANG_.call(null,out);
var state_5527__$1 = (function (){var statearr_5536 = state_5527;
(statearr_5536[(9)] = inst_5524);

return statearr_5536;
})();
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5527__$1,inst_5525);
} else {
if((state_val_5528 === (2))){
var state_5527__$1 = state_5527;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5527__$1,(4),ch);
} else {
if((state_val_5528 === (11))){
var inst_5507 = (state_5527[(8)]);
var inst_5516 = (state_5527[(2)]);
var inst_5504 = inst_5507;
var state_5527__$1 = (function (){var statearr_5537 = state_5527;
(statearr_5537[(10)] = inst_5516);

(statearr_5537[(7)] = inst_5504);

return statearr_5537;
})();
var statearr_5538_5556 = state_5527__$1;
(statearr_5538_5556[(2)] = null);

(statearr_5538_5556[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (9))){
var inst_5507 = (state_5527[(8)]);
var state_5527__$1 = state_5527;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5527__$1,(11),out,inst_5507);
} else {
if((state_val_5528 === (5))){
var inst_5507 = (state_5527[(8)]);
var inst_5504 = (state_5527[(7)]);
var inst_5511 = cljs.core._EQ_.call(null,inst_5507,inst_5504);
var state_5527__$1 = state_5527;
if(inst_5511){
var statearr_5540_5557 = state_5527__$1;
(statearr_5540_5557[(1)] = (8));

} else {
var statearr_5541_5558 = state_5527__$1;
(statearr_5541_5558[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (10))){
var inst_5519 = (state_5527[(2)]);
var state_5527__$1 = state_5527;
var statearr_5542_5559 = state_5527__$1;
(statearr_5542_5559[(2)] = inst_5519);

(statearr_5542_5559[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5528 === (8))){
var inst_5504 = (state_5527[(7)]);
var tmp5539 = inst_5504;
var inst_5504__$1 = tmp5539;
var state_5527__$1 = (function (){var statearr_5543 = state_5527;
(statearr_5543[(7)] = inst_5504__$1);

return statearr_5543;
})();
var statearr_5544_5560 = state_5527__$1;
(statearr_5544_5560[(2)] = null);

(statearr_5544_5560[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5550,out))
;
return ((function (switch__3724__auto__,c__3814__auto___5550,out){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5545 = [null,null,null,null,null,null,null,null,null,null,null];
(statearr_5545[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5545[(1)] = (1));

return statearr_5545;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5527){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5527);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5546){if((e5546 instanceof Object)){
var ex__3728__auto__ = e5546;
var statearr_5547_5561 = state_5527;
(statearr_5547_5561[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5527);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5546;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5562 = state_5527;
state_5527 = G__5562;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5527){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5527);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5550,out))
})();
var state__3816__auto__ = (function (){var statearr_5548 = f__3815__auto__.call(null);
(statearr_5548[(6)] = c__3814__auto___5550);

return statearr_5548;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5550,out))
);


return out;
});

cljs.core.async.unique.cljs$lang$maxFixedArity = 2;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition = (function cljs$core$async$partition(var_args){
var G__5564 = arguments.length;
switch (G__5564) {
case 2:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$2 = (function (n,ch){
return cljs.core.async.partition.call(null,n,ch,null);
});

cljs.core.async.partition.cljs$core$IFn$_invoke$arity$3 = (function (n,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__3814__auto___5630 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5630,out){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5630,out){
return (function (state_5602){
var state_val_5603 = (state_5602[(1)]);
if((state_val_5603 === (7))){
var inst_5598 = (state_5602[(2)]);
var state_5602__$1 = state_5602;
var statearr_5604_5631 = state_5602__$1;
(statearr_5604_5631[(2)] = inst_5598);

(statearr_5604_5631[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (1))){
var inst_5565 = (new Array(n));
var inst_5566 = inst_5565;
var inst_5567 = (0);
var state_5602__$1 = (function (){var statearr_5605 = state_5602;
(statearr_5605[(7)] = inst_5566);

(statearr_5605[(8)] = inst_5567);

return statearr_5605;
})();
var statearr_5606_5632 = state_5602__$1;
(statearr_5606_5632[(2)] = null);

(statearr_5606_5632[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (4))){
var inst_5570 = (state_5602[(9)]);
var inst_5570__$1 = (state_5602[(2)]);
var inst_5571 = (inst_5570__$1 == null);
var inst_5572 = cljs.core.not.call(null,inst_5571);
var state_5602__$1 = (function (){var statearr_5607 = state_5602;
(statearr_5607[(9)] = inst_5570__$1);

return statearr_5607;
})();
if(inst_5572){
var statearr_5608_5633 = state_5602__$1;
(statearr_5608_5633[(1)] = (5));

} else {
var statearr_5609_5634 = state_5602__$1;
(statearr_5609_5634[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (15))){
var inst_5592 = (state_5602[(2)]);
var state_5602__$1 = state_5602;
var statearr_5610_5635 = state_5602__$1;
(statearr_5610_5635[(2)] = inst_5592);

(statearr_5610_5635[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (13))){
var state_5602__$1 = state_5602;
var statearr_5611_5636 = state_5602__$1;
(statearr_5611_5636[(2)] = null);

(statearr_5611_5636[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (6))){
var inst_5567 = (state_5602[(8)]);
var inst_5588 = (inst_5567 > (0));
var state_5602__$1 = state_5602;
if(cljs.core.truth_(inst_5588)){
var statearr_5612_5637 = state_5602__$1;
(statearr_5612_5637[(1)] = (12));

} else {
var statearr_5613_5638 = state_5602__$1;
(statearr_5613_5638[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (3))){
var inst_5600 = (state_5602[(2)]);
var state_5602__$1 = state_5602;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5602__$1,inst_5600);
} else {
if((state_val_5603 === (12))){
var inst_5566 = (state_5602[(7)]);
var inst_5590 = cljs.core.vec.call(null,inst_5566);
var state_5602__$1 = state_5602;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5602__$1,(15),out,inst_5590);
} else {
if((state_val_5603 === (2))){
var state_5602__$1 = state_5602;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5602__$1,(4),ch);
} else {
if((state_val_5603 === (11))){
var inst_5582 = (state_5602[(2)]);
var inst_5583 = (new Array(n));
var inst_5566 = inst_5583;
var inst_5567 = (0);
var state_5602__$1 = (function (){var statearr_5614 = state_5602;
(statearr_5614[(10)] = inst_5582);

(statearr_5614[(7)] = inst_5566);

(statearr_5614[(8)] = inst_5567);

return statearr_5614;
})();
var statearr_5615_5639 = state_5602__$1;
(statearr_5615_5639[(2)] = null);

(statearr_5615_5639[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (9))){
var inst_5566 = (state_5602[(7)]);
var inst_5580 = cljs.core.vec.call(null,inst_5566);
var state_5602__$1 = state_5602;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5602__$1,(11),out,inst_5580);
} else {
if((state_val_5603 === (5))){
var inst_5575 = (state_5602[(11)]);
var inst_5566 = (state_5602[(7)]);
var inst_5567 = (state_5602[(8)]);
var inst_5570 = (state_5602[(9)]);
var inst_5574 = (inst_5566[inst_5567] = inst_5570);
var inst_5575__$1 = (inst_5567 + (1));
var inst_5576 = (inst_5575__$1 < n);
var state_5602__$1 = (function (){var statearr_5616 = state_5602;
(statearr_5616[(11)] = inst_5575__$1);

(statearr_5616[(12)] = inst_5574);

return statearr_5616;
})();
if(cljs.core.truth_(inst_5576)){
var statearr_5617_5640 = state_5602__$1;
(statearr_5617_5640[(1)] = (8));

} else {
var statearr_5618_5641 = state_5602__$1;
(statearr_5618_5641[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (14))){
var inst_5595 = (state_5602[(2)]);
var inst_5596 = cljs.core.async.close_BANG_.call(null,out);
var state_5602__$1 = (function (){var statearr_5620 = state_5602;
(statearr_5620[(13)] = inst_5595);

return statearr_5620;
})();
var statearr_5621_5642 = state_5602__$1;
(statearr_5621_5642[(2)] = inst_5596);

(statearr_5621_5642[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (10))){
var inst_5586 = (state_5602[(2)]);
var state_5602__$1 = state_5602;
var statearr_5622_5643 = state_5602__$1;
(statearr_5622_5643[(2)] = inst_5586);

(statearr_5622_5643[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5603 === (8))){
var inst_5575 = (state_5602[(11)]);
var inst_5566 = (state_5602[(7)]);
var tmp5619 = inst_5566;
var inst_5566__$1 = tmp5619;
var inst_5567 = inst_5575;
var state_5602__$1 = (function (){var statearr_5623 = state_5602;
(statearr_5623[(7)] = inst_5566__$1);

(statearr_5623[(8)] = inst_5567);

return statearr_5623;
})();
var statearr_5624_5644 = state_5602__$1;
(statearr_5624_5644[(2)] = null);

(statearr_5624_5644[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5630,out))
;
return ((function (switch__3724__auto__,c__3814__auto___5630,out){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5625 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5625[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5625[(1)] = (1));

return statearr_5625;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5602){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5602);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5626){if((e5626 instanceof Object)){
var ex__3728__auto__ = e5626;
var statearr_5627_5645 = state_5602;
(statearr_5627_5645[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5602);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5626;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5646 = state_5602;
state_5602 = G__5646;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5602){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5602);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5630,out))
})();
var state__3816__auto__ = (function (){var statearr_5628 = f__3815__auto__.call(null);
(statearr_5628[(6)] = c__3814__auto___5630);

return statearr_5628;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5630,out))
);


return out;
});

cljs.core.async.partition.cljs$lang$maxFixedArity = 3;

/**
 * Deprecated - this function will be removed. Use transducer instead
 */
cljs.core.async.partition_by = (function cljs$core$async$partition_by(var_args){
var G__5648 = arguments.length;
switch (G__5648) {
case 2:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2((arguments[(0)]),(arguments[(1)]));

break;
case 3:
return cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3((arguments[(0)]),(arguments[(1)]),(arguments[(2)]));

break;
default:
throw (new Error(["Invalid arity: ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(arguments.length)].join('')));

}
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$2 = (function (f,ch){
return cljs.core.async.partition_by.call(null,f,ch,null);
});

cljs.core.async.partition_by.cljs$core$IFn$_invoke$arity$3 = (function (f,ch,buf_or_n){
var out = cljs.core.async.chan.call(null,buf_or_n);
var c__3814__auto___5718 = cljs.core.async.chan.call(null,(1));
cljs.core.async.impl.dispatch.run.call(null,((function (c__3814__auto___5718,out){
return (function (){
var f__3815__auto__ = (function (){var switch__3724__auto__ = ((function (c__3814__auto___5718,out){
return (function (state_5690){
var state_val_5691 = (state_5690[(1)]);
if((state_val_5691 === (7))){
var inst_5686 = (state_5690[(2)]);
var state_5690__$1 = state_5690;
var statearr_5692_5719 = state_5690__$1;
(statearr_5692_5719[(2)] = inst_5686);

(statearr_5692_5719[(1)] = (3));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (1))){
var inst_5649 = [];
var inst_5650 = inst_5649;
var inst_5651 = new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123);
var state_5690__$1 = (function (){var statearr_5693 = state_5690;
(statearr_5693[(7)] = inst_5650);

(statearr_5693[(8)] = inst_5651);

return statearr_5693;
})();
var statearr_5694_5720 = state_5690__$1;
(statearr_5694_5720[(2)] = null);

(statearr_5694_5720[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (4))){
var inst_5654 = (state_5690[(9)]);
var inst_5654__$1 = (state_5690[(2)]);
var inst_5655 = (inst_5654__$1 == null);
var inst_5656 = cljs.core.not.call(null,inst_5655);
var state_5690__$1 = (function (){var statearr_5695 = state_5690;
(statearr_5695[(9)] = inst_5654__$1);

return statearr_5695;
})();
if(inst_5656){
var statearr_5696_5721 = state_5690__$1;
(statearr_5696_5721[(1)] = (5));

} else {
var statearr_5697_5722 = state_5690__$1;
(statearr_5697_5722[(1)] = (6));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (15))){
var inst_5680 = (state_5690[(2)]);
var state_5690__$1 = state_5690;
var statearr_5698_5723 = state_5690__$1;
(statearr_5698_5723[(2)] = inst_5680);

(statearr_5698_5723[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (13))){
var state_5690__$1 = state_5690;
var statearr_5699_5724 = state_5690__$1;
(statearr_5699_5724[(2)] = null);

(statearr_5699_5724[(1)] = (14));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (6))){
var inst_5650 = (state_5690[(7)]);
var inst_5675 = inst_5650.length;
var inst_5676 = (inst_5675 > (0));
var state_5690__$1 = state_5690;
if(cljs.core.truth_(inst_5676)){
var statearr_5700_5725 = state_5690__$1;
(statearr_5700_5725[(1)] = (12));

} else {
var statearr_5701_5726 = state_5690__$1;
(statearr_5701_5726[(1)] = (13));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (3))){
var inst_5688 = (state_5690[(2)]);
var state_5690__$1 = state_5690;
return cljs.core.async.impl.ioc_helpers.return_chan.call(null,state_5690__$1,inst_5688);
} else {
if((state_val_5691 === (12))){
var inst_5650 = (state_5690[(7)]);
var inst_5678 = cljs.core.vec.call(null,inst_5650);
var state_5690__$1 = state_5690;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5690__$1,(15),out,inst_5678);
} else {
if((state_val_5691 === (2))){
var state_5690__$1 = state_5690;
return cljs.core.async.impl.ioc_helpers.take_BANG_.call(null,state_5690__$1,(4),ch);
} else {
if((state_val_5691 === (11))){
var inst_5658 = (state_5690[(10)]);
var inst_5654 = (state_5690[(9)]);
var inst_5668 = (state_5690[(2)]);
var inst_5669 = [];
var inst_5670 = inst_5669.push(inst_5654);
var inst_5650 = inst_5669;
var inst_5651 = inst_5658;
var state_5690__$1 = (function (){var statearr_5702 = state_5690;
(statearr_5702[(7)] = inst_5650);

(statearr_5702[(11)] = inst_5668);

(statearr_5702[(12)] = inst_5670);

(statearr_5702[(8)] = inst_5651);

return statearr_5702;
})();
var statearr_5703_5727 = state_5690__$1;
(statearr_5703_5727[(2)] = null);

(statearr_5703_5727[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (9))){
var inst_5650 = (state_5690[(7)]);
var inst_5666 = cljs.core.vec.call(null,inst_5650);
var state_5690__$1 = state_5690;
return cljs.core.async.impl.ioc_helpers.put_BANG_.call(null,state_5690__$1,(11),out,inst_5666);
} else {
if((state_val_5691 === (5))){
var inst_5658 = (state_5690[(10)]);
var inst_5651 = (state_5690[(8)]);
var inst_5654 = (state_5690[(9)]);
var inst_5658__$1 = f.call(null,inst_5654);
var inst_5659 = cljs.core._EQ_.call(null,inst_5658__$1,inst_5651);
var inst_5660 = cljs.core.keyword_identical_QMARK_.call(null,inst_5651,new cljs.core.Keyword("cljs.core.async","nothing","cljs.core.async/nothing",-69252123));
var inst_5661 = ((inst_5659) || (inst_5660));
var state_5690__$1 = (function (){var statearr_5704 = state_5690;
(statearr_5704[(10)] = inst_5658__$1);

return statearr_5704;
})();
if(cljs.core.truth_(inst_5661)){
var statearr_5705_5728 = state_5690__$1;
(statearr_5705_5728[(1)] = (8));

} else {
var statearr_5706_5729 = state_5690__$1;
(statearr_5706_5729[(1)] = (9));

}

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (14))){
var inst_5683 = (state_5690[(2)]);
var inst_5684 = cljs.core.async.close_BANG_.call(null,out);
var state_5690__$1 = (function (){var statearr_5708 = state_5690;
(statearr_5708[(13)] = inst_5683);

return statearr_5708;
})();
var statearr_5709_5730 = state_5690__$1;
(statearr_5709_5730[(2)] = inst_5684);

(statearr_5709_5730[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (10))){
var inst_5673 = (state_5690[(2)]);
var state_5690__$1 = state_5690;
var statearr_5710_5731 = state_5690__$1;
(statearr_5710_5731[(2)] = inst_5673);

(statearr_5710_5731[(1)] = (7));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
if((state_val_5691 === (8))){
var inst_5650 = (state_5690[(7)]);
var inst_5658 = (state_5690[(10)]);
var inst_5654 = (state_5690[(9)]);
var inst_5663 = inst_5650.push(inst_5654);
var tmp5707 = inst_5650;
var inst_5650__$1 = tmp5707;
var inst_5651 = inst_5658;
var state_5690__$1 = (function (){var statearr_5711 = state_5690;
(statearr_5711[(7)] = inst_5650__$1);

(statearr_5711[(8)] = inst_5651);

(statearr_5711[(14)] = inst_5663);

return statearr_5711;
})();
var statearr_5712_5732 = state_5690__$1;
(statearr_5712_5732[(2)] = null);

(statearr_5712_5732[(1)] = (2));


return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
return null;
}
}
}
}
}
}
}
}
}
}
}
}
}
}
}
});})(c__3814__auto___5718,out))
;
return ((function (switch__3724__auto__,c__3814__auto___5718,out){
return (function() {
var cljs$core$async$state_machine__3725__auto__ = null;
var cljs$core$async$state_machine__3725__auto____0 = (function (){
var statearr_5713 = [null,null,null,null,null,null,null,null,null,null,null,null,null,null,null];
(statearr_5713[(0)] = cljs$core$async$state_machine__3725__auto__);

(statearr_5713[(1)] = (1));

return statearr_5713;
});
var cljs$core$async$state_machine__3725__auto____1 = (function (state_5690){
while(true){
var ret_value__3726__auto__ = (function (){try{while(true){
var result__3727__auto__ = switch__3724__auto__.call(null,state_5690);
if(cljs.core.keyword_identical_QMARK_.call(null,result__3727__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
continue;
} else {
return result__3727__auto__;
}
break;
}
}catch (e5714){if((e5714 instanceof Object)){
var ex__3728__auto__ = e5714;
var statearr_5715_5733 = state_5690;
(statearr_5715_5733[(5)] = ex__3728__auto__);


cljs.core.async.impl.ioc_helpers.process_exception.call(null,state_5690);

return new cljs.core.Keyword(null,"recur","recur",-437573268);
} else {
throw e5714;

}
}})();
if(cljs.core.keyword_identical_QMARK_.call(null,ret_value__3726__auto__,new cljs.core.Keyword(null,"recur","recur",-437573268))){
var G__5734 = state_5690;
state_5690 = G__5734;
continue;
} else {
return ret_value__3726__auto__;
}
break;
}
});
cljs$core$async$state_machine__3725__auto__ = function(state_5690){
switch(arguments.length){
case 0:
return cljs$core$async$state_machine__3725__auto____0.call(this);
case 1:
return cljs$core$async$state_machine__3725__auto____1.call(this,state_5690);
}
throw(new Error('Invalid arity: ' + (arguments.length - 1)));
};
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$0 = cljs$core$async$state_machine__3725__auto____0;
cljs$core$async$state_machine__3725__auto__.cljs$core$IFn$_invoke$arity$1 = cljs$core$async$state_machine__3725__auto____1;
return cljs$core$async$state_machine__3725__auto__;
})()
;})(switch__3724__auto__,c__3814__auto___5718,out))
})();
var state__3816__auto__ = (function (){var statearr_5716 = f__3815__auto__.call(null);
(statearr_5716[(6)] = c__3814__auto___5718);

return statearr_5716;
})();
return cljs.core.async.impl.ioc_helpers.run_state_machine_wrapped.call(null,state__3816__auto__);
});})(c__3814__auto___5718,out))
);


return out;
});

cljs.core.async.partition_by.cljs$lang$maxFixedArity = 3;


//# sourceMappingURL=async.js.map
